
#ifndef TARG_ATTRIBUTESTRINGS_H
#define TARG_ATTRIBUTESTRINGS_H

/**
 *  @file attributestrings.H
 *
 *  @brief Attribute string conversion routines.  This file is autogenerated
 *      and should not be altered.
 */

//******************************************************************************
// Includes
//******************************************************************************

// STD
#include <stdint.h>
#include <stdlib.h>

namespace TARGETING
{

/**
 *  @brief Class used to clarify compiler error when caller attempts to
 *      stringify an unsupported attribute
 */
class InvalidAttributeForStringification;

/**
 *  @brief Return attribute as a string
 *
 *  @param[in] i_attrValue Value of the attribute
 *
 *  @return String which decodes the attribute value
 */
template<const ATTRIBUTE_ID A>
const char* attrToString(
    typename AttributeTraits<A>::Type const& i_attrValue)
{
    // Default behavior is to fail the compile if caller attempts to print an
    // unsupported string
    #ifdef __HOSTBOOT_MODULE
        static_assert(A != A, "Must use an explicitly supported template "
                              "specialization");
    #else
        char mustUseTemplateSpecialization[A != A ? 1 : -1];
    #endif

    const char* retVal = NULL;
    return retVal;
}

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_CDM_DOMAIN>(
    AttributeTraits<ATTR_CDM_DOMAIN>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_CLASS>(
    AttributeTraits<ATTR_CLASS>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_ENGINE_TYPE>(
    AttributeTraits<ATTR_ENGINE_TYPE>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_FSI_MASTER_TYPE>(
    AttributeTraits<ATTR_FSI_MASTER_TYPE>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_KEY_TRANSITION_STATE>(
    AttributeTraits<ATTR_KEY_TRANSITION_STATE>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_MFG_WRAP_TEST_ABUS_LINKS_SET>(
    AttributeTraits<ATTR_MFG_WRAP_TEST_ABUS_LINKS_SET>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_MODEL>(
    AttributeTraits<ATTR_MODEL>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_PAYLOAD_KIND>(
    AttributeTraits<ATTR_PAYLOAD_KIND>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_PROC_COMPATIBILITY_REQ>(
    AttributeTraits<ATTR_PROC_COMPATIBILITY_REQ>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_RISK_LEVEL_ORIGIN>(
    AttributeTraits<ATTR_RISK_LEVEL_ORIGIN>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_TYPE>(
    AttributeTraits<ATTR_TYPE>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_CHIP_VER>(
    AttributeTraits<ATTR_CHIP_VER>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_HW_VER>(
    AttributeTraits<ATTR_HW_VER>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_ROLE>(
    AttributeTraits<ATTR_ROLE>::Type const& i_attrValue);

/**
 *  @brief See attrToString<const ATTRIBUTE_ID A>
 */
template<>
const char* attrToString<ATTR_SW_VER>(
    AttributeTraits<ATTR_SW_VER>::Type const& i_attrValue);


} // End namespace TARGETING

#endif // TARG_ATTRIBUTESTRINGS_H

