
#ifndef TARG_MUTEXATTRIBUTES_H
#define TARG_MUTEXATTRIBUTES_H

/**
 *  @file mutexattributes.H
 *
 *  @brief Array of attributes Ids whose type is hbmutex
 *
 *  This header file contains a single array that lists out all of the hbmutex
 *  attributes. This is used on the MPIPL path to know which attributes we need
 *  to reset.  This file is autogenerated and should not be altered.
 */

//******************************************************************************
// Includes
//******************************************************************************

// STD
#include <stdint.h>

//******************************************************************************
// Array
//******************************************************************************

namespace TARGETING
{

/**
 *  @brief HB Mutex Attribute IDs
 *
 *  Array defining all attribute ids found that are of type hbMutex.
 *  This file is autogenerated and should not be altered.
 */
const struct {uint32_t id; bool isRecursive;} hbMutexAttrIds[] = {
                                  { 0x24bd83c, false },
                                  { 0x1fa93ae, false },
                                  { 0x62c7ef8, false },
                                  { 0x103a4d1, false },
                                  { 0xcec54c0, false },
                                   { 0x529511a, true },
                                  { 0xeaece7d, false },
                                   { 0x99841b6, true },
                                   { 0x07646f7, true },
                                   { 0x29009e8, true },
                                   { 0x3aecc94, true },
                                  { 0x1419735, false },
                                  { 0xe6e329c, false },
                                  { 0x0ec8887, false },
                                  { 0x7329dbe, false },
                                  { 0x10dd067, false },
                                  { 0xde81674, false },
                                  { 0x474550f, false },
};

} // End namespace TARGETING

#endif // TARG_MUTEXATTRIBUTES_H

