#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <errl/errludattribute.H>
#include <errl/errlreasoncodes.H>
#include <targeting/common/targetservice.H>
#include <targeting/common/trace.H>

namespace ERRORLOG
{
using namespace TARGETING;
extern TARG_TD_t g_trac_errl;

void ErrlUserDetailsAttribute::addData(
    uint32_t i_attr)
{
    char *tmpBuffer = NULL;
    uint32_t attrSize = 0;

    switch (i_attr) {
        case (ATTR_SERIAL_NUMBER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SERIAL_NUMBER entry");
            AttributeTraits<ATTR_SERIAL_NUMBER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SERIAL_NUMBER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PART_NUMBER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PART_NUMBER entry");
            AttributeTraits<ATTR_PART_NUMBER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PART_NUMBER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PEC_PCIE_HX_KEYWORD_DATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PEC_PCIE_HX_KEYWORD_DATA entry");
            AttributeTraits<ATTR_PEC_PCIE_HX_KEYWORD_DATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PEC_PCIE_HX_KEYWORD_DATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
#if 0 //@fixme-RTC:152874
        case (ATTR_SBE_IMAGE_MINIMUM_VALID_ECS): { break; }
        case (ATTR_EXTERNAL_VRM_STEPSIZE): { break; }
        case (ATTR_EXTERNAL_VRM_TRANSITION_START_NS): { break; }
        case (ATTR_EXTERNAL_VRM_TRANSITION_RATE_INC_UV_PER_US): { break; }
        case (ATTR_EXTERNAL_VRM_TRANSITION_RATE_DEC_UV_PER_US): { break; }
        case (ATTR_EXTERNAL_VRM_TRANSITION_STABILIZATION_TIME_NS): { break; }
        case (ATTR_SAFE_MODE_NOVDM_UPLIFT_MV): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SAFE_MODE_NOVDM_UPLIFT_MV entry");
            AttributeTraits<ATTR_SAFE_MODE_NOVDM_UPLIFT_MV>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SAFE_MODE_NOVDM_UPLIFT_MV>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SAFE_MODE_VOLTAGE_MV): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SAFE_MODE_VOLTAGE_MV entry");
            AttributeTraits<ATTR_SAFE_MODE_VOLTAGE_MV>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SAFE_MODE_VOLTAGE_MV>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SAFE_MODE_FREQUENCY_MHZ): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SAFE_MODE_FREQUENCY_MHZ entry");
            AttributeTraits<ATTR_SAFE_MODE_FREQUENCY_MHZ>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SAFE_MODE_FREQUENCY_MHZ>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_AVSBUS_FREQUENCY): { break; }
        case (ATTR_VDD_AVSBUS_BUSNUM): { break; }
        case (ATTR_VDN_AVSBUS_BUSNUM): { break; }
        case (ATTR_VCS_AVSBUS_BUSNUM): { break; }
        case (ATTR_VDD_AVSBUS_RAIL): { break; }
        case (ATTR_VDN_AVSBUS_RAIL): { break; }
        case (ATTR_VCS_AVSBUS_RAIL): { break; }
        case (ATTR_VCS_I2C_BUSNUM): { break; }
        case (ATTR_VDD_BOOT_VOLTAGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: VDD_BOOT_VOLTAGE entry");
            AttributeTraits<ATTR_VDD_BOOT_VOLTAGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_VDD_BOOT_VOLTAGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_VDN_BOOT_VOLTAGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: VDN_BOOT_VOLTAGE entry");
            AttributeTraits<ATTR_VDN_BOOT_VOLTAGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_VDN_BOOT_VOLTAGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_VCS_BOOT_VOLTAGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: VCS_BOOT_VOLTAGE entry");
            AttributeTraits<ATTR_VCS_BOOT_VOLTAGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_VCS_BOOT_VOLTAGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SPIPSS_FREQUENCY): { break; }
        case (ATTR_PM_APSS_CHIP_SELECT): { break; }
        case (ATTR_PROC_R_LOADLINE_VDD_UOHM): { break; }
        case (ATTR_PROC_R_DISTLOSS_VDD_UOHM): { break; }
        case (ATTR_PROC_VRM_VOFFSET_VDD_UV): { break; }
        case (ATTR_PROC_R_LOADLINE_VDN_UOHM): { break; }
        case (ATTR_PROC_R_DISTLOSS_VDN_UOHM): { break; }
        case (ATTR_PROC_VRM_VOFFSET_VDN_UV): { break; }
        case (ATTR_PROC_R_LOADLINE_VCS_UOHM): { break; }
        case (ATTR_PROC_R_DISTLOSS_VCS_UOHM): { break; }
        case (ATTR_PROC_VRM_VOFFSET_VCS_UV): { break; }
        case (ATTR_FREQ_BIAS_ULTRATURBO): { break; }
        case (ATTR_FREQ_BIAS_TURBO): { break; }
        case (ATTR_FREQ_BIAS_NOMINAL): { break; }
        case (ATTR_FREQ_BIAS_POWERSAVE): { break; }
        case (ATTR_VOLTAGE_EXT_VDD_BIAS_ULTRATURBO): { break; }
        case (ATTR_VOLTAGE_EXT_VDD_BIAS_TURBO): { break; }
        case (ATTR_VOLTAGE_EXT_VDD_BIAS_NOMINAL): { break; }
        case (ATTR_VOLTAGE_EXT_VDD_BIAS_POWERSAVE): { break; }
        case (ATTR_VOLTAGE_EXT_VCS_BIAS): { break; }
        case (ATTR_VOLTAGE_EXT_VDN_BIAS): { break; }
        case (ATTR_VOLTAGE_INT_VDD_BIAS_ULTRATURBO): { break; }
        case (ATTR_VOLTAGE_INT_VDD_BIAS_TURBO): { break; }
        case (ATTR_VOLTAGE_INT_VDD_BIAS_NOMINAL): { break; }
        case (ATTR_VOLTAGE_INT_VDD_BIAS_POWERSAVE): { break; }
        case (ATTR_STOP4_DISABLE): { break; }
        case (ATTR_STOP8_DISABLE): { break; }
        case (ATTR_STOP11_DISABLE): { break; }
        case (ATTR_SYSTEM_CORE_PERIODIC_QUIESCE_DISABLE): { break; }
        case (ATTR_SYSTEM_POUNDV_VALIDITY_HALT_DISABLE): { break; }
        case (ATTR_SYSTEM_WOF_DISABLE): { break; }
        case (ATTR_SYSTEM_WOV_UNDERV_DISABLE): { break; }
        case (ATTR_WOV_UNDERV_FORCE): { break; }
        case (ATTR_SYSTEM_WOV_OVERV_DISABLE): { break; }
        case (ATTR_SYSTEM_IVRM_DISABLE): { break; }
        case (ATTR_WOF_ENABLE_FRATIO): { break; }
        case (ATTR_WOF_ENABLE_VRATIO): { break; }
        case (ATTR_WOF_VRATIO_SELECT): { break; }
        case (ATTR_WOV_SAMPLE_125US): { break; }
        case (ATTR_WOV_MAX_DROOP_10THPCT): { break; }
        case (ATTR_WOV_UNDERV_VMIN_MV): { break; }
        case (ATTR_WOV_UNDERV_LIMIT_ALGORITHM): { break; }
        case (ATTR_WOV_UNDERV_LIMIT_MV): { break; }
        case (ATTR_WOV_UNDERV_LIMIT_10THPCT): { break; }
        case (ATTR_WOV_OVERV_VMAX_SETPOINT_MV): { break; }
        case (ATTR_WOV_UNDERV_STEP_INCR_10THPCT): { break; }
        case (ATTR_WOV_UNDERV_STEP_DECR_10THPCT): { break; }
        case (ATTR_WOV_UNDERV_MAX_10THPCT): { break; }
        case (ATTR_WOV_UNDERV_PERF_LOSS_THRESH_10THPCT): { break; }
        case (ATTR_WOV_OVERV_STEP_INCR_10THPCT): { break; }
        case (ATTR_WOV_OVERV_STEP_DECR_10THPCT): { break; }
        case (ATTR_WOV_OVERV_MAX_10THPCT): { break; }
        case (ATTR_PBAX_GROUPID): { break; }
        case (ATTR_PBAX_CHIPID): { break; }
        case (ATTR_PBAX_BRDCST_ID_VECTOR): { break; }
        case (ATTR_POUNDV_BUCKET_NUM_OVERRIDE): { break; }
        case (ATTR_POUNDV_BUCKET_NUM): { break; }
        case (ATTR_DUMP_STOP_INFO_SUPPRESS_ERROR_TRACE): { break; }
        case (ATTR_DUMP_STOP_INFO_ENABLE_ERRORLOG): { break; }
        case (ATTR_SYSTEM_VDM_DISABLE): { break; }
        case (ATTR_VDM_DROOP_SMALL_OVERRIDE): { break; }
        case (ATTR_VDM_DROOP_LARGE_OVERRIDE): { break; }
        case (ATTR_VDM_DROOP_EXTREME_OVERRIDE): { break; }
        case (ATTR_VDM_OVERVOLT_OVERRIDE): { break; }
        case (ATTR_VDM_SMALL_FREQ_DROP_N_S_OVERRIDE): { break; }
        case (ATTR_VDM_LARGE_FREQ_DROP_N_L_OVERRIDE): { break; }
        case (ATTR_VDM_FREQ_RETURN_L_S_OVERRIDE): { break; }
        case (ATTR_VDM_FREQ_RETURN_S_N_OVERRIDE): { break; }
        case (ATTR_VDM_EXTREME_THOTTLE_ENABLE): { break; }
        case (ATTR_VDM_FMAX_OVERRIDE_KHZ): { break; }
        case (ATTR_VDM_FMIN_OVERRIDE_KHZ): { break; }
        case (ATTR_VDM_VID_COMPARE_OVERRIDE_MV): { break; }
        case (ATTR_VDM_VID_COMPARE_BIAS_0P5PCT): { break; }
        case (ATTR_DPLL_VDM_RESPONSE): { break; }
        case (ATTR_IVRM_DEADZONE_MV): { break; }
        case (ATTR_IVRM_STRENGTH_LOOKUP): { break; }
        case (ATTR_IVRM_VIN_MULTIPLIER): { break; }
        case (ATTR_IVRM_VIN_MAX_MV): { break; }
        case (ATTR_IVRM_STEP_DELAY_NS): { break; }
        case (ATTR_IVRM_STABILIZATION_DELAY_NS): { break; }
        case (ATTR_TDP_RDP_CURRENT_FACTOR): { break; }
        case (ATTR_SYSTEM_RESCLK_DISABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SYSTEM_RESCLK_DISABLE entry");
            AttributeTraits<ATTR_SYSTEM_RESCLK_DISABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SYSTEM_RESCLK_DISABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SYSTEM_RESCLK_STEP_DELAY): { break; }
        case (ATTR_SYSTEM_RESCLK_FREQ_REGIONS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SYSTEM_RESCLK_FREQ_REGIONS entry");
            AttributeTraits<ATTR_SYSTEM_RESCLK_FREQ_REGIONS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SYSTEM_RESCLK_FREQ_REGIONS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SYSTEM_RESCLK_FREQ_REGION_INDEX): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SYSTEM_RESCLK_FREQ_REGION_INDEX entry");
            AttributeTraits<ATTR_SYSTEM_RESCLK_FREQ_REGION_INDEX>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SYSTEM_RESCLK_FREQ_REGION_INDEX>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SYSTEM_RESCLK_VALUE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SYSTEM_RESCLK_VALUE entry");
            AttributeTraits<ATTR_SYSTEM_RESCLK_VALUE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SYSTEM_RESCLK_VALUE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SYSTEM_RESCLK_L3_VALUE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SYSTEM_RESCLK_L3_VALUE entry");
            AttributeTraits<ATTR_SYSTEM_RESCLK_L3_VALUE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SYSTEM_RESCLK_L3_VALUE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SYSTEM_RESCLK_L3_VOLTAGE_THRESHOLD_MV): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SYSTEM_RESCLK_L3_VOLTAGE_THRESHOLD_MV entry");
            AttributeTraits<ATTR_SYSTEM_RESCLK_L3_VOLTAGE_THRESHOLD_MV>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SYSTEM_RESCLK_L3_VOLTAGE_THRESHOLD_MV>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SYSTEM_RING_DBG_MODE): { break; }
        case (ATTR_PERF_24x7_INVOCATION_TIME_MS): { break; }
        case (ATTR_CME_INSTRUCTION_TRACE_ENABLE): { break; }
        case (ATTR_CME_CHTM_TRACE_ENABLE): { break; }
        case (ATTR_CME_CHTM_TRACE_MEMORY_CONFIG): { break; }
        case (ATTR_PGPE_HCODE_FUNCTION_ENABLE): { break; }
        case (ATTR_POUND_W_STATIC_DATA_ENABLE): { break; }
        case (ATTR_AUX_FUNC_INVOCATION_TIME_MS): { break; }
        case (ATTR_SYS_VFRT_STATIC_DATA_ENABLE): { break; }
        case (ATTR_NEST_LEAKAGE_PERCENT): { break; }
        case (ATTR_SYSTEM_PSTATES_MODE): { break; }
        case (ATTR_CORE_THROTTLE_ASSERT_COUNT): { break; }
        case (ATTR_CORE_THROTTLE_DEASSERT_COUNT): { break; }
        case (ATTR_PM_GLOBAL_FIR_TRACE_EN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PM_GLOBAL_FIR_TRACE_EN entry");
            AttributeTraits<ATTR_PM_GLOBAL_FIR_TRACE_EN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PM_GLOBAL_FIR_TRACE_EN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FREQ_PB_MHZ_POUNDV_FALLBACK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FREQ_PB_MHZ_POUNDV_FALLBACK entry");
            AttributeTraits<ATTR_FREQ_PB_MHZ_POUNDV_FALLBACK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FREQ_PB_MHZ_POUNDV_FALLBACK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SKIP_WAKEUP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SKIP_WAKEUP entry");
            AttributeTraits<ATTR_SKIP_WAKEUP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SKIP_WAKEUP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PM_MALF_ALERT_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PM_MALF_ALERT_ENABLE entry");
            AttributeTraits<ATTR_PM_MALF_ALERT_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PM_MALF_ALERT_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PM_RESET_FFDC_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PM_RESET_FFDC_ENABLE entry");
            AttributeTraits<ATTR_PM_RESET_FFDC_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PM_RESET_FFDC_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NEST_24x7_PERF_ACCUM_ENABLE): { break; }
        case (ATTR_UNSECURE_HOMER_ADDRESS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: UNSECURE_HOMER_ADDRESS entry");
            AttributeTraits<ATTR_UNSECURE_HOMER_ADDRESS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_UNSECURE_HOMER_ADDRESS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_UNSECURE_HOMER_SIZE): { break; }
        case (ATTR_PMCR_MOST_RECENT_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PMCR_MOST_RECENT_MODE entry");
            AttributeTraits<ATTR_PMCR_MOST_RECENT_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PMCR_MOST_RECENT_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ENABLED_OBUS_BRICKS): { break; }
        case (ATTR_IO_XBUS_DCCAL_FLAGS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IO_XBUS_DCCAL_FLAGS entry");
            AttributeTraits<ATTR_IO_XBUS_DCCAL_FLAGS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IO_XBUS_DCCAL_FLAGS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_X_DEBUG): { break; }
        case (ATTR_IO_X_MFG_CHK): { break; }
        case (ATTR_IO_X_MFG_MIN_EYE_WIDTH): { break; }
        case (ATTR_IO_XBUS_MASTER_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IO_XBUS_MASTER_MODE entry");
            AttributeTraits<ATTR_IO_XBUS_MASTER_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IO_XBUS_MASTER_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_XBUS_TX_MARGIN_RATIO): { break; }
        case (ATTR_IO_XBUS_TX_FFE_PRECURSOR): { break; }
        case (ATTR_IO_XBUS_CHAN_EQ): { break; }
        case (ATTR_IO_XBUS_GRP0_PRE_BAD_LANE_DATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IO_XBUS_GRP0_PRE_BAD_LANE_DATA entry");
            AttributeTraits<ATTR_IO_XBUS_GRP0_PRE_BAD_LANE_DATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IO_XBUS_GRP0_PRE_BAD_LANE_DATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_XBUS_GRP1_PRE_BAD_LANE_DATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IO_XBUS_GRP1_PRE_BAD_LANE_DATA entry");
            AttributeTraits<ATTR_IO_XBUS_GRP1_PRE_BAD_LANE_DATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IO_XBUS_GRP1_PRE_BAD_LANE_DATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_DO_MSS_WR_VREF): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: DO_MSS_WR_VREF entry");
            AttributeTraits<ATTR_DO_MSS_WR_VREF>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_DO_MSS_WR_VREF>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SKIP_HW_VREF_CAL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SKIP_HW_VREF_CAL entry");
            AttributeTraits<ATTR_SKIP_HW_VREF_CAL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SKIP_HW_VREF_CAL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SKIP_RD_VREF_VREFSENSE_OVERRIDE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SKIP_RD_VREF_VREFSENSE_OVERRIDE entry");
            AttributeTraits<ATTR_SKIP_RD_VREF_VREFSENSE_OVERRIDE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SKIP_RD_VREF_VREFSENSE_OVERRIDE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_DO_MSS_VREF_DAC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: DO_MSS_VREF_DAC entry");
            AttributeTraits<ATTR_DO_MSS_VREF_DAC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_DO_MSS_VREF_DAC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_DO_MSS_TRAINING_BAD_BITS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: DO_MSS_TRAINING_BAD_BITS entry");
            AttributeTraits<ATTR_DO_MSS_TRAINING_BAD_BITS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_DO_MSS_TRAINING_BAD_BITS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_RUN_DCD_CALIBRATION): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_RUN_DCD_CALIBRATION entry");
            AttributeTraits<ATTR_MSS_RUN_DCD_CALIBRATION>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_RUN_DCD_CALIBRATION>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_MRW_UNSUPPORTED_RANK_CONFIG): { break; }
        case (ATTR_OMI_DL_GROUP_POS): { break; }
        case (ATTR_OMI_DL_NUM): { break; }
        case (ATTR_PROC_DSTLCFG_MMIO_ADDRBIT_POS): { break; }
        case (ATTR_PROC_ENABLE_DL_TMPL_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_ENABLE_DL_TMPL_1 entry");
            AttributeTraits<ATTR_PROC_ENABLE_DL_TMPL_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_ENABLE_DL_TMPL_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_ENABLE_DL_TMPL_4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_ENABLE_DL_TMPL_4 entry");
            AttributeTraits<ATTR_PROC_ENABLE_DL_TMPL_4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_ENABLE_DL_TMPL_4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_ENABLE_DL_TMPL_7): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_ENABLE_DL_TMPL_7 entry");
            AttributeTraits<ATTR_PROC_ENABLE_DL_TMPL_7>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_ENABLE_DL_TMPL_7>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_ENABLE_DL_TMPL_A): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_ENABLE_DL_TMPL_A entry");
            AttributeTraits<ATTR_PROC_ENABLE_DL_TMPL_A>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_ENABLE_DL_TMPL_A>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_TMPL_0_PACING): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_TMPL_0_PACING entry");
            AttributeTraits<ATTR_PROC_TMPL_0_PACING>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_TMPL_0_PACING>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_TMPL_1_PACING): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_TMPL_1_PACING entry");
            AttributeTraits<ATTR_PROC_TMPL_1_PACING>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_TMPL_1_PACING>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_TMPL_4_PACING): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_TMPL_4_PACING entry");
            AttributeTraits<ATTR_PROC_TMPL_4_PACING>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_TMPL_4_PACING>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_TMPL_7_PACING): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_TMPL_7_PACING entry");
            AttributeTraits<ATTR_PROC_TMPL_7_PACING>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_TMPL_7_PACING>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_TMPL_A_PACING): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_TMPL_A_PACING entry");
            AttributeTraits<ATTR_PROC_TMPL_A_PACING>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_TMPL_A_PACING>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_OMI_OC_MAJOR_VER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_OMI_OC_MAJOR_VER entry");
            AttributeTraits<ATTR_PROC_OMI_OC_MAJOR_VER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_OMI_OC_MAJOR_VER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_OMI_OC_MINOR_VER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_OMI_OC_MINOR_VER entry");
            AttributeTraits<ATTR_PROC_OMI_OC_MINOR_VER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_OMI_OC_MINOR_VER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_GEN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_GEN entry");
            AttributeTraits<ATTR_EFF_DRAM_GEN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_GEN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_TYPE entry");
            AttributeTraits<ATTR_EFF_DIMM_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_HYBRID_MEMORY_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_HYBRID_MEMORY_TYPE entry");
            AttributeTraits<ATTR_EFF_HYBRID_MEMORY_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_HYBRID_MEMORY_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_HYBRID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_HYBRID entry");
            AttributeTraits<ATTR_EFF_HYBRID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_HYBRID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_DENSITY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_DENSITY entry");
            AttributeTraits<ATTR_EFF_DRAM_DENSITY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_DENSITY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_BANK_BITS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_BANK_BITS entry");
            AttributeTraits<ATTR_EFF_DRAM_BANK_BITS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_BANK_BITS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_BANK_GROUP_BITS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_BANK_GROUP_BITS entry");
            AttributeTraits<ATTR_EFF_DRAM_BANK_GROUP_BITS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_BANK_GROUP_BITS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_COLUMN_BITS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_COLUMN_BITS entry");
            AttributeTraits<ATTR_EFF_DRAM_COLUMN_BITS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_COLUMN_BITS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_ROW_BITS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_ROW_BITS entry");
            AttributeTraits<ATTR_EFF_DRAM_ROW_BITS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_ROW_BITS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_PRIM_STACK_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_PRIM_STACK_TYPE entry");
            AttributeTraits<ATTR_EFF_PRIM_STACK_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_PRIM_STACK_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_PPR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_PPR entry");
            AttributeTraits<ATTR_EFF_DRAM_PPR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_PPR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_SOFT_PPR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_SOFT_PPR entry");
            AttributeTraits<ATTR_EFF_DRAM_SOFT_PPR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_SOFT_PPR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TRCD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TRCD entry");
            AttributeTraits<ATTR_EFF_DRAM_TRCD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TRCD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TRP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TRP entry");
            AttributeTraits<ATTR_EFF_DRAM_TRP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TRP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TRAS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TRAS entry");
            AttributeTraits<ATTR_EFF_DRAM_TRAS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TRAS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TRC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TRC entry");
            AttributeTraits<ATTR_EFF_DRAM_TRC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TRC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TRFC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TRFC entry");
            AttributeTraits<ATTR_EFF_DRAM_TRFC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TRFC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TFAW): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TFAW entry");
            AttributeTraits<ATTR_EFF_DRAM_TFAW>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TFAW>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TRRD_S): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TRRD_S entry");
            AttributeTraits<ATTR_EFF_DRAM_TRRD_S>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TRRD_S>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TRRD_L): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TRRD_L entry");
            AttributeTraits<ATTR_EFF_DRAM_TRRD_L>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TRRD_L>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TCCD_L): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TCCD_L entry");
            AttributeTraits<ATTR_EFF_DRAM_TCCD_L>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TCCD_L>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TWR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TWR entry");
            AttributeTraits<ATTR_EFF_DRAM_TWR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TWR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TWTR_S): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TWTR_S entry");
            AttributeTraits<ATTR_EFF_DRAM_TWTR_S>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TWTR_S>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TWTR_L): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TWTR_L entry");
            AttributeTraits<ATTR_EFF_DRAM_TWTR_L>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TWTR_L>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TMAW): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TMAW entry");
            AttributeTraits<ATTR_EFF_DRAM_TMAW>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TMAW>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_WIDTH): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_WIDTH entry");
            AttributeTraits<ATTR_EFF_DRAM_WIDTH>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_WIDTH>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_RANK_MIX): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_RANK_MIX entry");
            AttributeTraits<ATTR_EFF_DRAM_RANK_MIX>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_RANK_MIX>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_NUM_RANKS_PER_DIMM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_NUM_RANKS_PER_DIMM entry");
            AttributeTraits<ATTR_EFF_NUM_RANKS_PER_DIMM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_NUM_RANKS_PER_DIMM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_REGISTER_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_REGISTER_TYPE entry");
            AttributeTraits<ATTR_EFF_REGISTER_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_REGISTER_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_MFG_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_MFG_ID entry");
            AttributeTraits<ATTR_EFF_DRAM_MFG_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_MFG_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_RCD_MFG_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_RCD_MFG_ID entry");
            AttributeTraits<ATTR_EFF_RCD_MFG_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_RCD_MFG_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_REGISTER_REV): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_REGISTER_REV entry");
            AttributeTraits<ATTR_EFF_REGISTER_REV>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_REGISTER_REV>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_PACKAGE_RANK_MAP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_PACKAGE_RANK_MAP entry");
            AttributeTraits<ATTR_EFF_PACKAGE_RANK_MAP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_PACKAGE_RANK_MAP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_NIBBLE_MAP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_NIBBLE_MAP entry");
            AttributeTraits<ATTR_EFF_NIBBLE_MAP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_NIBBLE_MAP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ROW_REPAIR_SUPPORTED_MRW): { break; }
        case (ATTR_EI_BUS_TX_MSBSWAP): { break; }
        case (ATTR_VPD_OVERRIDE_MT): { break; }
        case (ATTR_VPD_OVERRIDE_MT_ENABLE): { break; }
        case (ATTR_VPD_OVERRIDE_MR): { break; }
        case (ATTR_VPD_OVERRIDE_MR_ENABLE): { break; }
        case (ATTR_VPD_OVERRIDE_DQ): { break; }
        case (ATTR_VPD_OVERRIDE_DQ_ENABLE): { break; }
        case (ATTR_VPD_OVERRIDE_CK): { break; }
        case (ATTR_VPD_OVERRIDE_CK_ENABLE): { break; }
        case (ATTR_VPD_OVERRIDE_MW): { break; }
        case (ATTR_VPD_OVERRIDE_MW_ENABLE): { break; }
        case (ATTR_MSS_OVERRIDE_MEMDIAGS_BCMODE): { break; }
        case (ATTR_PROC_NPU_REGION_ENABLED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_NPU_REGION_ENABLED entry");
            AttributeTraits<ATTR_PROC_NPU_REGION_ENABLED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_NPU_REGION_ENABLED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CLOCK_PLL_MUX_TOD): { break; }
        case (ATTR_CLOCK_PLL_MUX): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CLOCK_PLL_MUX entry");
            AttributeTraits<ATTR_CLOCK_PLL_MUX>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CLOCK_PLL_MUX>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CLOCK_PLL_MUX0): { break; }
        case (ATTR_I2C_BUS_DIV_REF): { break; }
        case (ATTR_EQ_GARD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EQ_GARD entry");
            AttributeTraits<ATTR_EQ_GARD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EQ_GARD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EC_GARD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EC_GARD entry");
            AttributeTraits<ATTR_EC_GARD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EC_GARD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SBE_RUNTIME_MODE): { break; }
        case (ATTR_IS_SP_MODE): { break; }
        case (ATTR_SBE_FFDC_ENABLE): { break; }
        case (ATTR_SBE_INTERNAL_FFDC_ENABLE): { break; }
        case (ATTR_NEST_PLL_BUCKET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NEST_PLL_BUCKET entry");
            AttributeTraits<ATTR_NEST_PLL_BUCKET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NEST_PLL_BUCKET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FILTER_PLL_BUCKET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FILTER_PLL_BUCKET entry");
            AttributeTraits<ATTR_FILTER_PLL_BUCKET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FILTER_PLL_BUCKET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MRW_FILTER_PLL_BUCKET): { break; }
        case (ATTR_FORCE_SYNC_SS_PLL_SPREAD): { break; }
        case (ATTR_BOOT_FREQ_MULT): { break; }
        case (ATTR_RISK_LEVEL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: RISK_LEVEL entry");
            AttributeTraits<ATTR_RISK_LEVEL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_RISK_LEVEL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_DISABLE_HBBL_VECTORS): { break; }
        case (ATTR_BACKUP_SEEPROM_SELECT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: BACKUP_SEEPROM_SELECT entry");
            AttributeTraits<ATTR_BACKUP_SEEPROM_SELECT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_BACKUP_SEEPROM_SELECT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_BOOT_FLAGS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: BOOT_FLAGS entry");
            AttributeTraits<ATTR_BOOT_FLAGS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_BOOT_FLAGS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_BOOT_FREQ_MHZ): { break; }
        case (ATTR_BRANCH_PIBMEM_ADDR): { break; }
        case (ATTR_CHIP_REGIONS_TO_ENABLE): { break; }
        case (ATTR_DEVICE_ID): { break; }
        case (ATTR_ECID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ECID entry");
            AttributeTraits<ATTR_ECID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ECID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_I2C_BUS_DIV_NEST): { break; }
        case (ATTR_LEN_OF_SEEPROM_DATA): { break; }
        case (ATTR_MB_BIT_RATE_DIVISOR_PLL): { break; }
        case (ATTR_MB_BIT_RATE_DIVISOR_REFCLK): { break; }
        case (ATTR_MC_SYNC_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MC_SYNC_MODE entry");
            AttributeTraits<ATTR_MC_SYNC_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MC_SYNC_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_PB_BNDY_DMIPLL_DATA): { break; }
        case (ATTR_PROC_PB_BNDY_DMIPLL_FOR_DCCAL_DATA): { break; }
        case (ATTR_PROC_PERV_BNDY_PLL_DATA): { break; }
        case (ATTR_PROC_SBE_MASTER_CHIP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_SBE_MASTER_CHIP entry");
            AttributeTraits<ATTR_PROC_SBE_MASTER_CHIP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_SBE_MASTER_CHIP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SBE_SEEPROM_I2C_DEVICE_ADDRESS): { break; }
        case (ATTR_SBE_SEEPROM_I2C_PORT): { break; }
        case (ATTR_START_PIBMEM_ADDR): { break; }
        case (ATTR_START_SEEPROM_ADDR): { break; }
        case (ATTR_WAIT_N0): { break; }
        case (ATTR_WAIT_N1): { break; }
        case (ATTR_WAIT_N2): { break; }
        case (ATTR_WAIT_N3): { break; }
        case (ATTR_SYS_FORCE_ALL_CORES): { break; }
        case (ATTR_MASTER_CORE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MASTER_CORE entry");
            AttributeTraits<ATTR_MASTER_CORE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MASTER_CORE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MASTER_EX): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MASTER_EX entry");
            AttributeTraits<ATTR_MASTER_EX>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MASTER_EX>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SECURITY_ENABLE): { break; }
        case (ATTR_PFET_OFF_CONTROLS): { break; }
        case (ATTR_OBUS_RATIO_VALUE): { break; }
        case (ATTR_PIBMEM_REPAIR0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PIBMEM_REPAIR0 entry");
            AttributeTraits<ATTR_PIBMEM_REPAIR0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PIBMEM_REPAIR0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PIBMEM_REPAIR1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PIBMEM_REPAIR1 entry");
            AttributeTraits<ATTR_PIBMEM_REPAIR1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PIBMEM_REPAIR1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PIBMEM_REPAIR2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PIBMEM_REPAIR2 entry");
            AttributeTraits<ATTR_PIBMEM_REPAIR2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PIBMEM_REPAIR2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SENSEADJ_STEP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SENSEADJ_STEP entry");
            AttributeTraits<ATTR_SENSEADJ_STEP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SENSEADJ_STEP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CP_FILTER_BYPASS): { break; }
        case (ATTR_SS_FILTER_BYPASS): { break; }
        case (ATTR_IO_FILTER_BYPASS): { break; }
        case (ATTR_DPLL_BYPASS): { break; }
        case (ATTR_NEST_MEM_X_O_PCI_BYPASS): { break; }
        case (ATTR_TARGET_HAS_POWER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: TARGET_HAS_POWER entry");
            AttributeTraits<ATTR_TARGET_HAS_POWER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_TARGET_HAS_POWER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_TARGET_HAS_CLOCK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: TARGET_HAS_CLOCK entry");
            AttributeTraits<ATTR_TARGET_HAS_CLOCK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_TARGET_HAS_CLOCK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_TARGET_IS_SCOMMABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: TARGET_IS_SCOMMABLE entry");
            AttributeTraits<ATTR_TARGET_IS_SCOMMABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_TARGET_IS_SCOMMABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SBE_SYS_CONFIG): { break; }
        case (ATTR_CP_REFCLOCK_RCVR_TERM): { break; }
        case (ATTR_IO_REFCLOCK_RCVR_TERM): { break; }
        case (ATTR_SECTOR_BUFFER_STRENGTH): { break; }
        case (ATTR_PULSE_MODE_ENABLE): { break; }
        case (ATTR_PULSE_MODE_VALUE): { break; }
        case (ATTR_NDL_MESHCTRL_SETUP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NDL_MESHCTRL_SETUP entry");
            AttributeTraits<ATTR_NDL_MESHCTRL_SETUP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NDL_MESHCTRL_SETUP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_START_CBS_FIFO_RESET_SKIP): { break; }
        case (ATTR_SYSTEM_CORECACHE_SKEWADJ_DISABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SYSTEM_CORECACHE_SKEWADJ_DISABLE entry");
            AttributeTraits<ATTR_SYSTEM_CORECACHE_SKEWADJ_DISABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SYSTEM_CORECACHE_SKEWADJ_DISABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SYSTEM_CORECACHE_DCADJ_DISABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SYSTEM_CORECACHE_DCADJ_DISABLE entry");
            AttributeTraits<ATTR_SYSTEM_CORECACHE_DCADJ_DISABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SYSTEM_CORECACHE_DCADJ_DISABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_MEM_TO_USE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_MEM_TO_USE entry");
            AttributeTraits<ATTR_PROC_MEM_TO_USE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_MEM_TO_USE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ORIG_FIR_SETTINGS_ACTION0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ORIG_FIR_SETTINGS_ACTION0 entry");
            AttributeTraits<ATTR_ORIG_FIR_SETTINGS_ACTION0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ORIG_FIR_SETTINGS_ACTION0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ORIG_FIR_SETTINGS_ACTION1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ORIG_FIR_SETTINGS_ACTION1 entry");
            AttributeTraits<ATTR_ORIG_FIR_SETTINGS_ACTION1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ORIG_FIR_SETTINGS_ACTION1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_LPC_CONSOLE_CNFG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: LPC_CONSOLE_CNFG entry");
            AttributeTraits<ATTR_LPC_CONSOLE_CNFG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_LPC_CONSOLE_CNFG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_X_EREPAIR_THRESHOLD_FIELD): { break; }
        case (ATTR_X_EREPAIR_THRESHOLD_MNFG): { break; }
        case (ATTR_O_EREPAIR_THRESHOLD_FIELD): { break; }
        case (ATTR_O_EREPAIR_THRESHOLD_MNFG): { break; }
        case (ATTR_DMI_EREPAIR_THRESHOLD_FIELD): { break; }
        case (ATTR_DMI_EREPAIR_THRESHOLD_MNFG): { break; }
        case (ATTR_MSS_VPD_CKE_MAP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_CKE_MAP entry");
            AttributeTraits<ATTR_MSS_VPD_CKE_MAP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_CKE_MAP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_OBUS_DCCAL_FLAGS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IO_OBUS_DCCAL_FLAGS entry");
            AttributeTraits<ATTR_IO_OBUS_DCCAL_FLAGS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IO_OBUS_DCCAL_FLAGS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_OBUS_PAT_A_DETECT_RUN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IO_OBUS_PAT_A_DETECT_RUN entry");
            AttributeTraits<ATTR_IO_OBUS_PAT_A_DETECT_RUN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IO_OBUS_PAT_A_DETECT_RUN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_OBUS_PAT_A_DETECT_RX_AMP_VALUE): { break; }
        case (ATTR_IO_OBUS_PAT_A_CAPTURE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IO_OBUS_PAT_A_CAPTURE entry");
            AttributeTraits<ATTR_IO_OBUS_PAT_A_CAPTURE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IO_OBUS_PAT_A_CAPTURE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_OBUS_TRAIN_FOR_RECOVERY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IO_OBUS_TRAIN_FOR_RECOVERY entry");
            AttributeTraits<ATTR_IO_OBUS_TRAIN_FOR_RECOVERY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IO_OBUS_TRAIN_FOR_RECOVERY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_OBUS_LANE_PDWN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IO_OBUS_LANE_PDWN entry");
            AttributeTraits<ATTR_IO_OBUS_LANE_PDWN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IO_OBUS_LANE_PDWN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_O_DEBUG): { break; }
        case (ATTR_IO_O_MFG_CHK): { break; }
        case (ATTR_IO_O_MFG_MIN_EYE_WIDTH): { break; }
        case (ATTR_IO_OBUS_TX_MARGIN_RATIO): { break; }
        case (ATTR_IO_OBUS_TX_FFE_PRECURSOR): { break; }
        case (ATTR_IO_OBUS_TX_FFE_POSTCURSOR): { break; }
        case (ATTR_IO_OLLFIR_MASK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IO_OLLFIR_MASK entry");
            AttributeTraits<ATTR_IO_OLLFIR_MASK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IO_OLLFIR_MASK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_PB_IOOFIR_MASK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IO_PB_IOOFIR_MASK entry");
            AttributeTraits<ATTR_IO_PB_IOOFIR_MASK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IO_PB_IOOFIR_MASK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_O_CHANNEL_TYPE): { break; }
        case (ATTR_IO_O_MFG_STRESS_PR_OFFSET_EVEN): { break; }
        case (ATTR_IO_O_MFG_STRESS_PR_OFFSET_ODD): { break; }
        case (ATTR_IO_O_MNFG_ERROR_THRESHOLD): { break; }
        case (ATTR_MSS_VPD_MT_0_VERSION_LAYOUT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_0_VERSION_LAYOUT entry");
            AttributeTraits<ATTR_MSS_VPD_MT_0_VERSION_LAYOUT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_0_VERSION_LAYOUT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_1_VERSION_DATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_1_VERSION_DATA entry");
            AttributeTraits<ATTR_MSS_VPD_MT_1_VERSION_DATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_1_VERSION_DATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_2_SIGNATURE_HASH): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_2_SIGNATURE_HASH entry");
            AttributeTraits<ATTR_MSS_VPD_MT_2_SIGNATURE_HASH>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_2_SIGNATURE_HASH>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_DIMM_RCD_IBT_CA entry");
            AttributeTraits<ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CKE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_DIMM_RCD_IBT_CKE entry");
            AttributeTraits<ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CKE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CKE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_DIMM_RCD_IBT_CS entry");
            AttributeTraits<ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_DIMM_RCD_IBT_ODT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_DIMM_RCD_IBT_ODT entry");
            AttributeTraits<ATTR_MSS_VPD_MT_DIMM_RCD_IBT_ODT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_DIMM_RCD_IBT_ODT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_DRAM_DRV_IMP_DQ_DQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_DRAM_DRV_IMP_DQ_DQS entry");
            AttributeTraits<ATTR_MSS_VPD_MT_DRAM_DRV_IMP_DQ_DQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_DRAM_DRV_IMP_DQ_DQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_DRAM_RTT_NOM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_DRAM_RTT_NOM entry");
            AttributeTraits<ATTR_MSS_VPD_MT_DRAM_RTT_NOM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_DRAM_RTT_NOM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_DRAM_RTT_PARK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_DRAM_RTT_PARK entry");
            AttributeTraits<ATTR_MSS_VPD_MT_DRAM_RTT_PARK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_DRAM_RTT_PARK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_DRAM_RTT_WR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_DRAM_RTT_WR entry");
            AttributeTraits<ATTR_MSS_VPD_MT_DRAM_RTT_WR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_DRAM_RTT_WR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_MC_BIAS_TRIM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_MC_BIAS_TRIM entry");
            AttributeTraits<ATTR_MSS_VPD_MT_MC_BIAS_TRIM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_MC_BIAS_TRIM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_RD_UP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_MC_DQ_ACBOOST_RD_UP entry");
            AttributeTraits<ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_RD_UP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_RD_UP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_WR_DOWN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_MC_DQ_ACBOOST_WR_DOWN entry");
            AttributeTraits<ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_WR_DOWN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_WR_DOWN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_WR_UP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_MC_DQ_ACBOOST_WR_UP entry");
            AttributeTraits<ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_WR_UP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_WR_UP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_MC_DQ_CTLE_CAP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_MC_DQ_CTLE_CAP entry");
            AttributeTraits<ATTR_MSS_VPD_MT_MC_DQ_CTLE_CAP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_MC_DQ_CTLE_CAP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_MC_DQ_CTLE_RES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_MC_DQ_CTLE_RES entry");
            AttributeTraits<ATTR_MSS_VPD_MT_MC_DQ_CTLE_RES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_MC_DQ_CTLE_RES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_MC_DRV_IMP_CLK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_MC_DRV_IMP_CLK entry");
            AttributeTraits<ATTR_MSS_VPD_MT_MC_DRV_IMP_CLK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_MC_DRV_IMP_CLK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_MC_DRV_IMP_CMD_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_MC_DRV_IMP_CMD_ADDR entry");
            AttributeTraits<ATTR_MSS_VPD_MT_MC_DRV_IMP_CMD_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_MC_DRV_IMP_CMD_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_MC_DRV_IMP_CNTL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_MC_DRV_IMP_CNTL entry");
            AttributeTraits<ATTR_MSS_VPD_MT_MC_DRV_IMP_CNTL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_MC_DRV_IMP_CNTL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_MC_DRV_IMP_CSCID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_MC_DRV_IMP_CSCID entry");
            AttributeTraits<ATTR_MSS_VPD_MT_MC_DRV_IMP_CSCID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_MC_DRV_IMP_CSCID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_MC_DRV_IMP_DQ_DQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_MC_DRV_IMP_DQ_DQS entry");
            AttributeTraits<ATTR_MSS_VPD_MT_MC_DRV_IMP_DQ_DQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_MC_DRV_IMP_DQ_DQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_MC_RCV_IMP_DQ_DQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_MC_RCV_IMP_DQ_DQS entry");
            AttributeTraits<ATTR_MSS_VPD_MT_MC_RCV_IMP_DQ_DQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_MC_RCV_IMP_DQ_DQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_ODT_RD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_ODT_RD entry");
            AttributeTraits<ATTR_MSS_VPD_MT_ODT_RD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_ODT_RD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_ODT_WR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_ODT_WR entry");
            AttributeTraits<ATTR_MSS_VPD_MT_ODT_WR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_ODT_WR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_PREAMBLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_PREAMBLE entry");
            AttributeTraits<ATTR_MSS_VPD_MT_PREAMBLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_PREAMBLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_VREF_DRAM_WR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_VREF_DRAM_WR entry");
            AttributeTraits<ATTR_MSS_VPD_MT_VREF_DRAM_WR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_VREF_DRAM_WR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_VREF_MC_RD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_VREF_MC_RD entry");
            AttributeTraits<ATTR_MSS_VPD_MT_VREF_MC_RD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_VREF_MC_RD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MT_WINDAGE_RD_CTR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MT_WINDAGE_RD_CTR entry");
            AttributeTraits<ATTR_MSS_VPD_MT_WINDAGE_RD_CTR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MT_WINDAGE_RD_CTR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_OMI_INBAND_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_HB_HRMOR_BYTES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HB_HRMOR_BYTES entry");
            AttributeTraits<ATTR_HB_HRMOR_BYTES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HB_HRMOR_BYTES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FREQ_PROC_REFCLOCK_KHZ): { break; }
        case (ATTR_FREQ_MEM_REFCLOCK): { break; }
        case (ATTR_MAX_ALLOWED_DIMM_FREQ): { break; }
        case (ATTR_MEMVPD_POS): { break; }
        case (ATTR_REQUIRED_SYNCH_MODE): { break; }
        case (ATTR_NHTM_TRACE_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NHTM_TRACE_TYPE entry");
            AttributeTraits<ATTR_NHTM_TRACE_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NHTM_TRACE_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CHTM_TRACE_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CHTM_TRACE_TYPE entry");
            AttributeTraits<ATTR_CHTM_TRACE_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CHTM_TRACE_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_TTYPEFILT_PAT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_TTYPEFILT_PAT entry");
            AttributeTraits<ATTR_HTMSC_TTYPEFILT_PAT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_TTYPEFILT_PAT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_TSIZEFILT_PAT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_TSIZEFILT_PAT entry");
            AttributeTraits<ATTR_HTMSC_TSIZEFILT_PAT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_TSIZEFILT_PAT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_TTYPEFILT_MASK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_TTYPEFILT_MASK entry");
            AttributeTraits<ATTR_HTMSC_TTYPEFILT_MASK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_TTYPEFILT_MASK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_TSIZEFILT_MASK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_TSIZEFILT_MASK entry");
            AttributeTraits<ATTR_HTMSC_TSIZEFILT_MASK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_TSIZEFILT_MASK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_TTYPEFILT_INVERT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_TTYPEFILT_INVERT entry");
            AttributeTraits<ATTR_HTMSC_TTYPEFILT_INVERT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_TTYPEFILT_INVERT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_CRESPFILT_INVERT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_CRESPFILT_INVERT entry");
            AttributeTraits<ATTR_HTMSC_CRESPFILT_INVERT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_CRESPFILT_INVERT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_FILT_PAT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_FILT_PAT entry");
            AttributeTraits<ATTR_HTMSC_FILT_PAT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_FILT_PAT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_FILT_CRESP_PAT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_FILT_CRESP_PAT entry");
            AttributeTraits<ATTR_HTMSC_FILT_CRESP_PAT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_FILT_CRESP_PAT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_FILT_MASK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_FILT_MASK entry");
            AttributeTraits<ATTR_HTMSC_FILT_MASK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_FILT_MASK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_FILT_CRESP_MASK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_FILT_CRESP_MASK entry");
            AttributeTraits<ATTR_HTMSC_FILT_CRESP_MASK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_FILT_CRESP_MASK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NHTM_HTMSC_MODE_CONTENT_SEL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NHTM_HTMSC_MODE_CONTENT_SEL entry");
            AttributeTraits<ATTR_NHTM_HTMSC_MODE_CONTENT_SEL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NHTM_HTMSC_MODE_CONTENT_SEL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NHTM_HTMSC_MODE_CAPTURE_GENERATED_WRITES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NHTM_HTMSC_MODE_CAPTURE_GENERATED_WRITES entry");
            AttributeTraits<ATTR_NHTM_HTMSC_MODE_CAPTURE_GENERATED_WRITES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NHTM_HTMSC_MODE_CAPTURE_GENERATED_WRITES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NHTM_HTMSC_MODE_CAPTURE_ENABLE_FILTER_ALL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NHTM_HTMSC_MODE_CAPTURE_ENABLE_FILTER_ALL entry");
            AttributeTraits<ATTR_NHTM_HTMSC_MODE_CAPTURE_ENABLE_FILTER_ALL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NHTM_HTMSC_MODE_CAPTURE_ENABLE_FILTER_ALL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NHTM_HTMSC_MODE_CAPTURE_PRECISE_CRESP_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NHTM_HTMSC_MODE_CAPTURE_PRECISE_CRESP_MODE entry");
            AttributeTraits<ATTR_NHTM_HTMSC_MODE_CAPTURE_PRECISE_CRESP_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NHTM_HTMSC_MODE_CAPTURE_PRECISE_CRESP_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NHTM_HTMSC_MODE_CAPTURE_LIMIT_MEM_ALLOCATION): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NHTM_HTMSC_MODE_CAPTURE_LIMIT_MEM_ALLOCATION entry");
            AttributeTraits<ATTR_NHTM_HTMSC_MODE_CAPTURE_LIMIT_MEM_ALLOCATION>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NHTM_HTMSC_MODE_CAPTURE_LIMIT_MEM_ALLOCATION>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NHTM_HTMSC_MODE_CAPTURE_PMISC_ONLY_CMD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NHTM_HTMSC_MODE_CAPTURE_PMISC_ONLY_CMD entry");
            AttributeTraits<ATTR_NHTM_HTMSC_MODE_CAPTURE_PMISC_ONLY_CMD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NHTM_HTMSC_MODE_CAPTURE_PMISC_ONLY_CMD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NHTM_HTMSC_MODE_SYNC_STAMP_FORCE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NHTM_HTMSC_MODE_SYNC_STAMP_FORCE entry");
            AttributeTraits<ATTR_NHTM_HTMSC_MODE_SYNC_STAMP_FORCE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NHTM_HTMSC_MODE_SYNC_STAMP_FORCE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NHTM_HTMSC_MODE_WRITETOIO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NHTM_HTMSC_MODE_WRITETOIO entry");
            AttributeTraits<ATTR_NHTM_HTMSC_MODE_WRITETOIO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NHTM_HTMSC_MODE_WRITETOIO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CHTM_HTMSC_MODE_CONTENT_SEL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CHTM_HTMSC_MODE_CONTENT_SEL entry");
            AttributeTraits<ATTR_CHTM_HTMSC_MODE_CONTENT_SEL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CHTM_HTMSC_MODE_CONTENT_SEL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CHTM_HTMSC_MODE_CAPTURE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CHTM_HTMSC_MODE_CAPTURE entry");
            AttributeTraits<ATTR_CHTM_HTMSC_MODE_CAPTURE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CHTM_HTMSC_MODE_CAPTURE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CHTM_HTMSC_MODE_CORE_INSTR_STALL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CHTM_HTMSC_MODE_CORE_INSTR_STALL entry");
            AttributeTraits<ATTR_CHTM_HTMSC_MODE_CORE_INSTR_STALL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CHTM_HTMSC_MODE_CORE_INSTR_STALL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_MODE_WRAP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_MODE_WRAP entry");
            AttributeTraits<ATTR_HTMSC_MODE_WRAP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_MODE_WRAP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_MODE_DIS_TSTAMP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_MODE_DIS_TSTAMP entry");
            AttributeTraits<ATTR_HTMSC_MODE_DIS_TSTAMP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_MODE_DIS_TSTAMP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_MODE_SINGLE_TSTAMP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_MODE_SINGLE_TSTAMP entry");
            AttributeTraits<ATTR_HTMSC_MODE_SINGLE_TSTAMP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_MODE_SINGLE_TSTAMP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_MODE_MARKERS_ONLY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_MODE_MARKERS_ONLY entry");
            AttributeTraits<ATTR_HTMSC_MODE_MARKERS_ONLY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_MODE_MARKERS_ONLY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_MODE_DIS_FORCE_GROUP_SCOPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_MODE_DIS_FORCE_GROUP_SCOPE entry");
            AttributeTraits<ATTR_HTMSC_MODE_DIS_FORCE_GROUP_SCOPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_MODE_DIS_FORCE_GROUP_SCOPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_MODE_VGTARGET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_MODE_VGTARGET entry");
            AttributeTraits<ATTR_HTMSC_MODE_VGTARGET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_MODE_VGTARGET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_MEM_SCOPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_MEM_SCOPE entry");
            AttributeTraits<ATTR_HTMSC_MEM_SCOPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_MEM_SCOPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_MEM_PRIORITY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_MEM_PRIORITY entry");
            AttributeTraits<ATTR_HTMSC_MEM_PRIORITY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_MEM_PRIORITY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NHTM_CTRL_TRIG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NHTM_CTRL_TRIG entry");
            AttributeTraits<ATTR_NHTM_CTRL_TRIG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NHTM_CTRL_TRIG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NHTM_CTRL_MARK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NHTM_CTRL_MARK entry");
            AttributeTraits<ATTR_NHTM_CTRL_MARK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NHTM_CTRL_MARK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CHTM_CTRL_TRIG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CHTM_CTRL_TRIG entry");
            AttributeTraits<ATTR_CHTM_CTRL_TRIG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CHTM_CTRL_TRIG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CHTM_CTRL_MARK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CHTM_CTRL_MARK entry");
            AttributeTraits<ATTR_CHTM_CTRL_MARK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CHTM_CTRL_MARK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_CTRL_DBG0_STOP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_CTRL_DBG0_STOP entry");
            AttributeTraits<ATTR_HTMSC_CTRL_DBG0_STOP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_CTRL_DBG0_STOP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_CTRL_DBG1_STOP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_CTRL_DBG1_STOP entry");
            AttributeTraits<ATTR_HTMSC_CTRL_DBG1_STOP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_CTRL_DBG1_STOP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_CTRL_RUN_STOP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_CTRL_RUN_STOP entry");
            AttributeTraits<ATTR_HTMSC_CTRL_RUN_STOP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_CTRL_RUN_STOP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_CTRL_OTHER_DBG0_STOP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_CTRL_OTHER_DBG0_STOP entry");
            AttributeTraits<ATTR_HTMSC_CTRL_OTHER_DBG0_STOP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_CTRL_OTHER_DBG0_STOP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_CTRL_XSTOP_STOP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_CTRL_XSTOP_STOP entry");
            AttributeTraits<ATTR_HTMSC_CTRL_XSTOP_STOP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_CTRL_XSTOP_STOP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_CTRL_CHIP0_STOP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_CTRL_CHIP0_STOP entry");
            AttributeTraits<ATTR_HTMSC_CTRL_CHIP0_STOP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_CTRL_CHIP0_STOP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_CTRL_CHIP1_STOP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_CTRL_CHIP1_STOP entry");
            AttributeTraits<ATTR_HTMSC_CTRL_CHIP1_STOP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_CTRL_CHIP1_STOP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_IMA_PDBAR_SPLIT_CORE_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_IMA_PDBAR_SPLIT_CORE_MODE entry");
            AttributeTraits<ATTR_HTMSC_IMA_PDBAR_SPLIT_CORE_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_IMA_PDBAR_SPLIT_CORE_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_IMA_PDBAR_SCOPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_IMA_PDBAR_SCOPE entry");
            AttributeTraits<ATTR_HTMSC_IMA_PDBAR_SCOPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_IMA_PDBAR_SCOPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMSC_IMA_PDBAR_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMSC_IMA_PDBAR_ADDR entry");
            AttributeTraits<ATTR_HTMSC_IMA_PDBAR_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMSC_IMA_PDBAR_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FREQ_PB_MHZ): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FREQ_PB_MHZ entry");
            AttributeTraits<ATTR_FREQ_PB_MHZ>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FREQ_PB_MHZ>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FREQ_O_MHZ): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FREQ_O_MHZ entry");
            AttributeTraits<ATTR_FREQ_O_MHZ>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FREQ_O_MHZ>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FREQ_A_MHZ): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FREQ_A_MHZ entry");
            AttributeTraits<ATTR_FREQ_A_MHZ>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FREQ_A_MHZ>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FREQ_X_MHZ): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FREQ_X_MHZ entry");
            AttributeTraits<ATTR_FREQ_X_MHZ>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FREQ_X_MHZ>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PM_SAFE_FREQUENCY_MHZ): { break; }
        case (ATTR_PM_SAFE_VOLTAGE_MV): { break; }
        case (ATTR_FREQ_PCIE_MHZ): { break; }
        case (ATTR_DD1_SLOW_PCI_REF_CLOCK): { break; }
        case (ATTR_PROC_FABRIC_ASYNC_SAFE_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_ASYNC_SAFE_MODE entry");
            AttributeTraits<ATTR_PROC_FABRIC_ASYNC_SAFE_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_ASYNC_SAFE_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_A_BUS_WIDTH): { break; }
        case (ATTR_PROC_FABRIC_X_BUS_WIDTH): { break; }
        case (ATTR_PROC_FABRIC_CORE_FLOOR_RATIO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_CORE_FLOOR_RATIO entry");
            AttributeTraits<ATTR_PROC_FABRIC_CORE_FLOOR_RATIO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_CORE_FLOOR_RATIO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_CORE_CEILING_RATIO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_CORE_CEILING_RATIO entry");
            AttributeTraits<ATTR_PROC_FABRIC_CORE_CEILING_RATIO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_CORE_CEILING_RATIO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_PUMP_MODE): { break; }
        case (ATTR_PROC_FABRIC_CCSM_MODE): { break; }
        case (ATTR_OPTICS_CONFIG_MODE): { break; }
        case (ATTR_PROC_FABRIC_SMP_OPTICS_MODE): { break; }
        case (ATTR_PROC_FABRIC_OPTICS_CONFIG_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_OPTICS_CONFIG_MODE entry");
            AttributeTraits<ATTR_PROC_FABRIC_OPTICS_CONFIG_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_OPTICS_CONFIG_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_CAPI_MODE): { break; }
        case (ATTR_FABRIC_PRESENT_GROUPS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FABRIC_PRESENT_GROUPS entry");
            AttributeTraits<ATTR_FABRIC_PRESENT_GROUPS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FABRIC_PRESENT_GROUPS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_SYSTEM_ID): { break; }
        case (ATTR_FABRIC_ADDR_EXTENSION_GROUP_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FABRIC_ADDR_EXTENSION_GROUP_ID entry");
            AttributeTraits<ATTR_FABRIC_ADDR_EXTENSION_GROUP_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FABRIC_ADDR_EXTENSION_GROUP_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FABRIC_ADDR_EXTENSION_CHIP_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FABRIC_ADDR_EXTENSION_CHIP_ID entry");
            AttributeTraits<ATTR_FABRIC_ADDR_EXTENSION_CHIP_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FABRIC_ADDR_EXTENSION_CHIP_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_EFF_FABRIC_GROUP_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_EFF_FABRIC_GROUP_ID entry");
            AttributeTraits<ATTR_PROC_EFF_FABRIC_GROUP_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_EFF_FABRIC_GROUP_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_EFF_FABRIC_CHIP_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_EFF_FABRIC_CHIP_ID entry");
            AttributeTraits<ATTR_PROC_EFF_FABRIC_CHIP_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_EFF_FABRIC_CHIP_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_SYSTEM_MASTER_CHIP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_SYSTEM_MASTER_CHIP entry");
            AttributeTraits<ATTR_PROC_FABRIC_SYSTEM_MASTER_CHIP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_SYSTEM_MASTER_CHIP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_GROUP_MASTER_CHIP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_GROUP_MASTER_CHIP entry");
            AttributeTraits<ATTR_PROC_FABRIC_GROUP_MASTER_CHIP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_GROUP_MASTER_CHIP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_LINK_ACTIVE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_LINK_ACTIVE entry");
            AttributeTraits<ATTR_PROC_FABRIC_LINK_ACTIVE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_LINK_ACTIVE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_LINK_TRAIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: LINK_TRAIN entry");
            AttributeTraits<ATTR_LINK_TRAIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_LINK_TRAIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_X_ATTACHED_CHIP_CNFG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_X_ATTACHED_CHIP_CNFG entry");
            AttributeTraits<ATTR_PROC_FABRIC_X_ATTACHED_CHIP_CNFG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_X_ATTACHED_CHIP_CNFG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_X_LINKS_CNFG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_X_LINKS_CNFG entry");
            AttributeTraits<ATTR_PROC_FABRIC_X_LINKS_CNFG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_X_LINKS_CNFG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_A_ATTACHED_CHIP_CNFG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_A_ATTACHED_CHIP_CNFG entry");
            AttributeTraits<ATTR_PROC_FABRIC_A_ATTACHED_CHIP_CNFG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_A_ATTACHED_CHIP_CNFG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_A_LINKS_CNFG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_A_LINKS_CNFG entry");
            AttributeTraits<ATTR_PROC_FABRIC_A_LINKS_CNFG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_A_LINKS_CNFG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_X_ATTACHED_CHIP_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_X_ATTACHED_CHIP_ID entry");
            AttributeTraits<ATTR_PROC_FABRIC_X_ATTACHED_CHIP_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_X_ATTACHED_CHIP_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_X_ATTACHED_LINK_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_X_ATTACHED_LINK_ID entry");
            AttributeTraits<ATTR_PROC_FABRIC_X_ATTACHED_LINK_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_X_ATTACHED_LINK_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_A_ATTACHED_CHIP_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_A_ATTACHED_CHIP_ID entry");
            AttributeTraits<ATTR_PROC_FABRIC_A_ATTACHED_CHIP_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_A_ATTACHED_CHIP_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_A_ATTACHED_LINK_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_A_ATTACHED_LINK_ID entry");
            AttributeTraits<ATTR_PROC_FABRIC_A_ATTACHED_LINK_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_A_ATTACHED_LINK_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_X_AGGREGATE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_X_AGGREGATE entry");
            AttributeTraits<ATTR_PROC_FABRIC_X_AGGREGATE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_X_AGGREGATE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_X_ADDR_DIS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_X_ADDR_DIS entry");
            AttributeTraits<ATTR_PROC_FABRIC_X_ADDR_DIS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_X_ADDR_DIS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_X_LINK_DELAY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_X_LINK_DELAY entry");
            AttributeTraits<ATTR_PROC_FABRIC_X_LINK_DELAY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_X_LINK_DELAY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_A_AGGREGATE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_A_AGGREGATE entry");
            AttributeTraits<ATTR_PROC_FABRIC_A_AGGREGATE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_A_AGGREGATE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_A_ADDR_DIS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_A_ADDR_DIS entry");
            AttributeTraits<ATTR_PROC_FABRIC_A_ADDR_DIS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_A_ADDR_DIS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FABRIC_A_LINK_DELAY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_FABRIC_A_LINK_DELAY entry");
            AttributeTraits<ATTR_PROC_FABRIC_A_LINK_DELAY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_FABRIC_A_LINK_DELAY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_EPS_GB_PERCENTAGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_EPS_GB_PERCENTAGE entry");
            AttributeTraits<ATTR_PROC_EPS_GB_PERCENTAGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_EPS_GB_PERCENTAGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_EPS_TABLE_TYPE): { break; }
        case (ATTR_PROC_EPS_READ_CYCLES_T0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_EPS_READ_CYCLES_T0 entry");
            AttributeTraits<ATTR_PROC_EPS_READ_CYCLES_T0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_EPS_READ_CYCLES_T0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_EPS_READ_CYCLES_T1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_EPS_READ_CYCLES_T1 entry");
            AttributeTraits<ATTR_PROC_EPS_READ_CYCLES_T1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_EPS_READ_CYCLES_T1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_EPS_READ_CYCLES_T2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_EPS_READ_CYCLES_T2 entry");
            AttributeTraits<ATTR_PROC_EPS_READ_CYCLES_T2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_EPS_READ_CYCLES_T2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_EPS_WRITE_CYCLES_T1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_EPS_WRITE_CYCLES_T1 entry");
            AttributeTraits<ATTR_PROC_EPS_WRITE_CYCLES_T1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_EPS_WRITE_CYCLES_T1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_EPS_WRITE_CYCLES_T2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_EPS_WRITE_CYCLES_T2 entry");
            AttributeTraits<ATTR_PROC_EPS_WRITE_CYCLES_T2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_EPS_WRITE_CYCLES_T2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_DMI_REFCLOCK_SWIZZLE): { break; }
        case (ATTR_OMI_REFCLOCK_SWIZZLE): { break; }
        case (ATTR_SYSTEM_IPL_PHASE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SYSTEM_IPL_PHASE entry");
            AttributeTraits<ATTR_SYSTEM_IPL_PHASE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SYSTEM_IPL_PHASE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_XSCOM_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_LPC_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_MAX_INTERLEAVE_GROUP_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MAX_INTERLEAVE_GROUP_SIZE entry");
            AttributeTraits<ATTR_MAX_INTERLEAVE_GROUP_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MAX_INTERLEAVE_GROUP_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_MIRROR_PLACEMENT_POLICY): { break; }
        case (ATTR_PROC_MEM_BASES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_MEM_BASES entry");
            AttributeTraits<ATTR_PROC_MEM_BASES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_MEM_BASES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_MEM_SIZES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_MEM_SIZES entry");
            AttributeTraits<ATTR_PROC_MEM_SIZES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_MEM_SIZES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_MIRROR_BASES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_MIRROR_BASES entry");
            AttributeTraits<ATTR_PROC_MIRROR_BASES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_MIRROR_BASES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_MIRROR_SIZES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_MIRROR_SIZES entry");
            AttributeTraits<ATTR_PROC_MIRROR_SIZES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_MIRROR_SIZES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_INTERLEAVE_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_INTERLEAVE_ENABLE entry");
            AttributeTraits<ATTR_MSS_INTERLEAVE_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_INTERLEAVE_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_INTERLEAVE_GRANULARITY): { break; }
        case (ATTR_MSS_MEM_MC_IN_GROUP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_MEM_MC_IN_GROUP entry");
            AttributeTraits<ATTR_MSS_MEM_MC_IN_GROUP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_MEM_MC_IN_GROUP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_MCS_GROUP_32): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_MCS_GROUP_32 entry");
            AttributeTraits<ATTR_MSS_MCS_GROUP_32>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_MCS_GROUP_32>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_MEM_IPL_COMPLETE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_MEM_IPL_COMPLETE entry");
            AttributeTraits<ATTR_MSS_MEM_IPL_COMPLETE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_MEM_IPL_COMPLETE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MRW_HW_MIRRORING_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MRW_HW_MIRRORING_ENABLE entry");
            AttributeTraits<ATTR_MRW_HW_MIRRORING_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MRW_HW_MIRRORING_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_NHTM_BAR_BASE_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_NHTM_BAR_BASE_ADDR entry");
            AttributeTraits<ATTR_PROC_NHTM_BAR_BASE_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_NHTM_BAR_BASE_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_NHTM_BAR_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_NHTM_BAR_SIZE entry");
            AttributeTraits<ATTR_PROC_NHTM_BAR_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_NHTM_BAR_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_CHTM_BAR_BASE_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_CHTM_BAR_BASE_ADDR entry");
            AttributeTraits<ATTR_PROC_CHTM_BAR_BASE_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_CHTM_BAR_BASE_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_CHTM_BAR_SIZES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_CHTM_BAR_SIZES entry");
            AttributeTraits<ATTR_PROC_CHTM_BAR_SIZES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_CHTM_BAR_SIZES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_SMF_BAR_BASE_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_SMF_BAR_BASE_ADDR entry");
            AttributeTraits<ATTR_PROC_SMF_BAR_BASE_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_SMF_BAR_BASE_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_SMF_BAR_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_SMF_BAR_SIZE entry");
            AttributeTraits<ATTR_PROC_SMF_BAR_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_SMF_BAR_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SMF_CONFIG): { break; }
        case (ATTR_SMF_ENABLED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SMF_ENABLED entry");
            AttributeTraits<ATTR_SMF_ENABLED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SMF_ENABLED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_OCC_SANDBOX_BASE_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_OCC_SANDBOX_BASE_ADDR entry");
            AttributeTraits<ATTR_PROC_OCC_SANDBOX_BASE_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_OCC_SANDBOX_BASE_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_OCC_SANDBOX_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_OCC_SANDBOX_SIZE entry");
            AttributeTraits<ATTR_PROC_OCC_SANDBOX_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_OCC_SANDBOX_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_MEM_BASES_ACK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_MEM_BASES_ACK entry");
            AttributeTraits<ATTR_PROC_MEM_BASES_ACK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_MEM_BASES_ACK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_MEM_SIZES_ACK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_MEM_SIZES_ACK entry");
            AttributeTraits<ATTR_PROC_MEM_SIZES_ACK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_MEM_SIZES_ACK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_MIRROR_BASES_ACK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_MIRROR_BASES_ACK entry");
            AttributeTraits<ATTR_PROC_MIRROR_BASES_ACK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_MIRROR_BASES_ACK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_MIRROR_SIZES_ACK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_MIRROR_SIZES_ACK entry");
            AttributeTraits<ATTR_PROC_MIRROR_SIZES_ACK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_MIRROR_SIZES_ACK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTM_QUEUES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTM_QUEUES entry");
            AttributeTraits<ATTR_HTM_QUEUES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTM_QUEUES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ENABLE_MEM_EARLY_DATA_SCOM): { break; }
        case (ATTR_MSS_VPD_DQ_MAP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_DQ_MAP entry");
            AttributeTraits<ATTR_MSS_VPD_DQ_MAP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_DQ_MAP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_0_VERSION_LAYOUT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_0_VERSION_LAYOUT entry");
            AttributeTraits<ATTR_MSS_VPD_MR_0_VERSION_LAYOUT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_0_VERSION_LAYOUT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_1_VERSION_DATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_1_VERSION_DATA entry");
            AttributeTraits<ATTR_MSS_VPD_MR_1_VERSION_DATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_1_VERSION_DATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_2_SIGNATURE_HASH): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_2_SIGNATURE_HASH entry");
            AttributeTraits<ATTR_MSS_VPD_MR_2_SIGNATURE_HASH>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_2_SIGNATURE_HASH>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_DPHY_GPO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_DPHY_GPO entry");
            AttributeTraits<ATTR_MSS_VPD_MR_DPHY_GPO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_DPHY_GPO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_DPHY_RLO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_DPHY_RLO entry");
            AttributeTraits<ATTR_MSS_VPD_MR_DPHY_RLO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_DPHY_RLO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_DPHY_WLO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_DPHY_WLO entry");
            AttributeTraits<ATTR_MSS_VPD_MR_DPHY_WLO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_DPHY_WLO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_2N_MODE_AUTOSET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_2N_MODE_AUTOSET entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_2N_MODE_AUTOSET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_2N_MODE_AUTOSET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A00): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A00 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A00>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A00>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A01): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A01 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A01>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A01>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A02): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A02 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A02>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A02>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A03): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A03 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A03>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A03>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A04): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A04 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A04>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A04>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A05): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A05 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A05>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A05>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A06): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A06 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A06>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A06>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A07): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A07 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A07>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A07>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A08): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A08 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A08>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A08>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A09): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A09 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A09>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A09>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A10): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A10 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A10>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A10>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A11): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A11 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A11>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A11>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A12): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A12 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A12>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A12>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A13): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A13 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A13>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A13>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A17): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_A17 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A17>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A17>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA0 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA1 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG0 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG1 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_C0 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_C1 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_ADDR_C2 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ACTN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CMD_ACTN entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ACTN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ACTN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_CASN_A15): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_CASN_A15 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_CASN_A15>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_CASN_A15>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_RASN_A16): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_RASN_A16 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_RASN_A16>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_RASN_A16>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_WEN_A14): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_WEN_A14 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_WEN_A14>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_WEN_A14>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_PAR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CMD_PAR entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_PAR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_PAR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE0 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE1 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN0 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN1 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT0 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT1 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE0 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE1 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN0 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN1 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT0 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT1 entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_D0_CLKN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_D0_CLKN entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_D0_CLKN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_D0_CLKN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_D0_CLKP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_D0_CLKP entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_D0_CLKP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_D0_CLKP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_D1_CLKN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_D1_CLKN entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_D1_CLKN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_D1_CLKN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_MC_PHASE_ROT_D1_CLKP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_MC_PHASE_ROT_D1_CLKP entry");
            AttributeTraits<ATTR_MSS_VPD_MR_MC_PHASE_ROT_D1_CLKP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_MC_PHASE_ROT_D1_CLKP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_TSYS_ADR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_TSYS_ADR entry");
            AttributeTraits<ATTR_MSS_VPD_MR_TSYS_ADR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_TSYS_ADR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPD_MR_TSYS_DATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VPD_MR_TSYS_DATA entry");
            AttributeTraits<ATTR_MSS_VPD_MR_TSYS_DATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VPD_MR_TSYS_DATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_FSP_BAR_ENABLE): { break; }
        case (ATTR_PROC_FSP_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_FSP_BAR_SIZE): { break; }
        case (ATTR_PROC_FSP_MMIO_MASK_SIZE): { break; }
        case (ATTR_PROC_NPU_PHY0_BAR_ENABLE): { break; }
        case (ATTR_PROC_NPU_PHY0_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_NPU_PHY1_BAR_ENABLE): { break; }
        case (ATTR_PROC_NPU_PHY1_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_NPU_MMIO_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_NPU_MMIO_BAR_ENABLE): { break; }
        case (ATTR_PROC_PSI_BRIDGE_BAR_ENABLE): { break; }
        case (ATTR_PROC_PSI_BRIDGE_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_NX_RNG_BAR_ENABLE): { break; }
        case (ATTR_PROC_NX_RNG_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_NX_RNG_FAILED_INT_ENABLE): { break; }
        case (ATTR_PROC_NX_RNG_FAILED_INT_ADDR): { break; }
        case (ATTR_PROC_INT_CQ_PC_BAR_ENABLE): { break; }
        case (ATTR_PROC_INT_CQ_PC_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_INT_CQ_PC_BAR_BASE_ADDR_OFFSET_MASK): { break; }
        case (ATTR_PROC_INT_CQ_VC_BAR_ENABLE): { break; }
        case (ATTR_PROC_INT_CQ_VC_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_INT_CQ_VC_BAR_BASE_ADDR_OFFSET_MASK): { break; }
        case (ATTR_PROC_INT_CQ_TM1_BAR_ENABLE): { break; }
        case (ATTR_PROC_INT_CQ_TM1_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_INT_CQ_TM1_BAR_PAGE_SIZE): { break; }
        case (ATTR_PROC_INT_CQ_IC_BAR_ENABLE): { break; }
        case (ATTR_PROC_INT_CQ_IC_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_INT_CQ_IC_BAR_PAGE_SIZE): { break; }
        case (ATTR_PROC_PCIE_IOP_SWAP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_PCIE_IOP_SWAP entry");
            AttributeTraits<ATTR_PROC_PCIE_IOP_SWAP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_PCIE_IOP_SWAP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_PCIE_BAR_ENABLE): { break; }
        case (ATTR_PROC_PCIE_MMIO_BAR0_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_PCIE_MMIO_BAR1_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_PCIE_REGISTER_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_PROC_PCIE_BAR_SIZE): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_CDR_GAIN): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_PK_INIT): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_INIT_GAIN): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_SIGDET_LVL): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_ROT_CDR_LOOKAHEAD): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_ROT_CDR_SSC): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_ROT_EXTEL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_PCIE_PCS_RX_ROT_EXTEL entry");
            AttributeTraits<ATTR_PROC_PCIE_PCS_RX_ROT_EXTEL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_PCIE_PCS_RX_ROT_EXTEL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_PCIE_PCS_RX_ROT_RST_FW): { break; }
        case (ATTR_PROC_PCIE_PCS_PCLCK_CNTL_PLLA): { break; }
        case (ATTR_PROC_PCIE_PCS_PCLCK_CNTL_PLLB): { break; }
        case (ATTR_PROC_PCIE_PCS_TX_DCLCK_ROT): { break; }
        case (ATTR_PROC_PCIE_PCS_TX_PCIE_RECV_DETECT_CNTL_REG1): { break; }
        case (ATTR_PROC_PCIE_PCS_TX_PCIE_RECV_DETECT_CNTL_REG2): { break; }
        case (ATTR_PROC_PCIE_PCS_TX_POWER_SEQ_ENABLE): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_VGA_CNTL_REG1): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_VGA_CNTL_REG2): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_DFE_FDDC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_PCIE_PCS_RX_DFE_FDDC entry");
            AttributeTraits<ATTR_PROC_PCIE_PCS_RX_DFE_FDDC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_PCIE_PCS_RX_DFE_FDDC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_PCIE_PCS_M_CNTL): { break; }
        case (ATTR_PROC_PCIE_CACHE_INJ_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_PCIE_CACHE_INJ_MODE entry");
            AttributeTraits<ATTR_PROC_PCIE_CACHE_INJ_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_PCIE_CACHE_INJ_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_PCIE_CACHE_INJ_THROTTLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_PCIE_CACHE_INJ_THROTTLE entry");
            AttributeTraits<ATTR_PROC_PCIE_CACHE_INJ_THROTTLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_PCIE_CACHE_INJ_THROTTLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_DPLL_DIVIDER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_DPLL_DIVIDER entry");
            AttributeTraits<ATTR_PROC_DPLL_DIVIDER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_DPLL_DIVIDER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_STOPGPE_BOOT_COPIER_IVPR_OFFSET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: STOPGPE_BOOT_COPIER_IVPR_OFFSET entry");
            AttributeTraits<ATTR_STOPGPE_BOOT_COPIER_IVPR_OFFSET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_STOPGPE_BOOT_COPIER_IVPR_OFFSET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PSTATEGPE_BOOT_COPIER_IVPR_OFFSET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PSTATEGPE_BOOT_COPIER_IVPR_OFFSET entry");
            AttributeTraits<ATTR_PSTATEGPE_BOOT_COPIER_IVPR_OFFSET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PSTATEGPE_BOOT_COPIER_IVPR_OFFSET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PM_SPWUP_IGNORE_XSTOP_FLAG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PM_SPWUP_IGNORE_XSTOP_FLAG entry");
            AttributeTraits<ATTR_PM_SPWUP_IGNORE_XSTOP_FLAG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PM_SPWUP_IGNORE_XSTOP_FLAG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_OCC_LFIR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: OCC_LFIR entry");
            AttributeTraits<ATTR_OCC_LFIR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_OCC_LFIR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PBA_LFIR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PBA_LFIR entry");
            AttributeTraits<ATTR_PBA_LFIR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PBA_LFIR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PM_FIRINIT_DONE_ONCE_FLAG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PM_FIRINIT_DONE_ONCE_FLAG entry");
            AttributeTraits<ATTR_PM_FIRINIT_DONE_ONCE_FLAG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PM_FIRINIT_DONE_ONCE_FLAG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_QUAD_PPM_ERRMASK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: QUAD_PPM_ERRMASK entry");
            AttributeTraits<ATTR_QUAD_PPM_ERRMASK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_QUAD_PPM_ERRMASK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CORE_PPM_ERRMASK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CORE_PPM_ERRMASK entry");
            AttributeTraits<ATTR_CORE_PPM_ERRMASK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CORE_PPM_ERRMASK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CME_LOCAL_FIRMASK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CME_LOCAL_FIRMASK entry");
            AttributeTraits<ATTR_CME_LOCAL_FIRMASK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CME_LOCAL_FIRMASK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_L2_HASCLOCKS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: L2_HASCLOCKS entry");
            AttributeTraits<ATTR_L2_HASCLOCKS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_L2_HASCLOCKS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_L3_HASCLOCKS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: L3_HASCLOCKS entry");
            AttributeTraits<ATTR_L3_HASCLOCKS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_L3_HASCLOCKS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_C0_EXEC_HASCLOCKS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: C0_EXEC_HASCLOCKS entry");
            AttributeTraits<ATTR_C0_EXEC_HASCLOCKS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_C0_EXEC_HASCLOCKS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_C1_EXEC_HASCLOCKS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: C1_EXEC_HASCLOCKS entry");
            AttributeTraits<ATTR_C1_EXEC_HASCLOCKS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_C1_EXEC_HASCLOCKS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_C0_PC_HASCLOCKS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: C0_PC_HASCLOCKS entry");
            AttributeTraits<ATTR_C0_PC_HASCLOCKS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_C0_PC_HASCLOCKS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_C1_PC_HASCLOCKS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: C1_PC_HASCLOCKS entry");
            AttributeTraits<ATTR_C1_PC_HASCLOCKS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_C1_PC_HASCLOCKS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_L2_HASPOWER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: L2_HASPOWER entry");
            AttributeTraits<ATTR_L2_HASPOWER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_L2_HASPOWER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_L3_HASPOWER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: L3_HASPOWER entry");
            AttributeTraits<ATTR_L3_HASPOWER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_L3_HASPOWER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_C0_HASPOWER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: C0_HASPOWER entry");
            AttributeTraits<ATTR_C0_HASPOWER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_C0_HASPOWER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_C1_HASPOWER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: C1_HASPOWER entry");
            AttributeTraits<ATTR_C1_HASPOWER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_C1_HASPOWER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PM_SPIPSS_FRAME_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PM_SPIPSS_FRAME_SIZE entry");
            AttributeTraits<ATTR_PM_SPIPSS_FRAME_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PM_SPIPSS_FRAME_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PM_SPIPSS_IN_DELAY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PM_SPIPSS_IN_DELAY entry");
            AttributeTraits<ATTR_PM_SPIPSS_IN_DELAY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PM_SPIPSS_IN_DELAY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PM_SPIPSS_CLOCK_POLARITY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PM_SPIPSS_CLOCK_POLARITY entry");
            AttributeTraits<ATTR_PM_SPIPSS_CLOCK_POLARITY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PM_SPIPSS_CLOCK_POLARITY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PM_SPIPSS_CLOCK_PHASE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PM_SPIPSS_CLOCK_PHASE entry");
            AttributeTraits<ATTR_PM_SPIPSS_CLOCK_PHASE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PM_SPIPSS_CLOCK_PHASE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PM_SPIPSS_CLOCK_DIVIDER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PM_SPIPSS_CLOCK_DIVIDER entry");
            AttributeTraits<ATTR_PM_SPIPSS_CLOCK_DIVIDER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PM_SPIPSS_CLOCK_DIVIDER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PM_SPIPSS_INTER_FRAME_DELAY_SETTING): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PM_SPIPSS_INTER_FRAME_DELAY_SETTING entry");
            AttributeTraits<ATTR_PM_SPIPSS_INTER_FRAME_DELAY_SETTING>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PM_SPIPSS_INTER_FRAME_DELAY_SETTING>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PSTATES_ENABLED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PSTATES_ENABLED entry");
            AttributeTraits<ATTR_PSTATES_ENABLED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PSTATES_ENABLED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_RESCLK_ENABLED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: RESCLK_ENABLED entry");
            AttributeTraits<ATTR_RESCLK_ENABLED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_RESCLK_ENABLED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_VDM_ENABLED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: VDM_ENABLED entry");
            AttributeTraits<ATTR_VDM_ENABLED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_VDM_ENABLED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IVRM_ENABLED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IVRM_ENABLED entry");
            AttributeTraits<ATTR_IVRM_ENABLED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IVRM_ENABLED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_WOF_ENABLED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: WOF_ENABLED entry");
            AttributeTraits<ATTR_WOF_ENABLED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_WOF_ENABLED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_WOV_OVERV_ENABLED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: WOV_OVERV_ENABLED entry");
            AttributeTraits<ATTR_WOV_OVERV_ENABLED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_WOV_OVERV_ENABLED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_WOV_UNDERV_ENABLED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: WOV_UNDERV_ENABLED entry");
            AttributeTraits<ATTR_WOV_UNDERV_ENABLED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_WOV_UNDERV_ENABLED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SGPE_PHANTOM_HALT_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SGPE_PHANTOM_HALT_ENABLE entry");
            AttributeTraits<ATTR_SGPE_PHANTOM_HALT_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SGPE_PHANTOM_HALT_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PGPE_PHANTOM_HALT_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PGPE_PHANTOM_HALT_ENABLE entry");
            AttributeTraits<ATTR_PGPE_PHANTOM_HALT_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PGPE_PHANTOM_HALT_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CME_STOP_PHANTOM_HALT_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CME_STOP_PHANTOM_HALT_ENABLE entry");
            AttributeTraits<ATTR_CME_STOP_PHANTOM_HALT_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CME_STOP_PHANTOM_HALT_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CME_PSTATE_PHANTOM_HALT_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CME_PSTATE_PHANTOM_HALT_ENABLE entry");
            AttributeTraits<ATTR_CME_PSTATE_PHANTOM_HALT_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CME_PSTATE_PHANTOM_HALT_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CORE_INSIDE_SPECIAL_WAKEUP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CORE_INSIDE_SPECIAL_WAKEUP entry");
            AttributeTraits<ATTR_CORE_INSIDE_SPECIAL_WAKEUP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CORE_INSIDE_SPECIAL_WAKEUP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EX_INSIDE_SPECIAL_WAKEUP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EX_INSIDE_SPECIAL_WAKEUP entry");
            AttributeTraits<ATTR_EX_INSIDE_SPECIAL_WAKEUP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EX_INSIDE_SPECIAL_WAKEUP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EQ_INSIDE_SPECIAL_WAKEUP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EQ_INSIDE_SPECIAL_WAKEUP entry");
            AttributeTraits<ATTR_EQ_INSIDE_SPECIAL_WAKEUP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EQ_INSIDE_SPECIAL_WAKEUP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_INITIATED_PM_RESET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: INITIATED_PM_RESET entry");
            AttributeTraits<ATTR_INITIATED_PM_RESET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_INITIATED_PM_RESET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PM_RESET_PHASE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PM_RESET_PHASE entry");
            AttributeTraits<ATTR_PM_RESET_PHASE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PM_RESET_PHASE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PM_MALF_CYCLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PM_MALF_CYCLE entry");
            AttributeTraits<ATTR_PM_MALF_CYCLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PM_MALF_CYCLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_OMI_DCCAL_FLAGS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IO_OMI_DCCAL_FLAGS entry");
            AttributeTraits<ATTR_IO_OMI_DCCAL_FLAGS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IO_OMI_DCCAL_FLAGS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_OMI_DEBUG): { break; }
        case (ATTR_IO_OMI_MFG_CHK): { break; }
        case (ATTR_IO_OMI_MFG_MIN_EYE_WIDTH): { break; }
        case (ATTR_IO_OMI_TX_MARGIN_RATIO): { break; }
        case (ATTR_IO_OMI_TX_FFE_PRECURSOR): { break; }
        case (ATTR_IO_OMI_TX_FFE_POSTCURSOR): { break; }
        case (ATTR_IO_OMI_MFG_STRESS_PR_OFFSET_EVEN): { break; }
        case (ATTR_IO_OMI_MFG_STRESS_PR_OFFSET_ODD): { break; }
        case (ATTR_IO_DMI_PROC_DCCAL_FLAGS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IO_DMI_PROC_DCCAL_FLAGS entry");
            AttributeTraits<ATTR_IO_DMI_PROC_DCCAL_FLAGS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IO_DMI_PROC_DCCAL_FLAGS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_DMI_PROC_DEBUG): { break; }
        case (ATTR_IO_DMI_PROC_TX_MARGIN_RATIO): { break; }
        case (ATTR_IO_DMI_PROC_TX_FFE_PRECURSOR): { break; }
        case (ATTR_DMI_INBAND_BAR_ENABLE): { break; }
        case (ATTR_DMI_INBAND_BAR_BASE_ADDR_OFFSET): { break; }
        case (ATTR_MSS_FREQ_OVERRIDE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_FREQ_OVERRIDE entry");
            AttributeTraits<ATTR_MSS_FREQ_OVERRIDE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_FREQ_OVERRIDE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_FREQ): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_FREQ entry");
            AttributeTraits<ATTR_MSS_FREQ>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_FREQ>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_FREQ_BIAS_PERCENTAGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_FREQ_BIAS_PERCENTAGE entry");
            AttributeTraits<ATTR_MSS_FREQ_BIAS_PERCENTAGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_FREQ_BIAS_PERCENTAGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_SPARE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_SPARE entry");
            AttributeTraits<ATTR_EFF_DIMM_SPARE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_SPARE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_WR_VREF): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_WR_VREF entry");
            AttributeTraits<ATTR_EFF_DRAM_WR_VREF>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_WR_VREF>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_WR_VREF_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_WR_VREF_SCHMOO entry");
            AttributeTraits<ATTR_EFF_DRAM_WR_VREF_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_WR_VREF_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_WRDDR4_VREF_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_WRDDR4_VREF_SCHMOO entry");
            AttributeTraits<ATTR_EFF_DRAM_WRDDR4_VREF_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_WRDDR4_VREF_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_SIZE entry");
            AttributeTraits<ATTR_EFF_DIMM_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_CL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_CL entry");
            AttributeTraits<ATTR_EFF_DRAM_CL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_CL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_AL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_AL entry");
            AttributeTraits<ATTR_EFF_DRAM_AL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_AL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_CWL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_CWL entry");
            AttributeTraits<ATTR_EFF_DRAM_CWL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_CWL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_RBT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_RBT entry");
            AttributeTraits<ATTR_EFF_DRAM_RBT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_RBT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TM entry");
            AttributeTraits<ATTR_EFF_DRAM_TM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_DLL_RESET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_DLL_RESET entry");
            AttributeTraits<ATTR_EFF_DRAM_DLL_RESET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_DLL_RESET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_DLL_PPD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_DLL_PPD entry");
            AttributeTraits<ATTR_EFF_DRAM_DLL_PPD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_DLL_PPD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_DLL_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_DLL_ENABLE entry");
            AttributeTraits<ATTR_EFF_DRAM_DLL_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_DLL_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_WR_LVL_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_WR_LVL_ENABLE entry");
            AttributeTraits<ATTR_EFF_DRAM_WR_LVL_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_WR_LVL_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_OUTPUT_BUFFER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_OUTPUT_BUFFER entry");
            AttributeTraits<ATTR_EFF_DRAM_OUTPUT_BUFFER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_OUTPUT_BUFFER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_PASR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_PASR entry");
            AttributeTraits<ATTR_EFF_DRAM_PASR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_PASR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_ASR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_ASR entry");
            AttributeTraits<ATTR_EFF_DRAM_ASR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_ASR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_SRT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_SRT entry");
            AttributeTraits<ATTR_EFF_DRAM_SRT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_SRT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_MPR_LOC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_MPR_LOC entry");
            AttributeTraits<ATTR_EFF_MPR_LOC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_MPR_LOC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_MPR_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_MPR_MODE entry");
            AttributeTraits<ATTR_EFF_MPR_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_MPR_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC00): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC00 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC00>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC00>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC01): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC01 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC01>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC01>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC02): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC02 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC02>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC02>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC03): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC03 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC03>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC03>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC04): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC04 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC04>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC04>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC05): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC05 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC05>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC05>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC06_07): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC06_07 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC06_07>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC06_07>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC08): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC08 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC08>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC08>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC09): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC09 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC09>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC09>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC0A): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC0A entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC0A>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC0A>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC0B): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC0B entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC0B>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC0B>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC0C): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC0C entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC0C>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC0C>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC0D): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC0D entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC0D>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC0D>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC0E): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC0E entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC0E>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC0E>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC0F): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC0F entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC0F>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC0F>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC_1x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC_1x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC_1x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC_1x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC_2x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC_2x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC_2x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC_2x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC_3x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC_3x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC_3x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC_3x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC_4x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC_4x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC_4x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC_4x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC_5x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC_5x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC_5x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC_5x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC_6x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC_6x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC_6x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC_6x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC_7x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC_7x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC_7x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC_7x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC_8x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC_8x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC_8x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC_8x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC_9x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC_9x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC_9x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC_9x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC_Ax): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC_Ax entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC_Ax>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC_Ax>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_RC_Bx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_RC_Bx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_RC_Bx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_RC_Bx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_RCD_MIRROR_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_RCD_MIRROR_MODE entry");
            AttributeTraits<ATTR_EFF_DIMM_RCD_MIRROR_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_RCD_MIRROR_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_SCHMOO_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_SCHMOO_MODE entry");
            AttributeTraits<ATTR_EFF_SCHMOO_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_SCHMOO_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_SCHMOO_ADDR_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_SCHMOO_ADDR_MODE entry");
            AttributeTraits<ATTR_EFF_SCHMOO_ADDR_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_SCHMOO_ADDR_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_SCHMOO_TEST_VALID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_SCHMOO_TEST_VALID entry");
            AttributeTraits<ATTR_EFF_SCHMOO_TEST_VALID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_SCHMOO_TEST_VALID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_SCHMOO_PARAM_VALID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_SCHMOO_PARAM_VALID entry");
            AttributeTraits<ATTR_EFF_SCHMOO_PARAM_VALID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_SCHMOO_PARAM_VALID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_SCHMOO_WR_EYE_MIN_MARGIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_SCHMOO_WR_EYE_MIN_MARGIN entry");
            AttributeTraits<ATTR_EFF_SCHMOO_WR_EYE_MIN_MARGIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_SCHMOO_WR_EYE_MIN_MARGIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_SCHMOO_RD_EYE_MIN_MARGIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_SCHMOO_RD_EYE_MIN_MARGIN entry");
            AttributeTraits<ATTR_EFF_SCHMOO_RD_EYE_MIN_MARGIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_SCHMOO_RD_EYE_MIN_MARGIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_SCHMOO_DQS_CLK_MIN_MARGIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_SCHMOO_DQS_CLK_MIN_MARGIN entry");
            AttributeTraits<ATTR_EFF_SCHMOO_DQS_CLK_MIN_MARGIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_SCHMOO_DQS_CLK_MIN_MARGIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_SCHMOO_RD_GATE_MIN_MARGIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_SCHMOO_RD_GATE_MIN_MARGIN entry");
            AttributeTraits<ATTR_EFF_SCHMOO_RD_GATE_MIN_MARGIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_SCHMOO_RD_GATE_MIN_MARGIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_SCHMOO_ADDR_CMD_MIN_MARGIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_SCHMOO_ADDR_CMD_MIN_MARGIN entry");
            AttributeTraits<ATTR_EFF_SCHMOO_ADDR_CMD_MIN_MARGIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_SCHMOO_ADDR_CMD_MIN_MARGIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_MEMCAL_INTERVAL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_MEMCAL_INTERVAL entry");
            AttributeTraits<ATTR_EFF_MEMCAL_INTERVAL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_MEMCAL_INTERVAL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_ZQCAL_INTERVAL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_ZQCAL_INTERVAL entry");
            AttributeTraits<ATTR_EFF_ZQCAL_INTERVAL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_ZQCAL_INTERVAL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_IBM_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_IBM_TYPE entry");
            AttributeTraits<ATTR_EFF_IBM_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_IBM_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_NUM_MASTER_RANKS_PER_DIMM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_NUM_MASTER_RANKS_PER_DIMM entry");
            AttributeTraits<ATTR_EFF_NUM_MASTER_RANKS_PER_DIMM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_NUM_MASTER_RANKS_PER_DIMM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_RANKS_CONFIGED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_RANKS_CONFIGED entry");
            AttributeTraits<ATTR_EFF_DIMM_RANKS_CONFIGED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_RANKS_CONFIGED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_PRIM_DIE_COUNT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_PRIM_DIE_COUNT entry");
            AttributeTraits<ATTR_EFF_PRIM_DIE_COUNT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_PRIM_DIE_COUNT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_MEM_THROTTLED_N_COMMANDS_PER_PORT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_MEM_THROTTLED_N_COMMANDS_PER_PORT entry");
            AttributeTraits<ATTR_MSS_MEM_THROTTLED_N_COMMANDS_PER_PORT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_MEM_THROTTLED_N_COMMANDS_PER_PORT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_MEM_PORT_POS_OF_FAIL_THROTTLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_MEM_PORT_POS_OF_FAIL_THROTTLE entry");
            AttributeTraits<ATTR_MSS_MEM_PORT_POS_OF_FAIL_THROTTLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_MEM_PORT_POS_OF_FAIL_THROTTLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_MEM_M_DRAM_CLOCKS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_MEM_M_DRAM_CLOCKS entry");
            AttributeTraits<ATTR_MSS_MEM_M_DRAM_CLOCKS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_MEM_M_DRAM_CLOCKS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_MEM_THROTTLED_N_COMMANDS_PER_SLOT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_MEM_THROTTLED_N_COMMANDS_PER_SLOT entry");
            AttributeTraits<ATTR_MSS_MEM_THROTTLED_N_COMMANDS_PER_SLOT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_MEM_THROTTLED_N_COMMANDS_PER_SLOT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_MEM_WATT_TARGET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_MEM_WATT_TARGET entry");
            AttributeTraits<ATTR_MSS_MEM_WATT_TARGET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_MEM_WATT_TARGET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_TOTAL_PWR_SLOPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_TOTAL_PWR_SLOPE entry");
            AttributeTraits<ATTR_MSS_TOTAL_PWR_SLOPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_TOTAL_PWR_SLOPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_TOTAL_PWR_INTERCEPT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_TOTAL_PWR_INTERCEPT entry");
            AttributeTraits<ATTR_MSS_TOTAL_PWR_INTERCEPT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_TOTAL_PWR_INTERCEPT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_DIMM_MAXBANDWIDTH_GBS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_DIMM_MAXBANDWIDTH_GBS entry");
            AttributeTraits<ATTR_MSS_DIMM_MAXBANDWIDTH_GBS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_DIMM_MAXBANDWIDTH_GBS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_DIMM_MAXBANDWIDTH_MRS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_DIMM_MAXBANDWIDTH_MRS entry");
            AttributeTraits<ATTR_MSS_DIMM_MAXBANDWIDTH_MRS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_DIMM_MAXBANDWIDTH_MRS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_CHANNEL_PAIR_MAXBANDWIDTH_GBS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CHANNEL_PAIR_MAXBANDWIDTH_GBS entry");
            AttributeTraits<ATTR_MSS_CHANNEL_PAIR_MAXBANDWIDTH_GBS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CHANNEL_PAIR_MAXBANDWIDTH_GBS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_CHANNEL_PAIR_MAXBANDWIDTH_MRS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CHANNEL_PAIR_MAXBANDWIDTH_MRS entry");
            AttributeTraits<ATTR_MSS_CHANNEL_PAIR_MAXBANDWIDTH_MRS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CHANNEL_PAIR_MAXBANDWIDTH_MRS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_DIMM_MAXPOWER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_DIMM_MAXPOWER entry");
            AttributeTraits<ATTR_MSS_DIMM_MAXPOWER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_DIMM_MAXPOWER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_DATABUS_UTIL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_DATABUS_UTIL entry");
            AttributeTraits<ATTR_MSS_DATABUS_UTIL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_DATABUS_UTIL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_PORT_MAXPOWER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_PORT_MAXPOWER entry");
            AttributeTraits<ATTR_MSS_PORT_MAXPOWER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_PORT_MAXPOWER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_DIMM_THERMAL_LIMIT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_DIMM_THERMAL_LIMIT entry");
            AttributeTraits<ATTR_MSS_DIMM_THERMAL_LIMIT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_DIMM_THERMAL_LIMIT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_PORT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_PORT entry");
            AttributeTraits<ATTR_MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_PORT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_PORT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_RUNTIME_MEM_M_DRAM_CLOCKS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_RUNTIME_MEM_M_DRAM_CLOCKS entry");
            AttributeTraits<ATTR_MSS_RUNTIME_MEM_M_DRAM_CLOCKS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_RUNTIME_MEM_M_DRAM_CLOCKS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_SLOT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_SLOT entry");
            AttributeTraits<ATTR_MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_SLOT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_SLOT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_EFF_DIMM_FUNCTIONAL_VECTOR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_EFF_DIMM_FUNCTIONAL_VECTOR entry");
            AttributeTraits<ATTR_MSS_EFF_DIMM_FUNCTIONAL_VECTOR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_EFF_DIMM_FUNCTIONAL_VECTOR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_LPASR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_LPASR entry");
            AttributeTraits<ATTR_EFF_DRAM_LPASR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_LPASR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_MPR_PAGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_MPR_PAGE entry");
            AttributeTraits<ATTR_EFF_MPR_PAGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_MPR_PAGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_GEARDOWN_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_GEARDOWN_MODE entry");
            AttributeTraits<ATTR_EFF_GEARDOWN_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_GEARDOWN_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_PER_DRAM_ACCESS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_PER_DRAM_ACCESS entry");
            AttributeTraits<ATTR_EFF_PER_DRAM_ACCESS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_PER_DRAM_ACCESS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_TEMP_READOUT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_TEMP_READOUT entry");
            AttributeTraits<ATTR_EFF_TEMP_READOUT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_TEMP_READOUT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_CRC_WR_LATENCY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_CRC_WR_LATENCY entry");
            AttributeTraits<ATTR_EFF_CRC_WR_LATENCY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_CRC_WR_LATENCY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_MPR_RD_FORMAT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_MPR_RD_FORMAT entry");
            AttributeTraits<ATTR_EFF_MPR_RD_FORMAT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_MPR_RD_FORMAT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_MAX_POWERDOWN_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_MAX_POWERDOWN_MODE entry");
            AttributeTraits<ATTR_EFF_MAX_POWERDOWN_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_MAX_POWERDOWN_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_INTERNAL_VREF_MONITOR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_INTERNAL_VREF_MONITOR entry");
            AttributeTraits<ATTR_EFF_INTERNAL_VREF_MONITOR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_INTERNAL_VREF_MONITOR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_CS_CMD_LATENCY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_CS_CMD_LATENCY entry");
            AttributeTraits<ATTR_EFF_CS_CMD_LATENCY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_CS_CMD_LATENCY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_SELF_REF_ABORT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_SELF_REF_ABORT entry");
            AttributeTraits<ATTR_EFF_SELF_REF_ABORT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_SELF_REF_ABORT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_RD_PREAMBLE_TRAIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_RD_PREAMBLE_TRAIN entry");
            AttributeTraits<ATTR_EFF_RD_PREAMBLE_TRAIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_RD_PREAMBLE_TRAIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_RD_PREAMBLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_RD_PREAMBLE entry");
            AttributeTraits<ATTR_EFF_RD_PREAMBLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_RD_PREAMBLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_WR_PREAMBLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_WR_PREAMBLE entry");
            AttributeTraits<ATTR_EFF_WR_PREAMBLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_WR_PREAMBLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_CA_PARITY_LATENCY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_CA_PARITY_LATENCY entry");
            AttributeTraits<ATTR_EFF_CA_PARITY_LATENCY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_CA_PARITY_LATENCY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_CRC_ERROR_CLEAR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_CRC_ERROR_CLEAR entry");
            AttributeTraits<ATTR_EFF_CRC_ERROR_CLEAR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_CRC_ERROR_CLEAR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_CA_PARITY_ERROR_STATUS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_CA_PARITY_ERROR_STATUS entry");
            AttributeTraits<ATTR_EFF_CA_PARITY_ERROR_STATUS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_CA_PARITY_ERROR_STATUS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_ODT_INPUT_BUFF): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_ODT_INPUT_BUFF entry");
            AttributeTraits<ATTR_EFF_ODT_INPUT_BUFF>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_ODT_INPUT_BUFF>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_CA_PARITY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_CA_PARITY entry");
            AttributeTraits<ATTR_EFF_CA_PARITY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_CA_PARITY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DATA_MASK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DATA_MASK entry");
            AttributeTraits<ATTR_EFF_DATA_MASK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DATA_MASK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_WRITE_DBI): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_WRITE_DBI entry");
            AttributeTraits<ATTR_EFF_WRITE_DBI>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_WRITE_DBI>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_READ_DBI): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_READ_DBI entry");
            AttributeTraits<ATTR_EFF_READ_DBI>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_READ_DBI>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_VREF_DQ_TRAIN_VALUE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_VREF_DQ_TRAIN_VALUE entry");
            AttributeTraits<ATTR_EFF_VREF_DQ_TRAIN_VALUE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_VREF_DQ_TRAIN_VALUE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_VREF_DQ_TRAIN_RANGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_VREF_DQ_TRAIN_RANGE entry");
            AttributeTraits<ATTR_EFF_VREF_DQ_TRAIN_RANGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_VREF_DQ_TRAIN_RANGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_VREF_DQ_TRAIN_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_VREF_DQ_TRAIN_ENABLE entry");
            AttributeTraits<ATTR_EFF_VREF_DQ_TRAIN_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_VREF_DQ_TRAIN_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_WRITE_CRC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_WRITE_CRC entry");
            AttributeTraits<ATTR_EFF_WRITE_CRC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_WRITE_CRC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_CAL_STEP_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CAL_STEP_ENABLE entry");
            AttributeTraits<ATTR_MSS_CAL_STEP_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CAL_STEP_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_CUSTOM_TRAINING_ADV_PATTERNS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CUSTOM_TRAINING_ADV_PATTERNS entry");
            AttributeTraits<ATTR_MSS_CUSTOM_TRAINING_ADV_PATTERNS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CUSTOM_TRAINING_ADV_PATTERNS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS entry");
            AttributeTraits<ATTR_MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS2 entry");
            AttributeTraits<ATTR_MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_CUSTOM_TRAINING_ADV_WR_PATTERN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CUSTOM_TRAINING_ADV_WR_PATTERN entry");
            AttributeTraits<ATTR_MSS_CUSTOM_TRAINING_ADV_WR_PATTERN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CUSTOM_TRAINING_ADV_WR_PATTERN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VREF_CAL_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VREF_CAL_ENABLE entry");
            AttributeTraits<ATTR_MSS_VREF_CAL_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VREF_CAL_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_RDVREF_CAL_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_RDVREF_CAL_ENABLE entry");
            AttributeTraits<ATTR_MSS_RDVREF_CAL_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_RDVREF_CAL_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_CAL_ABORT_ON_ERROR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CAL_ABORT_ON_ERROR entry");
            AttributeTraits<ATTR_MSS_CAL_ABORT_ON_ERROR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CAL_ABORT_ON_ERROR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_SLEW_RATE_DATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_SLEW_RATE_DATA entry");
            AttributeTraits<ATTR_MSS_SLEW_RATE_DATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_SLEW_RATE_DATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_SLEW_RATE_ADR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_SLEW_RATE_ADR entry");
            AttributeTraits<ATTR_MSS_SLEW_RATE_ADR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_SLEW_RATE_ADR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCHMOO_MULTIPLE_SETUP_CALL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCHMOO_MULTIPLE_SETUP_CALL entry");
            AttributeTraits<ATTR_SCHMOO_MULTIPLE_SETUP_CALL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCHMOO_MULTIPLE_SETUP_CALL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_BUFFER_LATENCY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_BUFFER_LATENCY entry");
            AttributeTraits<ATTR_EFF_BUFFER_LATENCY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_BUFFER_LATENCY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_LRDIMM_WORD_X): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_LRDIMM_WORD_X entry");
            AttributeTraits<ATTR_EFF_LRDIMM_WORD_X>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_LRDIMM_WORD_X>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_LRDIMM_MR12_REG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: LRDIMM_MR12_REG entry");
            AttributeTraits<ATTR_LRDIMM_MR12_REG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_LRDIMM_MR12_REG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_LRDIMM_ADDITIONAL_CNTL_WORDS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: LRDIMM_ADDITIONAL_CNTL_WORDS entry");
            AttributeTraits<ATTR_LRDIMM_ADDITIONAL_CNTL_WORDS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_LRDIMM_ADDITIONAL_CNTL_WORDS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_LRDIMM_RANK_MULT_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: LRDIMM_RANK_MULT_MODE entry");
            AttributeTraits<ATTR_LRDIMM_RANK_MULT_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_LRDIMM_RANK_MULT_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_EFF_VPD_VERSION): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_EFF_VPD_VERSION entry");
            AttributeTraits<ATTR_MSS_EFF_VPD_VERSION>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_EFF_VPD_VERSION>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_OVERRIDE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_OVERRIDE entry");
            AttributeTraits<ATTR_MSS_VOLT_OVERRIDE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_OVERRIDE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VDDR_OVERIDE_SPD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VDDR_OVERIDE_SPD entry");
            AttributeTraits<ATTR_MSS_VDDR_OVERIDE_SPD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VDDR_OVERIDE_SPD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VMEM_REGULATOR_MAX_DIMM_COUNT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VMEM_REGULATOR_MAX_DIMM_COUNT entry");
            AttributeTraits<ATTR_MSS_VMEM_REGULATOR_MAX_DIMM_COUNT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VMEM_REGULATOR_MAX_DIMM_COUNT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VREF_DAC_NIBBLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VREF_DAC_NIBBLE entry");
            AttributeTraits<ATTR_MSS_VREF_DAC_NIBBLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VREF_DAC_NIBBLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VCCD_OVERRIDE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VCCD_OVERRIDE entry");
            AttributeTraits<ATTR_MSS_VCCD_OVERRIDE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VCCD_OVERRIDE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_MAC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_MAC entry");
            AttributeTraits<ATTR_EFF_DRAM_MAC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_MAC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_MODULE_BUS_WIDTH): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_MODULE_BUS_WIDTH entry");
            AttributeTraits<ATTR_EFF_DRAM_MODULE_BUS_WIDTH>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_MODULE_BUS_WIDTH>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_RTT_NOM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_RTT_NOM entry");
            AttributeTraits<ATTR_EFF_DRAM_RTT_NOM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_RTT_NOM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_RTT_WR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_RTT_WR entry");
            AttributeTraits<ATTR_EFF_DRAM_RTT_WR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_RTT_WR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_RTT_PARK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_RTT_PARK entry");
            AttributeTraits<ATTR_EFF_DRAM_RTT_PARK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_RTT_PARK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC00): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC00 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC00>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC00>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC01): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC01 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC01>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC01>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC02): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC02 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC02>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC02>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC03): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC03 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC03>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC03>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC04): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC04 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC04>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC04>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC05): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC05 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC05>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC05>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC06): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC06 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC06>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC06>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC07): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC07 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC07>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC07>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC08): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC08 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC08>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC08>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC09): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC09 entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC09>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC09>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC0A): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC0A entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC0A>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC0A>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC0B): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC0B entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC0B>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC0B>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC0C): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC0C entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC0C>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC0C>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC0D): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC0D entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC0D>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC0D>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC0E): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC0E entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC0E>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC0E>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_BC0F): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_BC0F entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_BC0F>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_BC0F>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F0BC1x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F0BC1x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F0BC1x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F0BC1x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F30BC2x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F30BC2x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F30BC2x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F30BC2x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F30BC3x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F30BC3x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F30BC3x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F30BC3x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F30BC4x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F30BC4x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F30BC4x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F30BC4x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F30BC5x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F30BC5x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F30BC5x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F30BC5x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F0BC6x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F0BC6x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F0BC6x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F0BC6x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F70BC7x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F70BC7x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F70BC7x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F70BC7x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F30BC8x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F30BC8x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F30BC8x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F30BC8x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F30BC9x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F30BC9x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F30BC9x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F30BC9x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F30BCAx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F30BCAx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F30BCAx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F30BCAx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F30BCBx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F30BCBx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F30BCBx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F30BCBx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F0BCCx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F0BCCx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F0BCCx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F0BCCx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F0BCDx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F0BCDx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F0BCDx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F0BCDx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F0BCEx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F0BCEx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F0BCEx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F0BCEx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F0BCFx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F0BCFx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F0BCFx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F0BCFx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F1BCCx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F1BCCx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F1BCCx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F1BCCx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F1BCDx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F1BCDx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F1BCDx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F1BCDx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F1BCEx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F1BCEx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F1BCEx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F1BCEx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F1BCFx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F1BCFx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F1BCFx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F1BCFx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F2BCEx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F2BCEx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F2BCEx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F2BCEx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F4BC0x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F4BC0x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F4BC0x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F4BC0x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F4BC1x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F4BC1x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F4BC1x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F4BC1x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F4BC2x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F4BC2x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F4BC2x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F4BC2x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F4BC3x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F4BC3x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F4BC3x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F4BC3x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F4BC4x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F4BC4x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F4BC4x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F4BC4x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F4BC5x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F4BC5x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F4BC5x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F4BC5x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F4BC6x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F4BC6x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F4BC6x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F4BC6x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F5BC0x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F5BC0x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F5BC0x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F5BC0x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F5BC1x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F5BC1x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F5BC1x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F5BC1x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F5BC2x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F5BC2x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F5BC2x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F5BC2x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F5BC3x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F5BC3x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F5BC3x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F5BC3x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F5BC5x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F5BC5x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F5BC5x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F5BC5x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F5BC6x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F5BC6x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F5BC6x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F5BC6x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F6BC0x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F6BC0x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F6BC0x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F6BC0x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F6BC1x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F6BC1x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F6BC1x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F6BC1x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F6BC2x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F6BC2x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F6BC2x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F6BC2x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F6BC3x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F6BC3x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F6BC3x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F6BC3x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F6BC4x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F6BC4x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F6BC4x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F6BC4x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F6BC5x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F6BC5x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F6BC5x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F6BC5x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F74BC8x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F74BC8x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F74BC8x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F74BC8x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F74BC9x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F74BC9x entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F74BC9x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F74BC9x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F74BCAx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F74BCAx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F74BCAx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F74BCAx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F74BCBx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F74BCBx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F74BCBx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F74BCBx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F74BCCx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F74BCCx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F74BCCx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F74BCCx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F74BCDx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F74BCDx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F74BCDx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F74BCDx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F74BCEx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F74BCEx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F74BCEx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F74BCEx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DIMM_DDR4_F74BCFx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DIMM_DDR4_F74BCFx entry");
            AttributeTraits<ATTR_EFF_DIMM_DDR4_F74BCFx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DIMM_DDR4_F74BCFx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_RON): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_RON entry");
            AttributeTraits<ATTR_EFF_DRAM_RON>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_RON>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TDQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TDQS entry");
            AttributeTraits<ATTR_EFF_DRAM_TDQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TDQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_ODIC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_ODIC entry");
            AttributeTraits<ATTR_EFF_DRAM_ODIC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_ODIC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_LRDIMM_TRAINING_PATTERN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_LRDIMM_TRAINING_PATTERN entry");
            AttributeTraits<ATTR_MSS_LRDIMM_TRAINING_PATTERN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_LRDIMM_TRAINING_PATTERN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_EFF_ODT_RD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_EFF_ODT_RD entry");
            AttributeTraits<ATTR_MSS_EFF_ODT_RD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_EFF_ODT_RD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_EFF_ODT_WR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_EFF_ODT_WR entry");
            AttributeTraits<ATTR_MSS_EFF_ODT_WR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_EFF_ODT_WR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_EFF_DPHY_WLO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_EFF_DPHY_WLO entry");
            AttributeTraits<ATTR_MSS_EFF_DPHY_WLO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_EFF_DPHY_WLO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_EFF_DPHY_RLO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_EFF_DPHY_RLO entry");
            AttributeTraits<ATTR_MSS_EFF_DPHY_RLO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_EFF_DPHY_RLO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TREFI): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TREFI entry");
            AttributeTraits<ATTR_EFF_DRAM_TREFI>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TREFI>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TRTP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TRTP entry");
            AttributeTraits<ATTR_EFF_DRAM_TRTP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TRTP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TRFC_DLR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TRFC_DLR entry");
            AttributeTraits<ATTR_EFF_DRAM_TRFC_DLR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TRFC_DLR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TFAW_DLR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TFAW_DLR entry");
            AttributeTraits<ATTR_EFF_DRAM_TFAW_DLR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TFAW_DLR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TRRD_DLR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TRRD_DLR entry");
            AttributeTraits<ATTR_EFF_DRAM_TRRD_DLR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TRRD_DLR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_DRAM_TXS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_DRAM_TXS entry");
            AttributeTraits<ATTR_EFF_DRAM_TXS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_DRAM_TXS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_IGNORE_PLUG_RULES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_IGNORE_PLUG_RULES entry");
            AttributeTraits<ATTR_MSS_IGNORE_PLUG_RULES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_IGNORE_PLUG_RULES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_MVPD_FWMS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_MVPD_FWMS entry");
            AttributeTraits<ATTR_MSS_MVPD_FWMS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_MVPD_FWMS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_REORDER_QUEUE_SETTING): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_REORDER_QUEUE_SETTING entry");
            AttributeTraits<ATTR_MSS_REORDER_QUEUE_SETTING>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_REORDER_QUEUE_SETTING>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EFF_RANK_GROUP_OVERRIDE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFF_RANK_GROUP_OVERRIDE entry");
            AttributeTraits<ATTR_EFF_RANK_GROUP_OVERRIDE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFF_RANK_GROUP_OVERRIDE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_RTT_NOM_OVERRIDE_DISABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_RTT_NOM_OVERRIDE_DISABLE entry");
            AttributeTraits<ATTR_MSS_RTT_NOM_OVERRIDE_DISABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_RTT_NOM_OVERRIDE_DISABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_EFF_WR_CRC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_EFF_WR_CRC entry");
            AttributeTraits<ATTR_MSS_EFF_WR_CRC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_EFF_WR_CRC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_WR_VREF_OFFSET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_WR_VREF_OFFSET entry");
            AttributeTraits<ATTR_MSS_WR_VREF_OFFSET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_WR_VREF_OFFSET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SBE_NVDIMM_IN_PORT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SBE_NVDIMM_IN_PORT entry");
            AttributeTraits<ATTR_SBE_NVDIMM_IN_PORT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SBE_NVDIMM_IN_PORT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT8_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT8_1 entry");
            AttributeTraits<ATTR_SCRATCH_UINT8_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT8_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT8_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT8_2 entry");
            AttributeTraits<ATTR_SCRATCH_UINT8_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT8_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT16_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT16_1 entry");
            AttributeTraits<ATTR_SCRATCH_UINT16_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT16_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT16_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT16_2 entry");
            AttributeTraits<ATTR_SCRATCH_UINT16_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT16_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT32_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT32_1 entry");
            AttributeTraits<ATTR_SCRATCH_UINT32_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT32_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT32_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT32_2 entry");
            AttributeTraits<ATTR_SCRATCH_UINT32_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT32_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT64_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT64_1 entry");
            AttributeTraits<ATTR_SCRATCH_UINT64_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT64_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT64_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT64_2 entry");
            AttributeTraits<ATTR_SCRATCH_UINT64_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT64_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT8_ARRAY_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT8_ARRAY_1 entry");
            AttributeTraits<ATTR_SCRATCH_UINT8_ARRAY_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT8_ARRAY_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT8_ARRAY_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT8_ARRAY_2 entry");
            AttributeTraits<ATTR_SCRATCH_UINT8_ARRAY_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT8_ARRAY_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT16_ARRAY_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT16_ARRAY_1 entry");
            AttributeTraits<ATTR_SCRATCH_UINT16_ARRAY_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT16_ARRAY_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT16_ARRAY_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT16_ARRAY_2 entry");
            AttributeTraits<ATTR_SCRATCH_UINT16_ARRAY_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT16_ARRAY_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT32_ARRAY_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT32_ARRAY_1 entry");
            AttributeTraits<ATTR_SCRATCH_UINT32_ARRAY_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT32_ARRAY_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT32_ARRAY_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT32_ARRAY_2 entry");
            AttributeTraits<ATTR_SCRATCH_UINT32_ARRAY_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT32_ARRAY_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT64_ARRAY_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT64_ARRAY_1 entry");
            AttributeTraits<ATTR_SCRATCH_UINT64_ARRAY_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT64_ARRAY_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_UINT64_ARRAY_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_UINT64_ARRAY_2 entry");
            AttributeTraits<ATTR_SCRATCH_UINT64_ARRAY_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_UINT64_ARRAY_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT8_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT8_1 entry");
            AttributeTraits<ATTR_SCRATCH_INT8_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT8_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT8_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT8_2 entry");
            AttributeTraits<ATTR_SCRATCH_INT8_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT8_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT16_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT16_1 entry");
            AttributeTraits<ATTR_SCRATCH_INT16_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT16_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT16_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT16_2 entry");
            AttributeTraits<ATTR_SCRATCH_INT16_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT16_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT32_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT32_1 entry");
            AttributeTraits<ATTR_SCRATCH_INT32_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT32_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT32_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT32_2 entry");
            AttributeTraits<ATTR_SCRATCH_INT32_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT32_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT64_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT64_1 entry");
            AttributeTraits<ATTR_SCRATCH_INT64_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT64_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT64_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT64_2 entry");
            AttributeTraits<ATTR_SCRATCH_INT64_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT64_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT8_ARRAY_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT8_ARRAY_1 entry");
            AttributeTraits<ATTR_SCRATCH_INT8_ARRAY_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT8_ARRAY_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT8_ARRAY_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT8_ARRAY_2 entry");
            AttributeTraits<ATTR_SCRATCH_INT8_ARRAY_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT8_ARRAY_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT16_ARRAY_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT16_ARRAY_1 entry");
            AttributeTraits<ATTR_SCRATCH_INT16_ARRAY_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT16_ARRAY_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT16_ARRAY_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT16_ARRAY_2 entry");
            AttributeTraits<ATTR_SCRATCH_INT16_ARRAY_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT16_ARRAY_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT32_ARRAY_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT32_ARRAY_1 entry");
            AttributeTraits<ATTR_SCRATCH_INT32_ARRAY_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT32_ARRAY_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT32_ARRAY_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT32_ARRAY_2 entry");
            AttributeTraits<ATTR_SCRATCH_INT32_ARRAY_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT32_ARRAY_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT64_ARRAY_1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT64_ARRAY_1 entry");
            AttributeTraits<ATTR_SCRATCH_INT64_ARRAY_1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT64_ARRAY_1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCRATCH_INT64_ARRAY_2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCRATCH_INT64_ARRAY_2 entry");
            AttributeTraits<ATTR_SCRATCH_INT64_ARRAY_2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SCRATCH_INT64_ARRAY_2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FAPI_POS): { break; }
        case (ATTR_IS_SIMULATION): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IS_SIMULATION entry");
            AttributeTraits<ATTR_IS_SIMULATION>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IS_SIMULATION>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EXECUTION_PLATFORM): { break; }
        case (ATTR_MNFG_FLAGS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MNFG_FLAGS entry");
            AttributeTraits<ATTR_MNFG_FLAGS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MNFG_FLAGS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_RECONFIGURE_LOOP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: RECONFIGURE_LOOP entry");
            AttributeTraits<ATTR_RECONFIGURE_LOOP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_RECONFIGURE_LOOP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MINI_EC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MINI_EC entry");
            AttributeTraits<ATTR_MINI_EC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MINI_EC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IO_DMI_CEN_TX_MARGIN_RATIO): { break; }
        case (ATTR_IO_DMI_CEN_TX_FFE_POSTCURSOR): { break; }
        case (ATTR_CEN_DMI_REFCLOCK_RCVR_TERM): { break; }
        case (ATTR_CEN_DDR_REFCLOCK_RCVR_TERM): { break; }
        case (ATTR_CEN_MSS_DATABUS_UTIL_PER_MBA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_DATABUS_UTIL_PER_MBA entry");
            AttributeTraits<ATTR_CEN_MSS_DATABUS_UTIL_PER_MBA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_DATABUS_UTIL_PER_MBA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_DRAM_DEVICE_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_DRAM_DEVICE_TYPE entry");
            AttributeTraits<ATTR_CEN_SPD_DRAM_DEVICE_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_DRAM_DEVICE_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_MODULE_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_MODULE_TYPE entry");
            AttributeTraits<ATTR_CEN_SPD_MODULE_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_MODULE_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_CUSTOM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_CUSTOM entry");
            AttributeTraits<ATTR_CEN_SPD_CUSTOM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_CUSTOM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_SDRAM_DENSITY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_SDRAM_DENSITY entry");
            AttributeTraits<ATTR_CEN_SPD_SDRAM_DENSITY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_SDRAM_DENSITY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_SDRAM_BANKS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_SDRAM_BANKS entry");
            AttributeTraits<ATTR_CEN_SPD_SDRAM_BANKS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_SDRAM_BANKS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_SDRAM_ROWS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_SDRAM_ROWS entry");
            AttributeTraits<ATTR_CEN_SPD_SDRAM_ROWS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_SDRAM_ROWS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_SDRAM_COLUMNS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_SDRAM_COLUMNS entry");
            AttributeTraits<ATTR_CEN_SPD_SDRAM_COLUMNS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_SDRAM_COLUMNS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_MODULE_NOMINAL_VOLTAGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_MODULE_NOMINAL_VOLTAGE entry");
            AttributeTraits<ATTR_CEN_SPD_MODULE_NOMINAL_VOLTAGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_MODULE_NOMINAL_VOLTAGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_NUM_RANKS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_NUM_RANKS entry");
            AttributeTraits<ATTR_CEN_SPD_NUM_RANKS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_NUM_RANKS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_DRAM_WIDTH): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_DRAM_WIDTH entry");
            AttributeTraits<ATTR_CEN_SPD_DRAM_WIDTH>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_DRAM_WIDTH>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_MODULE_MEMORY_BUS_WIDTH): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_MODULE_MEMORY_BUS_WIDTH entry");
            AttributeTraits<ATTR_CEN_SPD_MODULE_MEMORY_BUS_WIDTH>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_MODULE_MEMORY_BUS_WIDTH>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TCKMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TCKMIN entry");
            AttributeTraits<ATTR_CEN_SPD_TCKMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TCKMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_CAS_LATENCIES_SUPPORTED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_CAS_LATENCIES_SUPPORTED entry");
            AttributeTraits<ATTR_CEN_SPD_CAS_LATENCIES_SUPPORTED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_CAS_LATENCIES_SUPPORTED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TAAMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TAAMIN entry");
            AttributeTraits<ATTR_CEN_SPD_TAAMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TAAMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TRCDMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TRCDMIN entry");
            AttributeTraits<ATTR_CEN_SPD_TRCDMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TRCDMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TRPMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TRPMIN entry");
            AttributeTraits<ATTR_CEN_SPD_TRPMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TRPMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TRASMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TRASMIN entry");
            AttributeTraits<ATTR_CEN_SPD_TRASMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TRASMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TRCMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TRCMIN entry");
            AttributeTraits<ATTR_CEN_SPD_TRCMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TRCMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TFAWMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TFAWMIN entry");
            AttributeTraits<ATTR_CEN_SPD_TFAWMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TFAWMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_SDRAM_OPTIONAL_FEATURES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_SDRAM_OPTIONAL_FEATURES entry");
            AttributeTraits<ATTR_CEN_SPD_SDRAM_OPTIONAL_FEATURES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_SDRAM_OPTIONAL_FEATURES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_SDRAM_THERMAL_AND_REFRESH_OPTIONS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_SDRAM_THERMAL_AND_REFRESH_OPTIONS entry");
            AttributeTraits<ATTR_CEN_SPD_SDRAM_THERMAL_AND_REFRESH_OPTIONS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_SDRAM_THERMAL_AND_REFRESH_OPTIONS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ROW_REPAIR_SPPR_SUPPORTED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ROW_REPAIR_SPPR_SUPPORTED entry");
            AttributeTraits<ATTR_ROW_REPAIR_SPPR_SUPPORTED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ROW_REPAIR_SPPR_SUPPORTED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_MODULE_THERMAL_SENSOR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_MODULE_THERMAL_SENSOR entry");
            AttributeTraits<ATTR_CEN_SPD_MODULE_THERMAL_SENSOR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_MODULE_THERMAL_SENSOR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_SDRAM_DEVICE_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_SDRAM_DEVICE_TYPE entry");
            AttributeTraits<ATTR_CEN_SPD_SDRAM_DEVICE_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_SDRAM_DEVICE_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_SDRAM_DEVICE_TYPE_SIGNAL_LOADING): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_SDRAM_DEVICE_TYPE_SIGNAL_LOADING entry");
            AttributeTraits<ATTR_CEN_SPD_SDRAM_DEVICE_TYPE_SIGNAL_LOADING>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_SDRAM_DEVICE_TYPE_SIGNAL_LOADING>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_SDRAM_DIE_COUNT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_SDRAM_DIE_COUNT entry");
            AttributeTraits<ATTR_CEN_SPD_SDRAM_DIE_COUNT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_SDRAM_DIE_COUNT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_FINE_OFFSET_TCKMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_FINE_OFFSET_TCKMIN entry");
            AttributeTraits<ATTR_CEN_SPD_FINE_OFFSET_TCKMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_FINE_OFFSET_TCKMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_FINE_OFFSET_TAAMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_FINE_OFFSET_TAAMIN entry");
            AttributeTraits<ATTR_CEN_SPD_FINE_OFFSET_TAAMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_FINE_OFFSET_TAAMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_FINE_OFFSET_TRCDMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_FINE_OFFSET_TRCDMIN entry");
            AttributeTraits<ATTR_CEN_SPD_FINE_OFFSET_TRCDMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_FINE_OFFSET_TRCDMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_FINE_OFFSET_TRPMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_FINE_OFFSET_TRPMIN entry");
            AttributeTraits<ATTR_CEN_SPD_FINE_OFFSET_TRPMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_FINE_OFFSET_TRPMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_FINE_OFFSET_TRCMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_FINE_OFFSET_TRCMIN entry");
            AttributeTraits<ATTR_CEN_SPD_FINE_OFFSET_TRCMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_FINE_OFFSET_TRCMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURERS_JEDEC_ID_CODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_MODULE_ID_MODULE_MANUFACTURERS_JEDEC_ID_CODE entry");
            AttributeTraits<ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURERS_JEDEC_ID_CODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURERS_JEDEC_ID_CODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_LOCATION): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_LOCATION entry");
            AttributeTraits<ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_LOCATION>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_LOCATION>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_DATE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_DATE entry");
            AttributeTraits<ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_DATE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_DATE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_MODULE_ID_MODULE_SERIAL_NUMBER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_MODULE_ID_MODULE_SERIAL_NUMBER entry");
            AttributeTraits<ATTR_CEN_SPD_MODULE_ID_MODULE_SERIAL_NUMBER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_MODULE_ID_MODULE_SERIAL_NUMBER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_MODULE_PART_NUMBER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_MODULE_PART_NUMBER entry");
            AttributeTraits<ATTR_CEN_SPD_MODULE_PART_NUMBER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_MODULE_PART_NUMBER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_MODULE_REVISION_CODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_MODULE_REVISION_CODE entry");
            AttributeTraits<ATTR_CEN_SPD_MODULE_REVISION_CODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_MODULE_REVISION_CODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_DRAM_MANUFACTURER_JEDEC_ID_CODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_DRAM_MANUFACTURER_JEDEC_ID_CODE entry");
            AttributeTraits<ATTR_CEN_SPD_DRAM_MANUFACTURER_JEDEC_ID_CODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_DRAM_MANUFACTURER_JEDEC_ID_CODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_BAD_DQ_DATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_BAD_DQ_DATA entry");
            AttributeTraits<ATTR_CEN_SPD_BAD_DQ_DATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_BAD_DQ_DATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_FTB_DIVIDEND): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_FTB_DIVIDEND entry");
            AttributeTraits<ATTR_CEN_SPD_FTB_DIVIDEND>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_FTB_DIVIDEND>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_FTB_DIVISOR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_FTB_DIVISOR entry");
            AttributeTraits<ATTR_CEN_SPD_FTB_DIVISOR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_FTB_DIVISOR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_MTB_DIVIDEND): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_MTB_DIVIDEND entry");
            AttributeTraits<ATTR_CEN_SPD_MTB_DIVIDEND>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_MTB_DIVIDEND>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_MTB_DIVISOR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_MTB_DIVISOR entry");
            AttributeTraits<ATTR_CEN_SPD_MTB_DIVISOR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_MTB_DIVISOR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TWRMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TWRMIN entry");
            AttributeTraits<ATTR_CEN_SPD_TWRMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TWRMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TRRDMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TRRDMIN entry");
            AttributeTraits<ATTR_CEN_SPD_TRRDMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TRRDMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TRFCMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TRFCMIN entry");
            AttributeTraits<ATTR_CEN_SPD_TRFCMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TRFCMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TWTRMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TWTRMIN entry");
            AttributeTraits<ATTR_CEN_SPD_TWTRMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TWTRMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TRTPMIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TRTPMIN entry");
            AttributeTraits<ATTR_CEN_SPD_TRTPMIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TRTPMIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_SDRAM_BANKGROUPS_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_SDRAM_BANKGROUPS_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_SDRAM_BANKGROUPS_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_SDRAM_BANKGROUPS_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TIMEBASE_MTB_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TIMEBASE_MTB_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_TIMEBASE_MTB_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TIMEBASE_MTB_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TIMEBASE_FTB_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TIMEBASE_FTB_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_TIMEBASE_FTB_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TIMEBASE_FTB_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TCKMAX_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TCKMAX_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_TCKMAX_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TCKMAX_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TRFC1MIN_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TRFC1MIN_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_TRFC1MIN_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TRFC1MIN_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TRFC2MIN_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TRFC2MIN_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_TRFC2MIN_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TRFC2MIN_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TRFC4MIN_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TRFC4MIN_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_TRFC4MIN_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TRFC4MIN_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TRRDSMIN_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TRRDSMIN_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_TRRDSMIN_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TRRDSMIN_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TRRDLMIN_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TRRDLMIN_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_TRRDLMIN_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TRRDLMIN_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_TCCDLMIN_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_TCCDLMIN_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_TCCDLMIN_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_TCCDLMIN_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_FINE_OFFSET_TCCDLMIN_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_FINE_OFFSET_TCCDLMIN_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_FINE_OFFSET_TCCDLMIN_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_FINE_OFFSET_TCCDLMIN_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_FINE_OFFSET_TRRDLMIN_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_FINE_OFFSET_TRRDLMIN_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_FINE_OFFSET_TRRDLMIN_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_FINE_OFFSET_TRRDLMIN_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_FINE_OFFSET_TRRDSMIN_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_FINE_OFFSET_TRRDSMIN_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_FINE_OFFSET_TRRDSMIN_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_FINE_OFFSET_TRRDSMIN_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_FINE_OFFSET_TCKMAX_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_FINE_OFFSET_TCKMAX_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_FINE_OFFSET_TCKMAX_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_FINE_OFFSET_TCKMAX_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_CRC_BASE_CONFIG_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_CRC_BASE_CONFIG_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_CRC_BASE_CONFIG_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_CRC_BASE_CONFIG_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_DRAM_STEPPING_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_DRAM_STEPPING_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_DRAM_STEPPING_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_DRAM_STEPPING_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_CRC_MNFG_SEC_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_CRC_MNFG_SEC_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_CRC_MNFG_SEC_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_CRC_MNFG_SEC_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_ADDR_MAP_REG_TO_DRAM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_ADDR_MAP_REG_TO_DRAM entry");
            AttributeTraits<ATTR_CEN_SPD_ADDR_MAP_REG_TO_DRAM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_ADDR_MAP_REG_TO_DRAM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SPD_MODULE_REVISION_CODE_DDR4): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SPD_MODULE_REVISION_CODE_DDR4 entry");
            AttributeTraits<ATTR_CEN_SPD_MODULE_REVISION_CODE_DDR4>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SPD_MODULE_REVISION_CODE_DDR4>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_ISDIMM_MBVPD_INDEX): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_ISDIMM_MBVPD_INDEX entry");
            AttributeTraits<ATTR_CEN_ISDIMM_MBVPD_INDEX>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_ISDIMM_MBVPD_INDEX>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_DQ_TO_DIMM_CONN_DQ): { break; }
        case (ATTR_CEN_MBA_PORT): { break; }
        case (ATTR_CEN_MBA_DIMM): { break; }
        case (ATTR_CEN_MBVPD_VERSION): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MBVPD_VERSION entry");
            AttributeTraits<ATTR_CEN_MBVPD_VERSION>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MBVPD_VERSION>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_ADDR_MODES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_ADDR_MODES entry");
            AttributeTraits<ATTR_CEN_MCBIST_ADDR_MODES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_ADDR_MODES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_RANK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_RANK entry");
            AttributeTraits<ATTR_CEN_MCBIST_RANK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_RANK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_START_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_START_ADDR entry");
            AttributeTraits<ATTR_CEN_MCBIST_START_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_START_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_END_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_END_ADDR entry");
            AttributeTraits<ATTR_CEN_MCBIST_END_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_END_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_ERROR_CAPTURE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_ERROR_CAPTURE entry");
            AttributeTraits<ATTR_CEN_MCBIST_ERROR_CAPTURE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_ERROR_CAPTURE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_MAX_TIMEOUT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_MAX_TIMEOUT entry");
            AttributeTraits<ATTR_CEN_MCBIST_MAX_TIMEOUT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_MAX_TIMEOUT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_PRINT_PORT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_PRINT_PORT entry");
            AttributeTraits<ATTR_CEN_MCBIST_PRINT_PORT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_PRINT_PORT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_STOP_ON_ERROR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_STOP_ON_ERROR entry");
            AttributeTraits<ATTR_CEN_MCBIST_STOP_ON_ERROR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_STOP_ON_ERROR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_DATA_SEED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_DATA_SEED entry");
            AttributeTraits<ATTR_CEN_MCBIST_DATA_SEED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_DATA_SEED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_ADDR_INTER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_ADDR_INTER entry");
            AttributeTraits<ATTR_CEN_MCBIST_ADDR_INTER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_ADDR_INTER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_ADDR_NUM_ROWS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_ADDR_NUM_ROWS entry");
            AttributeTraits<ATTR_CEN_MCBIST_ADDR_NUM_ROWS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_ADDR_NUM_ROWS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_ADDR_NUM_COLS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_ADDR_NUM_COLS entry");
            AttributeTraits<ATTR_CEN_MCBIST_ADDR_NUM_COLS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_ADDR_NUM_COLS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_ADDR_RANK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_ADDR_RANK entry");
            AttributeTraits<ATTR_CEN_MCBIST_ADDR_RANK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_ADDR_RANK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_ADDR_BANK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_ADDR_BANK entry");
            AttributeTraits<ATTR_CEN_MCBIST_ADDR_BANK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_ADDR_BANK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_ADDR_SLAVE_RANK_ON): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_ADDR_SLAVE_RANK_ON entry");
            AttributeTraits<ATTR_CEN_MCBIST_ADDR_SLAVE_RANK_ON>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_ADDR_SLAVE_RANK_ON>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_ADDR_STR_MAP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_ADDR_STR_MAP entry");
            AttributeTraits<ATTR_CEN_MCBIST_ADDR_STR_MAP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_ADDR_STR_MAP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_ADDR_RAND): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_ADDR_RAND entry");
            AttributeTraits<ATTR_CEN_MCBIST_ADDR_RAND>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_ADDR_RAND>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_ADDRESS_MIRRORING): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_ADDRESS_MIRRORING entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_ADDRESS_MIRRORING>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_ADDRESS_MIRRORING>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_FREQ_OVERRIDE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_FREQ_OVERRIDE entry");
            AttributeTraits<ATTR_CEN_MSS_FREQ_OVERRIDE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_FREQ_OVERRIDE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_FREQ): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_FREQ entry");
            AttributeTraits<ATTR_CEN_MSS_FREQ>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_FREQ>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_FREQ_BIAS_PERCENTAGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_FREQ_BIAS_PERCENTAGE entry");
            AttributeTraits<ATTR_CEN_MSS_FREQ_BIAS_PERCENTAGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_FREQ_BIAS_PERCENTAGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_VREF_CAL_CNTL): { break; }
        case (ATTR_CEN_MSS_VREF_CAL_DELTA_FROM_NOMINAL): { break; }
        case (ATTR_CEN_EFF_DIMM_RANKS_CONFIGED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_RANKS_CONFIGED entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_RANKS_CONFIGED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_RANKS_CONFIGED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_NUM_RANKS_PER_DIMM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_NUM_RANKS_PER_DIMM entry");
            AttributeTraits<ATTR_CEN_EFF_NUM_RANKS_PER_DIMM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_NUM_RANKS_PER_DIMM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_TYPE entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CUSTOM_DIMM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CUSTOM_DIMM entry");
            AttributeTraits<ATTR_CEN_EFF_CUSTOM_DIMM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CUSTOM_DIMM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_WIDTH): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_WIDTH entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_WIDTH>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_WIDTH>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_GEN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_GEN entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_GEN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_GEN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_PRIMARY_RANK_GROUP0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_PRIMARY_RANK_GROUP0 entry");
            AttributeTraits<ATTR_CEN_EFF_PRIMARY_RANK_GROUP0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_PRIMARY_RANK_GROUP0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_PRIMARY_RANK_GROUP1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_PRIMARY_RANK_GROUP1 entry");
            AttributeTraits<ATTR_CEN_EFF_PRIMARY_RANK_GROUP1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_PRIMARY_RANK_GROUP1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_PRIMARY_RANK_GROUP2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_PRIMARY_RANK_GROUP2 entry");
            AttributeTraits<ATTR_CEN_EFF_PRIMARY_RANK_GROUP2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_PRIMARY_RANK_GROUP2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_PRIMARY_RANK_GROUP3): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_PRIMARY_RANK_GROUP3 entry");
            AttributeTraits<ATTR_CEN_EFF_PRIMARY_RANK_GROUP3>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_PRIMARY_RANK_GROUP3>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SECONDARY_RANK_GROUP0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SECONDARY_RANK_GROUP0 entry");
            AttributeTraits<ATTR_CEN_EFF_SECONDARY_RANK_GROUP0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SECONDARY_RANK_GROUP0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SECONDARY_RANK_GROUP1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SECONDARY_RANK_GROUP1 entry");
            AttributeTraits<ATTR_CEN_EFF_SECONDARY_RANK_GROUP1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SECONDARY_RANK_GROUP1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SECONDARY_RANK_GROUP2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SECONDARY_RANK_GROUP2 entry");
            AttributeTraits<ATTR_CEN_EFF_SECONDARY_RANK_GROUP2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SECONDARY_RANK_GROUP2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SECONDARY_RANK_GROUP3): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SECONDARY_RANK_GROUP3 entry");
            AttributeTraits<ATTR_CEN_EFF_SECONDARY_RANK_GROUP3>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SECONDARY_RANK_GROUP3>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_TERTIARY_RANK_GROUP0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_TERTIARY_RANK_GROUP0 entry");
            AttributeTraits<ATTR_CEN_EFF_TERTIARY_RANK_GROUP0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_TERTIARY_RANK_GROUP0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_TERTIARY_RANK_GROUP1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_TERTIARY_RANK_GROUP1 entry");
            AttributeTraits<ATTR_CEN_EFF_TERTIARY_RANK_GROUP1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_TERTIARY_RANK_GROUP1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_TERTIARY_RANK_GROUP2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_TERTIARY_RANK_GROUP2 entry");
            AttributeTraits<ATTR_CEN_EFF_TERTIARY_RANK_GROUP2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_TERTIARY_RANK_GROUP2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_TERTIARY_RANK_GROUP3): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_TERTIARY_RANK_GROUP3 entry");
            AttributeTraits<ATTR_CEN_EFF_TERTIARY_RANK_GROUP3>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_TERTIARY_RANK_GROUP3>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_QUATERNARY_RANK_GROUP0): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_QUATERNARY_RANK_GROUP0 entry");
            AttributeTraits<ATTR_CEN_EFF_QUATERNARY_RANK_GROUP0>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_QUATERNARY_RANK_GROUP0>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_QUATERNARY_RANK_GROUP1): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_QUATERNARY_RANK_GROUP1 entry");
            AttributeTraits<ATTR_CEN_EFF_QUATERNARY_RANK_GROUP1>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_QUATERNARY_RANK_GROUP1>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_QUATERNARY_RANK_GROUP2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_QUATERNARY_RANK_GROUP2 entry");
            AttributeTraits<ATTR_CEN_EFF_QUATERNARY_RANK_GROUP2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_QUATERNARY_RANK_GROUP2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_QUATERNARY_RANK_GROUP3): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_QUATERNARY_RANK_GROUP3 entry");
            AttributeTraits<ATTR_CEN_EFF_QUATERNARY_RANK_GROUP3>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_QUATERNARY_RANK_GROUP3>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_WR_VREF): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_WR_VREF entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_WR_VREF>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_WR_VREF>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_WR_VREF_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_WR_VREF_SCHMOO entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_WR_VREF_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_WR_VREF_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_DRV_IMP_DQ_DQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_DRV_IMP_DQ_DQS entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_DRV_IMP_DQ_DQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_DRV_IMP_DQ_DQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_DRV_IMP_DQ_DQS_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_DRV_IMP_DQ_DQS_SCHMOO entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_DRV_IMP_DQ_DQS_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_DRV_IMP_DQ_DQS_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_SLEW_RATE_DQ_DQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_SLEW_RATE_DQ_DQS entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_SLEW_RATE_DQ_DQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_SLEW_RATE_DQ_DQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_DRV_IMP_CLK_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_DRV_IMP_CLK_SCHMOO entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_DRV_IMP_CLK_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_DRV_IMP_CLK_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_DRV_IMP_SPCKE_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_DRV_IMP_SPCKE_SCHMOO entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_DRV_IMP_SPCKE_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_DRV_IMP_SPCKE_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_DRV_IMP_CNTL_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_DRV_IMP_CNTL_SCHMOO entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_DRV_IMP_CNTL_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_DRV_IMP_CNTL_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_RCV_IMP_DQ_DQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_RCV_IMP_DQ_DQS entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_RCV_IMP_DQ_DQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_RCV_IMP_DQ_DQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_RCV_IMP_DQ_DQS_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_RCV_IMP_DQ_DQS_SCHMOO entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_RCV_IMP_DQ_DQS_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_RCV_IMP_DQ_DQS_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_SLEW_RATE_DQ_DQS_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_SLEW_RATE_DQ_DQS_SCHMOO entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_SLEW_RATE_DQ_DQS_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_SLEW_RATE_DQ_DQS_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_SLEW_RATE_CLK_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_SLEW_RATE_CLK_SCHMOO entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_SLEW_RATE_CLK_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_SLEW_RATE_CLK_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_SLEW_RATE_SPCKE_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_SLEW_RATE_SPCKE_SCHMOO entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_SLEW_RATE_SPCKE_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_SLEW_RATE_SPCKE_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_SLEW_RATE_ADDR_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_SLEW_RATE_ADDR_SCHMOO entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_SLEW_RATE_ADDR_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_SLEW_RATE_ADDR_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_SLEW_RATE_CNTL_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_SLEW_RATE_CNTL_SCHMOO entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_SLEW_RATE_CNTL_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_SLEW_RATE_CNTL_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_RD_VREF): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_RD_VREF entry");
            AttributeTraits<ATTR_CEN_EFF_RD_VREF>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_RD_VREF>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CEN_RD_VREF_SCHMOO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CEN_RD_VREF_SCHMOO entry");
            AttributeTraits<ATTR_CEN_EFF_CEN_RD_VREF_SCHMOO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CEN_RD_VREF_SCHMOO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_SIZE entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_BANKS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_BANKS entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_BANKS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_BANKS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_ROWS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_ROWS entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_ROWS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_ROWS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_COLS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_COLS entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_COLS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_COLS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_DENSITY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_DENSITY entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_DENSITY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_DENSITY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TRCD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TRCD entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TRCD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TRCD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TRRD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TRRD entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TRRD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TRRD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TRRD_L): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TRRD_L entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TRRD_L>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TRRD_L>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TRP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TRP entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TRP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TRP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TRAS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TRAS entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TRAS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TRAS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TRC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TRC entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TRC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TRC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TRFI): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TRFI entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TRFI>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TRFI>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TRFC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TRFC entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TRFC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TRFC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TWTR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TWTR entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TWTR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TWTR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TWTR_L): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TWTR_L entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TWTR_L>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TWTR_L>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TRTP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TRTP entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TRTP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TRTP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TFAW): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TFAW entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TFAW>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TFAW>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_BL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_BL entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_BL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_BL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_CL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_CL entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_CL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_CL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_AL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_AL entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_AL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_AL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_CWL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_CWL entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_CWL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_CWL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_RBT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_RBT entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_RBT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_RBT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TM entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_DLL_RESET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_DLL_RESET entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_DLL_RESET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_DLL_RESET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_WR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_WR entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_WR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_WR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_DLL_PPD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_DLL_PPD entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_DLL_PPD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_DLL_PPD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_DLL_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_DLL_ENABLE entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_DLL_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_DLL_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TDQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TDQS entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TDQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TDQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_WR_LVL_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_WR_LVL_ENABLE entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_WR_LVL_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_WR_LVL_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_OUTPUT_BUFFER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_OUTPUT_BUFFER entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_OUTPUT_BUFFER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_OUTPUT_BUFFER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_PASR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_PASR entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_PASR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_PASR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_ASR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_ASR entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_ASR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_ASR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_SRT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_SRT entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_SRT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_SRT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_MPR_LOC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_MPR_LOC entry");
            AttributeTraits<ATTR_CEN_EFF_MPR_LOC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_MPR_LOC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_MPR_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_MPR_MODE entry");
            AttributeTraits<ATTR_CEN_EFF_MPR_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_MPR_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_RCD_CNTL_WORD_0_15): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_RCD_CNTL_WORD_0_15 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_RCD_CNTL_WORD_0_15>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_RCD_CNTL_WORD_0_15>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC00): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC00 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC00>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC00>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC01): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC01 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC01>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC01>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC02): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC02 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC02>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC02>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC03): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC03 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC03>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC03>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC04): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC04 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC04>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC04>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC05): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC05 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC05>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC05>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC06_07): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC06_07 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC06_07>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC06_07>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC08): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC08 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC08>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC08>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC09): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC09 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC09>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC09>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC10): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC10 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC10>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC10>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC11): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC11 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC11>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC11>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC12): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC12 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC12>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC12>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC13): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC13 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC13>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC13>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC14): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC14 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC14>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC14>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC15): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC15 entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC15>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC15>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC_1x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC_1x entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC_1x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC_1x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC_2x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC_2x entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC_2x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC_2x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC_3x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC_3x entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC_3x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC_3x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC_4x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC_4x entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC_4x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC_4x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC_5x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC_5x entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC_5x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC_5x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC_6x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC_6x entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC_6x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC_6x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC_7x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC_7x entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC_7x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC_7x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC_8x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC_8x entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC_8x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC_8x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC_9x): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC_9x entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC_9x>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC_9x>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC_Ax): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC_Ax entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC_Ax>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC_Ax>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DIMM_DDR4_RC_Bx): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DIMM_DDR4_RC_Bx entry");
            AttributeTraits<ATTR_CEN_EFF_DIMM_DDR4_RC_Bx>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DIMM_DDR4_RC_Bx>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SCHMOO_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SCHMOO_MODE entry");
            AttributeTraits<ATTR_CEN_EFF_SCHMOO_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SCHMOO_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SCHMOO_ADDR_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SCHMOO_ADDR_MODE entry");
            AttributeTraits<ATTR_CEN_EFF_SCHMOO_ADDR_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SCHMOO_ADDR_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SCHMOO_TEST_VALID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SCHMOO_TEST_VALID entry");
            AttributeTraits<ATTR_CEN_EFF_SCHMOO_TEST_VALID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SCHMOO_TEST_VALID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SCHMOO_PARAM_VALID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SCHMOO_PARAM_VALID entry");
            AttributeTraits<ATTR_CEN_EFF_SCHMOO_PARAM_VALID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SCHMOO_PARAM_VALID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SCHMOO_VREF_STEP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SCHMOO_VREF_STEP entry");
            AttributeTraits<ATTR_CEN_EFF_SCHMOO_VREF_STEP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SCHMOO_VREF_STEP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SCHMOO_WR_EYE_MIN_MARGIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SCHMOO_WR_EYE_MIN_MARGIN entry");
            AttributeTraits<ATTR_CEN_EFF_SCHMOO_WR_EYE_MIN_MARGIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SCHMOO_WR_EYE_MIN_MARGIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SCHMOO_RD_EYE_MIN_MARGIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SCHMOO_RD_EYE_MIN_MARGIN entry");
            AttributeTraits<ATTR_CEN_EFF_SCHMOO_RD_EYE_MIN_MARGIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SCHMOO_RD_EYE_MIN_MARGIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SCHMOO_DQS_CLK_MIN_MARGIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SCHMOO_DQS_CLK_MIN_MARGIN entry");
            AttributeTraits<ATTR_CEN_EFF_SCHMOO_DQS_CLK_MIN_MARGIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SCHMOO_DQS_CLK_MIN_MARGIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SCHMOO_RD_GATE_MIN_MARGIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SCHMOO_RD_GATE_MIN_MARGIN entry");
            AttributeTraits<ATTR_CEN_EFF_SCHMOO_RD_GATE_MIN_MARGIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SCHMOO_RD_GATE_MIN_MARGIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SCHMOO_ADDR_CMD_MIN_MARGIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SCHMOO_ADDR_CMD_MIN_MARGIN entry");
            AttributeTraits<ATTR_CEN_EFF_SCHMOO_ADDR_CMD_MIN_MARGIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SCHMOO_ADDR_CMD_MIN_MARGIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_MEMCAL_INTERVAL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_MEMCAL_INTERVAL entry");
            AttributeTraits<ATTR_CEN_EFF_MEMCAL_INTERVAL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_MEMCAL_INTERVAL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_ZQCAL_INTERVAL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_ZQCAL_INTERVAL entry");
            AttributeTraits<ATTR_CEN_EFF_ZQCAL_INTERVAL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_ZQCAL_INTERVAL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_IBM_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_IBM_TYPE entry");
            AttributeTraits<ATTR_CEN_EFF_IBM_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_IBM_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_NUM_DROPS_PER_PORT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_NUM_DROPS_PER_PORT entry");
            AttributeTraits<ATTR_CEN_EFF_NUM_DROPS_PER_PORT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_NUM_DROPS_PER_PORT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_STACK_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_STACK_TYPE entry");
            AttributeTraits<ATTR_CEN_EFF_STACK_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_STACK_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_NUM_MASTER_RANKS_PER_DIMM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_NUM_MASTER_RANKS_PER_DIMM entry");
            AttributeTraits<ATTR_CEN_EFF_NUM_MASTER_RANKS_PER_DIMM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_NUM_MASTER_RANKS_PER_DIMM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_NUM_PACKAGES_PER_RANK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_NUM_PACKAGES_PER_RANK entry");
            AttributeTraits<ATTR_CEN_EFF_NUM_PACKAGES_PER_RANK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_NUM_PACKAGES_PER_RANK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_NUM_DIES_PER_PACKAGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_NUM_DIES_PER_PACKAGE entry");
            AttributeTraits<ATTR_CEN_EFF_NUM_DIES_PER_PACKAGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_NUM_DIES_PER_PACKAGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_MBA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_MBA entry");
            AttributeTraits<ATTR_CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_MBA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_MBA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_MEM_THROTTLE_DENOMINATOR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_MEM_THROTTLE_DENOMINATOR entry");
            AttributeTraits<ATTR_CEN_MSS_MEM_THROTTLE_DENOMINATOR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_MEM_THROTTLE_DENOMINATOR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_CHIP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_CHIP entry");
            AttributeTraits<ATTR_CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_CHIP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_CHIP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_MEM_WATT_TARGET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_MEM_WATT_TARGET entry");
            AttributeTraits<ATTR_CEN_MSS_MEM_WATT_TARGET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_MEM_WATT_TARGET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_POWER_SLOPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_POWER_SLOPE entry");
            AttributeTraits<ATTR_CEN_MSS_POWER_SLOPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_POWER_SLOPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_POWER_SLOPE2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_POWER_SLOPE2 entry");
            AttributeTraits<ATTR_CEN_MSS_POWER_SLOPE2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_POWER_SLOPE2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_POWER_INT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_POWER_INT entry");
            AttributeTraits<ATTR_CEN_MSS_POWER_INT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_POWER_INT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_POWER_INT2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_POWER_INT2 entry");
            AttributeTraits<ATTR_CEN_MSS_POWER_INT2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_POWER_INT2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_TOTAL_POWER_SLOPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_TOTAL_POWER_SLOPE entry");
            AttributeTraits<ATTR_CEN_MSS_TOTAL_POWER_SLOPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_TOTAL_POWER_SLOPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_TOTAL_POWER_SLOPE2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_TOTAL_POWER_SLOPE2 entry");
            AttributeTraits<ATTR_CEN_MSS_TOTAL_POWER_SLOPE2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_TOTAL_POWER_SLOPE2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_TOTAL_POWER_INT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_TOTAL_POWER_INT entry");
            AttributeTraits<ATTR_CEN_MSS_TOTAL_POWER_INT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_TOTAL_POWER_INT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_TOTAL_POWER_INT2): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_TOTAL_POWER_INT2 entry");
            AttributeTraits<ATTR_CEN_MSS_TOTAL_POWER_INT2>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_TOTAL_POWER_INT2>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_CHANNEL_PAIR_MAXPOWER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_CHANNEL_PAIR_MAXPOWER entry");
            AttributeTraits<ATTR_CEN_MSS_CHANNEL_PAIR_MAXPOWER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_CHANNEL_PAIR_MAXPOWER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_MBA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_MBA entry");
            AttributeTraits<ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_MBA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_MBA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_DENOMINATOR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_RUNTIME_MEM_THROTTLE_DENOMINATOR entry");
            AttributeTraits<ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_DENOMINATOR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_DENOMINATOR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_CHIP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_CHIP entry");
            AttributeTraits<ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_CHIP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_CHIP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MRW_SAFEMODE_MEM_THROTTLE_NUMERATOR_PER_MBA): { break; }
        case (ATTR_CEN_MRW_SAFEMODE_MEM_THROTTLE_NUMERATOR_PER_CHIP): { break; }
        case (ATTR_CEN_MSS_DERIVED_MBA_ADDR_INTERLEAVE_BIT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_DERIVED_MBA_ADDR_INTERLEAVE_BIT entry");
            AttributeTraits<ATTR_CEN_MSS_DERIVED_MBA_ADDR_INTERLEAVE_BIT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_DERIVED_MBA_ADDR_INTERLEAVE_BIT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_DERIVED_MBA_CACHELINE_INTERLEAVE_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_DERIVED_MBA_CACHELINE_INTERLEAVE_MODE entry");
            AttributeTraits<ATTR_CEN_MSS_DERIVED_MBA_CACHELINE_INTERLEAVE_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_DERIVED_MBA_CACHELINE_INTERLEAVE_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MRW_MBA_CACHELINE_INTERLEAVE_MODE_CONTROL): { break; }
        case (ATTR_CEN_MSS_CACHE_ENABLE): { break; }
        case (ATTR_CEN_MSS_PREFETCH_ENABLE): { break; }
        case (ATTR_CEN_MSS_CLEANER_ENABLE): { break; }
        case (ATTR_CEN_MSS_EFF_DIMM_FUNCTIONAL_VECTOR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_EFF_DIMM_FUNCTIONAL_VECTOR entry");
            AttributeTraits<ATTR_CEN_MSS_EFF_DIMM_FUNCTIONAL_VECTOR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_EFF_DIMM_FUNCTIONAL_VECTOR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_LPASR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_LPASR entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_LPASR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_LPASR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_MPR_PAGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_MPR_PAGE entry");
            AttributeTraits<ATTR_CEN_EFF_MPR_PAGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_MPR_PAGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_GEARDOWN_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_GEARDOWN_MODE entry");
            AttributeTraits<ATTR_CEN_EFF_GEARDOWN_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_GEARDOWN_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_PER_DRAM_ACCESS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_PER_DRAM_ACCESS entry");
            AttributeTraits<ATTR_CEN_EFF_PER_DRAM_ACCESS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_PER_DRAM_ACCESS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_TEMP_READOUT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_TEMP_READOUT entry");
            AttributeTraits<ATTR_CEN_EFF_TEMP_READOUT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_TEMP_READOUT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_FINE_REFRESH_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_FINE_REFRESH_MODE entry");
            AttributeTraits<ATTR_CEN_EFF_FINE_REFRESH_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_FINE_REFRESH_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CRC_WR_LATENCY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CRC_WR_LATENCY entry");
            AttributeTraits<ATTR_CEN_EFF_CRC_WR_LATENCY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CRC_WR_LATENCY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_MPR_RD_FORMAT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_MPR_RD_FORMAT entry");
            AttributeTraits<ATTR_CEN_EFF_MPR_RD_FORMAT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_MPR_RD_FORMAT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_MAX_POWERDOWN_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_MAX_POWERDOWN_MODE entry");
            AttributeTraits<ATTR_CEN_EFF_MAX_POWERDOWN_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_MAX_POWERDOWN_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_TEMP_REF_RANGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_TEMP_REF_RANGE entry");
            AttributeTraits<ATTR_CEN_EFF_TEMP_REF_RANGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_TEMP_REF_RANGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_TEMP_REF_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_TEMP_REF_MODE entry");
            AttributeTraits<ATTR_CEN_EFF_TEMP_REF_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_TEMP_REF_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_INT_VREF_MON): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_INT_VREF_MON entry");
            AttributeTraits<ATTR_CEN_EFF_INT_VREF_MON>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_INT_VREF_MON>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CS_CMD_LATENCY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CS_CMD_LATENCY entry");
            AttributeTraits<ATTR_CEN_EFF_CS_CMD_LATENCY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CS_CMD_LATENCY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_SELF_REF_ABORT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_SELF_REF_ABORT entry");
            AttributeTraits<ATTR_CEN_EFF_SELF_REF_ABORT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_SELF_REF_ABORT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_RD_PREAMBLE_TRAIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_RD_PREAMBLE_TRAIN entry");
            AttributeTraits<ATTR_CEN_EFF_RD_PREAMBLE_TRAIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_RD_PREAMBLE_TRAIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_RD_PREAMBLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_RD_PREAMBLE entry");
            AttributeTraits<ATTR_CEN_EFF_RD_PREAMBLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_RD_PREAMBLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_WR_PREAMBLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_WR_PREAMBLE entry");
            AttributeTraits<ATTR_CEN_EFF_WR_PREAMBLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_WR_PREAMBLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CA_PARITY_LATENCY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CA_PARITY_LATENCY entry");
            AttributeTraits<ATTR_CEN_EFF_CA_PARITY_LATENCY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CA_PARITY_LATENCY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CRC_ERROR_CLEAR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CRC_ERROR_CLEAR entry");
            AttributeTraits<ATTR_CEN_EFF_CRC_ERROR_CLEAR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CRC_ERROR_CLEAR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CA_PARITY_ERROR_STATUS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CA_PARITY_ERROR_STATUS entry");
            AttributeTraits<ATTR_CEN_EFF_CA_PARITY_ERROR_STATUS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CA_PARITY_ERROR_STATUS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_ODT_INPUT_BUFF): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_ODT_INPUT_BUFF entry");
            AttributeTraits<ATTR_CEN_EFF_ODT_INPUT_BUFF>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_ODT_INPUT_BUFF>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_CA_PARITY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_CA_PARITY entry");
            AttributeTraits<ATTR_CEN_EFF_CA_PARITY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_CA_PARITY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DATA_MASK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DATA_MASK entry");
            AttributeTraits<ATTR_CEN_EFF_DATA_MASK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DATA_MASK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_WRITE_DBI): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_WRITE_DBI entry");
            AttributeTraits<ATTR_CEN_EFF_WRITE_DBI>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_WRITE_DBI>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_READ_DBI): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_READ_DBI entry");
            AttributeTraits<ATTR_CEN_EFF_READ_DBI>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_READ_DBI>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_VREF_DQ_TRAIN_VALUE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_VREF_DQ_TRAIN_VALUE entry");
            AttributeTraits<ATTR_CEN_EFF_VREF_DQ_TRAIN_VALUE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_VREF_DQ_TRAIN_VALUE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_VREF_DQ_TRAIN_RANGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_VREF_DQ_TRAIN_RANGE entry");
            AttributeTraits<ATTR_CEN_EFF_VREF_DQ_TRAIN_RANGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_VREF_DQ_TRAIN_RANGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_VREF_DQ_TRAIN_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_VREF_DQ_TRAIN_ENABLE entry");
            AttributeTraits<ATTR_CEN_EFF_VREF_DQ_TRAIN_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_VREF_DQ_TRAIN_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_DRAM_TCCD_L): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_DRAM_TCCD_L entry");
            AttributeTraits<ATTR_CEN_EFF_DRAM_TCCD_L>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_DRAM_TCCD_L>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_TCCD_L): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_TCCD_L entry");
            AttributeTraits<ATTR_CEN_TCCD_L>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_TCCD_L>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_EFF_WRITE_CRC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_EFF_WRITE_CRC entry");
            AttributeTraits<ATTR_CEN_EFF_WRITE_CRC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_EFF_WRITE_CRC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_CAL_STEP_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_CAL_STEP_ENABLE entry");
            AttributeTraits<ATTR_CEN_MSS_CAL_STEP_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_CAL_STEP_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_DRAMINIT_RESET_DISABLE): { break; }
        case (ATTR_CEN_MSS_SLEW_RATE_DATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_SLEW_RATE_DATA entry");
            AttributeTraits<ATTR_CEN_MSS_SLEW_RATE_DATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_SLEW_RATE_DATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_SLEW_RATE_ADR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_SLEW_RATE_ADR entry");
            AttributeTraits<ATTR_CEN_MSS_SLEW_RATE_ADR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_SLEW_RATE_ADR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_ALLOW_SINGLE_PORT): { break; }
        case (ATTR_CEN_MSS_DQS_SWIZZLE_TYPE): { break; }
        case (ATTR_CEN_MSS_PSRO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_PSRO entry");
            AttributeTraits<ATTR_CEN_MSS_PSRO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_PSRO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_NWELL_MISPLACEMENT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_NWELL_MISPLACEMENT entry");
            AttributeTraits<ATTR_CEN_MSS_NWELL_MISPLACEMENT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_NWELL_MISPLACEMENT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_BLUEWATERFALL_BROKEN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_BLUEWATERFALL_BROKEN entry");
            AttributeTraits<ATTR_CEN_MSS_BLUEWATERFALL_BROKEN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_BLUEWATERFALL_BROKEN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_PATTERN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_PATTERN entry");
            AttributeTraits<ATTR_CEN_MCBIST_PATTERN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_PATTERN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_TEST_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_TEST_TYPE entry");
            AttributeTraits<ATTR_CEN_MCBIST_TEST_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_TEST_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_PRINTING_DISABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_PRINTING_DISABLE entry");
            AttributeTraits<ATTR_CEN_MCBIST_PRINTING_DISABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_PRINTING_DISABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_DATA_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_DATA_ENABLE entry");
            AttributeTraits<ATTR_CEN_MCBIST_DATA_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_DATA_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_USER_RANK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_USER_RANK entry");
            AttributeTraits<ATTR_CEN_MCBIST_USER_RANK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_USER_RANK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_USER_BANK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_USER_BANK entry");
            AttributeTraits<ATTR_CEN_MCBIST_USER_BANK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_USER_BANK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_SCHMOO_MULTIPLE_SETUP_CALL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_SCHMOO_MULTIPLE_SETUP_CALL entry");
            AttributeTraits<ATTR_CEN_SCHMOO_MULTIPLE_SETUP_CALL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_SCHMOO_MULTIPLE_SETUP_CALL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_LRDIMM_RANK_MULT_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_LRDIMM_RANK_MULT_MODE entry");
            AttributeTraits<ATTR_CEN_LRDIMM_RANK_MULT_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_LRDIMM_RANK_MULT_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_THROTTLE_CONTROL_RAS_WEIGHT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_THROTTLE_CONTROL_RAS_WEIGHT entry");
            AttributeTraits<ATTR_CEN_MSS_THROTTLE_CONTROL_RAS_WEIGHT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_THROTTLE_CONTROL_RAS_WEIGHT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_THROTTLE_CONTROL_CAS_WEIGHT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_THROTTLE_CONTROL_CAS_WEIGHT entry");
            AttributeTraits<ATTR_CEN_MSS_THROTTLE_CONTROL_CAS_WEIGHT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_THROTTLE_CONTROL_CAS_WEIGHT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_RANDOM_SEED_VALUE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_RANDOM_SEED_VALUE entry");
            AttributeTraits<ATTR_CEN_MCBIST_RANDOM_SEED_VALUE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_RANDOM_SEED_VALUE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MCBIST_RANDOM_SEED_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MCBIST_RANDOM_SEED_TYPE entry");
            AttributeTraits<ATTR_CEN_MCBIST_RANDOM_SEED_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MCBIST_RANDOM_SEED_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_INIT_STATE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_INIT_STATE entry");
            AttributeTraits<ATTR_CEN_MSS_INIT_STATE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_INIT_STATE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_EFF_VPD_VERSION): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_EFF_VPD_VERSION entry");
            AttributeTraits<ATTR_CEN_MSS_EFF_VPD_VERSION>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_EFF_VPD_VERSION>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_NEST_CAPABLE_FREQUENCIES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_NEST_CAPABLE_FREQUENCIES entry");
            AttributeTraits<ATTR_CEN_MSS_NEST_CAPABLE_FREQUENCIES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_NEST_CAPABLE_FREQUENCIES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MRW_STRICT_MBA_PLUG_RULE_CHECKING): { break; }
        case (ATTR_CEN_MRW_CDIMM_MASTER_I2C_TEMP_SENSOR_ENABLE): { break; }
        case (ATTR_CEN_MRW_CDIMM_SPARE_I2C_TEMP_SENSOR_ENABLE): { break; }
        case (ATTR_CEN_MRW_THERMAL_MEMORY_POWER_LIMIT): { break; }
        case (ATTR_CEN_MRW_POWER_CONTROL_REQUESTED): { break; }
        case (ATTR_CEN_MSS_DDR3_VDDR_SLOPE): { break; }
        case (ATTR_CEN_MSS_DDR3_VDDR_INTERCEPT): { break; }
        case (ATTR_CEN_MSS_DDR4_VDDR_SLOPE): { break; }
        case (ATTR_CEN_MSS_DDR4_VDDR_INTERCEPT): { break; }
        case (ATTR_CEN_MSS_VOLT_OVERRIDE): { break; }
        case (ATTR_CEN_MSS_VOLT_COMPLIANT_DIMMS): { break; }
        case (ATTR_CEN_MRW_MCS_PREFETCH_RETRY_THRESHOLD): { break; }
        case (ATTR_CEN_MRW_DDR3_VDDR_MAX_LIMIT): { break; }
        case (ATTR_CEN_MRW_DDR4_VDDR_MAX_LIMIT): { break; }
        case (ATTR_MRW_MEM_SENSOR_CACHE_ADDR_MAP): { break; }
        case (ATTR_CEN_MRW_WR_VREF_CHECK_VREF_STEP_SIZE): { break; }
        case (ATTR_MEM_DRAM_CWL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DRAM_CWL entry");
            AttributeTraits<ATTR_MEM_DRAM_CWL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DRAM_CWL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_RDIMM_BUFFER_DELAY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_RDIMM_BUFFER_DELAY entry");
            AttributeTraits<ATTR_MEM_RDIMM_BUFFER_DELAY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_RDIMM_BUFFER_DELAY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_REORDER_QUEUE_SETTING): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_REORDER_QUEUE_SETTING entry");
            AttributeTraits<ATTR_MEM_REORDER_QUEUE_SETTING>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_REORDER_QUEUE_SETTING>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_2N_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_2N_MODE entry");
            AttributeTraits<ATTR_MEM_2N_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_2N_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_VPD_DQ_MAP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_VPD_DQ_MAP entry");
            AttributeTraits<ATTR_MEM_VPD_DQ_MAP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_VPD_DQ_MAP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_DDR4_F0RC0F): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_DDR4_F0RC0F entry");
            AttributeTraits<ATTR_MEM_DIMM_DDR4_F0RC0F>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_DDR4_F0RC0F>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_CS_CMD_LATENCY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_CS_CMD_LATENCY entry");
            AttributeTraits<ATTR_MEM_CS_CMD_LATENCY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_CS_CMD_LATENCY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_CA_PARITY_LATENCY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_CA_PARITY_LATENCY entry");
            AttributeTraits<ATTR_MEM_CA_PARITY_LATENCY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_CA_PARITY_LATENCY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_DDR4_F0RC02): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_DDR4_F0RC02 entry");
            AttributeTraits<ATTR_MEM_DIMM_DDR4_F0RC02>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_DDR4_F0RC02>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_DDR4_F0RC03): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_DDR4_F0RC03 entry");
            AttributeTraits<ATTR_MEM_DIMM_DDR4_F0RC03>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_DDR4_F0RC03>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_DDR4_F0RC04): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_DDR4_F0RC04 entry");
            AttributeTraits<ATTR_MEM_DIMM_DDR4_F0RC04>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_DDR4_F0RC04>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_DDR4_F0RC05): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_DDR4_F0RC05 entry");
            AttributeTraits<ATTR_MEM_DIMM_DDR4_F0RC05>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_DDR4_F0RC05>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_DDR4_F0RC0B): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_DDR4_F0RC0B entry");
            AttributeTraits<ATTR_MEM_DIMM_DDR4_F0RC0B>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_DDR4_F0RC0B>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_DDR4_F0RC1X): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_DDR4_F0RC1X entry");
            AttributeTraits<ATTR_MEM_DIMM_DDR4_F0RC1X>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_DDR4_F0RC1X>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_DDR4_F0RC7X): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_DDR4_F0RC7X entry");
            AttributeTraits<ATTR_MEM_DIMM_DDR4_F0RC7X>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_DDR4_F0RC7X>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_DDR4_F1RC00): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_DDR4_F1RC00 entry");
            AttributeTraits<ATTR_MEM_DIMM_DDR4_F1RC00>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_DDR4_F1RC00>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_DDR4_F1RC02): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_DDR4_F1RC02 entry");
            AttributeTraits<ATTR_MEM_DIMM_DDR4_F1RC02>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_DDR4_F1RC02>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_DDR4_F1RC03): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_DDR4_F1RC03 entry");
            AttributeTraits<ATTR_MEM_DIMM_DDR4_F1RC03>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_DDR4_F1RC03>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_DDR4_F1RC04): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_DDR4_F1RC04 entry");
            AttributeTraits<ATTR_MEM_DIMM_DDR4_F1RC04>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_DDR4_F1RC04>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_DDR4_F1RC05): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_DDR4_F1RC05 entry");
            AttributeTraits<ATTR_MEM_DIMM_DDR4_F1RC05>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_DDR4_F1RC05>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_POS_METADATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_POS_METADATA entry");
            AttributeTraits<ATTR_MEM_DIMM_POS_METADATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_POS_METADATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DRAM_GEN_METADATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DRAM_GEN_METADATA entry");
            AttributeTraits<ATTR_MEM_DRAM_GEN_METADATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DRAM_GEN_METADATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_DIMM_TYPE_METADATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_DIMM_TYPE_METADATA entry");
            AttributeTraits<ATTR_MEM_DIMM_TYPE_METADATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_DIMM_TYPE_METADATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_SIGNATURE_HASH): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_SIGNATURE_HASH entry");
            AttributeTraits<ATTR_MEM_SI_SIGNATURE_HASH>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_SIGNATURE_HASH>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_DIMM_RCD_IBT_CA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_DIMM_RCD_IBT_CA entry");
            AttributeTraits<ATTR_MEM_SI_DIMM_RCD_IBT_CA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_DIMM_RCD_IBT_CA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_DIMM_RCD_IBT_CKE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_DIMM_RCD_IBT_CKE entry");
            AttributeTraits<ATTR_MEM_SI_DIMM_RCD_IBT_CKE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_DIMM_RCD_IBT_CKE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_DIMM_RCD_IBT_CS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_DIMM_RCD_IBT_CS entry");
            AttributeTraits<ATTR_MEM_SI_DIMM_RCD_IBT_CS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_DIMM_RCD_IBT_CS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_DIMM_RCD_IBT_ODT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_DIMM_RCD_IBT_ODT entry");
            AttributeTraits<ATTR_MEM_SI_DIMM_RCD_IBT_ODT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_DIMM_RCD_IBT_ODT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_DRAM_DRV_IMP_DQ_DQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_DRAM_DRV_IMP_DQ_DQS entry");
            AttributeTraits<ATTR_MEM_SI_DRAM_DRV_IMP_DQ_DQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_DRAM_DRV_IMP_DQ_DQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_DRAM_PREAMBLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_DRAM_PREAMBLE entry");
            AttributeTraits<ATTR_MEM_SI_DRAM_PREAMBLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_DRAM_PREAMBLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_DRAM_RTT_NOM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_DRAM_RTT_NOM entry");
            AttributeTraits<ATTR_MEM_SI_DRAM_RTT_NOM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_DRAM_RTT_NOM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_DRAM_RTT_PARK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_DRAM_RTT_PARK entry");
            AttributeTraits<ATTR_MEM_SI_DRAM_RTT_PARK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_DRAM_RTT_PARK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_DRAM_RTT_WR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_DRAM_RTT_WR entry");
            AttributeTraits<ATTR_MEM_SI_DRAM_RTT_WR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_DRAM_RTT_WR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_VREF_DQ_TRAIN_VALUE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_VREF_DQ_TRAIN_VALUE entry");
            AttributeTraits<ATTR_MEM_SI_VREF_DQ_TRAIN_VALUE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_VREF_DQ_TRAIN_VALUE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_VREF_DQ_TRAIN_RANGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_VREF_DQ_TRAIN_RANGE entry");
            AttributeTraits<ATTR_MEM_SI_VREF_DQ_TRAIN_RANGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_VREF_DQ_TRAIN_RANGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_GEARDOWN_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_GEARDOWN_MODE entry");
            AttributeTraits<ATTR_MEM_SI_GEARDOWN_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_GEARDOWN_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_DRV_DQ_DQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_DRV_DQ_DQS entry");
            AttributeTraits<ATTR_MEM_SI_MC_DRV_DQ_DQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_DRV_DQ_DQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_RCV_EQ_DQ_DQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_RCV_EQ_DQ_DQS entry");
            AttributeTraits<ATTR_MEM_SI_MC_RCV_EQ_DQ_DQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_RCV_EQ_DQ_DQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_DRV_EQ_DQ_DQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_DRV_EQ_DQ_DQS entry");
            AttributeTraits<ATTR_MEM_SI_MC_DRV_EQ_DQ_DQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_DRV_EQ_DQ_DQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_DRV_IMP_CLK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_DRV_IMP_CLK entry");
            AttributeTraits<ATTR_MEM_SI_MC_DRV_IMP_CLK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_DRV_IMP_CLK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_DRV_IMP_CMD_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_DRV_IMP_CMD_ADDR entry");
            AttributeTraits<ATTR_MEM_SI_MC_DRV_IMP_CMD_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_DRV_IMP_CMD_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_DRV_IMP_CNTL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_DRV_IMP_CNTL entry");
            AttributeTraits<ATTR_MEM_SI_MC_DRV_IMP_CNTL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_DRV_IMP_CNTL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_DRV_IMP_CSCID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_DRV_IMP_CSCID entry");
            AttributeTraits<ATTR_MEM_SI_MC_DRV_IMP_CSCID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_DRV_IMP_CSCID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_DOWN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_DOWN entry");
            AttributeTraits<ATTR_MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_DOWN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_DOWN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_UP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_UP entry");
            AttributeTraits<ATTR_MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_UP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_UP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_DRV_SLEW_RATE_CLK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_DRV_SLEW_RATE_CLK entry");
            AttributeTraits<ATTR_MEM_SI_MC_DRV_SLEW_RATE_CLK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_DRV_SLEW_RATE_CLK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_DRV_SLEW_RATE_CMD_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_DRV_SLEW_RATE_CMD_ADDR entry");
            AttributeTraits<ATTR_MEM_SI_MC_DRV_SLEW_RATE_CMD_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_DRV_SLEW_RATE_CMD_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_DRV_SLEW_RATE_CNTL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_DRV_SLEW_RATE_CNTL entry");
            AttributeTraits<ATTR_MEM_SI_MC_DRV_SLEW_RATE_CNTL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_DRV_SLEW_RATE_CNTL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_DRV_SLEW_RATE_CSCID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_DRV_SLEW_RATE_CSCID entry");
            AttributeTraits<ATTR_MEM_SI_MC_DRV_SLEW_RATE_CSCID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_DRV_SLEW_RATE_CSCID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_DRV_SLEW_RATE_DQ_DQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_DRV_SLEW_RATE_DQ_DQS entry");
            AttributeTraits<ATTR_MEM_SI_MC_DRV_SLEW_RATE_DQ_DQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_DRV_SLEW_RATE_DQ_DQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_RCV_IMP_ALERT_N): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_RCV_IMP_ALERT_N entry");
            AttributeTraits<ATTR_MEM_SI_MC_RCV_IMP_ALERT_N>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_RCV_IMP_ALERT_N>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_MC_RCV_IMP_DQ_DQS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_MC_RCV_IMP_DQ_DQS entry");
            AttributeTraits<ATTR_MEM_SI_MC_RCV_IMP_DQ_DQS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_MC_RCV_IMP_DQ_DQS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_ODT_RD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_ODT_RD entry");
            AttributeTraits<ATTR_MEM_SI_ODT_RD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_ODT_RD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_ODT_WR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_ODT_WR entry");
            AttributeTraits<ATTR_MEM_SI_ODT_WR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_ODT_WR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_VREF_DRAM_WR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_VREF_DRAM_WR entry");
            AttributeTraits<ATTR_MEM_SI_VREF_DRAM_WR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_VREF_DRAM_WR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_VREF_MC_RD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_VREF_MC_RD entry");
            AttributeTraits<ATTR_MEM_SI_VREF_MC_RD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_VREF_MC_RD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_SI_WINDAGE_RD_CTR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_SI_WINDAGE_RD_CTR entry");
            AttributeTraits<ATTR_MEM_SI_WINDAGE_RD_CTR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_SI_WINDAGE_RD_CTR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_MRW_SUPPORTED_FREQ): { break; }
        case (ATTR_MEM_MRW_IS_PLANAR): { break; }
        case (ATTR_MSS_MRW_SAFEMODE_MEM_THROTTLED_N_COMMANDS_PER_PORT): { break; }
        case (ATTR_MSS_MRW_THERMAL_MEMORY_POWER_LIMIT): { break; }
        case (ATTR_MSS_MRW_PWR_INTERCEPT): { break; }
        case (ATTR_MSS_MRW_PWR_SLOPE): { break; }
        case (ATTR_MSS_MRW_REFRESH_RATE_REQUEST): { break; }
        case (ATTR_MSS_MRW_DIMM_POWER_CURVE_PERCENT_UPLIFT): { break; }
        case (ATTR_MSS_MRW_DIMM_POWER_CURVE_PERCENT_UPLIFT_IDLE): { break; }
        case (ATTR_MSS_MRW_MEM_M_DRAM_CLOCKS): { break; }
        case (ATTR_MSS_MRW_MAX_DRAM_DATABUS_UTIL): { break; }
        case (ATTR_MSS_MRW_POWER_CONTROL_REQUESTED): { break; }
        case (ATTR_MSS_MRW_IDLE_POWER_CONTROL_REQUESTED): { break; }
        case (ATTR_MSS_MRW_VMEM_REGULATOR_POWER_LIMIT_PER_DIMM_ADJ_ENABLE): { break; }
        case (ATTR_MRW_VMEM_REGULATOR_MEMORY_POWER_LIMIT_PER_DIMM_DDR3): { break; }
        case (ATTR_MRW_VMEM_REGULATOR_MEMORY_POWER_LIMIT_PER_DIMM_DDR4): { break; }
        case (ATTR_MSS_MRW_MAX_NUMBER_DIMMS_POSSIBLE_PER_VMEM_REGULATOR): { break; }
        case (ATTR_MSS_MRW_AVDD_OFFSET_ENABLE): { break; }
        case (ATTR_MSS_MRW_VDD_OFFSET_ENABLE): { break; }
        case (ATTR_MSS_MRW_VCS_OFFSET_ENABLE): { break; }
        case (ATTR_MSS_MRW_VPP_OFFSET_ENABLE): { break; }
        case (ATTR_MSS_MRW_VDDR_OFFSET_ENABLE): { break; }
        case (ATTR_MSS_MRW_FINE_REFRESH_MODE): { break; }
        case (ATTR_MSS_MRW_TEMP_REFRESH_RANGE): { break; }
        case (ATTR_MSS_MRW_RESET_DELAY_BEFORE_CAL): { break; }
        case (ATTR_MSS_MRW_PERIODIC_MEMCAL_MODE_OPTIONS): { break; }
        case (ATTR_MSS_MRW_PERIODIC_ZQCAL_MODE_OPTIONS): { break; }
        case (ATTR_MSS_MRW_DRAM_2N_MODE): { break; }
        case (ATTR_MSS_MRW_DRAM_WRITE_CRC): { break; }
        case (ATTR_MSS_MRW_TEMP_REFRESH_MODE): { break; }
        case (ATTR_MSS_MRW_FORCE_BCMODE_OFF): { break; }
        case (ATTR_MSS_MRW_NVDIMM_PLUG_RULES): { break; }
        case (ATTR_MSS_MRW_ALLOW_UNSUPPORTED_RCW): { break; }
        case (ATTR_MSS_MRW_SUPPORTED_DRAM_WIDTH): { break; }
        case (ATTR_MEM_EFF_DRAM_GEN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_GEN entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_GEN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_GEN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DIMM_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DIMM_TYPE entry");
            AttributeTraits<ATTR_MEM_EFF_DIMM_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DIMM_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_HYBRID_MEMORY_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_HYBRID_MEMORY_TYPE entry");
            AttributeTraits<ATTR_MEM_EFF_HYBRID_MEMORY_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_HYBRID_MEMORY_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_HYBRID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_HYBRID entry");
            AttributeTraits<ATTR_MEM_EFF_HYBRID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_HYBRID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_HOST_TO_DDR_SPEED_RATIO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_HOST_TO_DDR_SPEED_RATIO entry");
            AttributeTraits<ATTR_MEM_EFF_HOST_TO_DDR_SPEED_RATIO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_HOST_TO_DDR_SPEED_RATIO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_DENSITY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_DENSITY entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_DENSITY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_DENSITY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_BANK_BITS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_BANK_BITS entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_BANK_BITS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_BANK_BITS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_BANK_GROUP_BITS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_BANK_GROUP_BITS entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_BANK_GROUP_BITS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_BANK_GROUP_BITS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_COLUMN_BITS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_COLUMN_BITS entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_COLUMN_BITS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_COLUMN_BITS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_ROW_BITS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_ROW_BITS entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_ROW_BITS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_ROW_BITS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_PRIM_STACK_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_PRIM_STACK_TYPE entry");
            AttributeTraits<ATTR_MEM_EFF_PRIM_STACK_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_PRIM_STACK_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_PPR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_PPR entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_PPR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_PPR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_SOFT_PPR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_SOFT_PPR entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_SOFT_PPR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_SOFT_PPR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TRCD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TRCD entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TRCD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TRCD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TRP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TRP entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TRP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TRP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TRAS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TRAS entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TRAS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TRAS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TRC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TRC entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TRC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TRC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TRFC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TRFC entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TRFC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TRFC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TFAW): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TFAW entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TFAW>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TFAW>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TRRD_S): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TRRD_S entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TRRD_S>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TRRD_S>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TRRD_L): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TRRD_L entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TRRD_L>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TRRD_L>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TRRD_DLR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TRRD_DLR entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TRRD_DLR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TRRD_DLR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TCCD_L): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TCCD_L entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TCCD_L>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TCCD_L>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TWR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TWR entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TWR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TWR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TWTR_S): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TWTR_S entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TWTR_S>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TWTR_S>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TWTR_L): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TWTR_L entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TWTR_L>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TWTR_L>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TMAW): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TMAW entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TMAW>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TMAW>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_WIDTH): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_WIDTH entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_WIDTH>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_WIDTH>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_NUM_RANKS_PER_DIMM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_NUM_RANKS_PER_DIMM entry");
            AttributeTraits<ATTR_MEM_EFF_NUM_RANKS_PER_DIMM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_NUM_RANKS_PER_DIMM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_REGISTER_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_REGISTER_TYPE entry");
            AttributeTraits<ATTR_MEM_EFF_REGISTER_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_REGISTER_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_MFG_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_MFG_ID entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_MFG_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_MFG_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_RCD_MFG_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_RCD_MFG_ID entry");
            AttributeTraits<ATTR_MEM_EFF_RCD_MFG_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_RCD_MFG_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_REGISTER_REV): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_REGISTER_REV entry");
            AttributeTraits<ATTR_MEM_EFF_REGISTER_REV>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_REGISTER_REV>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_PACKAGE_RANK_MAP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_PACKAGE_RANK_MAP entry");
            AttributeTraits<ATTR_MEM_EFF_PACKAGE_RANK_MAP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_PACKAGE_RANK_MAP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_NIBBLE_MAP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_NIBBLE_MAP entry");
            AttributeTraits<ATTR_MEM_EFF_NIBBLE_MAP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_NIBBLE_MAP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DIMM_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DIMM_SIZE entry");
            AttributeTraits<ATTR_MEM_EFF_DIMM_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DIMM_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DIMM_SPARE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DIMM_SPARE entry");
            AttributeTraits<ATTR_MEM_EFF_DIMM_SPARE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DIMM_SPARE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_CL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_CL entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_CL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_CL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_NUM_MASTER_RANKS_PER_DIMM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_NUM_MASTER_RANKS_PER_DIMM entry");
            AttributeTraits<ATTR_MEM_EFF_NUM_MASTER_RANKS_PER_DIMM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_NUM_MASTER_RANKS_PER_DIMM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DIMM_RANKS_CONFIGED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DIMM_RANKS_CONFIGED entry");
            AttributeTraits<ATTR_MEM_EFF_DIMM_RANKS_CONFIGED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DIMM_RANKS_CONFIGED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TREFI): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TREFI entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TREFI>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TREFI>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TRTP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TRTP entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TRTP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TRTP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DRAM_TRFC_DLR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DRAM_TRFC_DLR entry");
            AttributeTraits<ATTR_MEM_EFF_DRAM_TRFC_DLR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DRAM_TRFC_DLR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_FREQ): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_FREQ entry");
            AttributeTraits<ATTR_MEM_EFF_FREQ>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_FREQ>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_VOLT_VDDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_VOLT_VDDR entry");
            AttributeTraits<ATTR_MEM_EFF_VOLT_VDDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_VOLT_VDDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_VOLT_VPP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_VOLT_VPP entry");
            AttributeTraits<ATTR_MEM_EFF_VOLT_VPP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_VOLT_VPP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EXPLR_ENABLE_US_TMPL_1): { break; }
        case (ATTR_EXPLR_ENABLE_US_TMPL_5): { break; }
        case (ATTR_EXPLR_ENABLE_US_TMPL_9): { break; }
        case (ATTR_EXPLR_ENABLE_US_TMPL_A): { break; }
        case (ATTR_EXPLR_ENABLE_US_TMPL_B): { break; }
        case (ATTR_EXPLR_TMPL_0_PACING): { break; }
        case (ATTR_EXPLR_TMPL_1_PACING): { break; }
        case (ATTR_EXPLR_TMPL_5_PACING): { break; }
        case (ATTR_EXPLR_TMPL_9_PACING): { break; }
        case (ATTR_EXPLR_TMPL_B_PACING): { break; }
        case (ATTR_EXPLR_SHRT_BACKOFF_TIMER): { break; }
        case (ATTR_EXPLR_METADATA_ENABLE): { break; }
        case (ATTR_EXPLR_PASID_BASE): { break; }
        case (ATTR_EXPLR_ACTAG_BASE): { break; }
        case (ATTR_EXPLR_AFU_ACTAG_LEN): { break; }
        case (ATTR_EXPLR_PASID_LEN): { break; }
        case (ATTR_MEM_EFF_PSTATES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_PSTATES entry");
            AttributeTraits<ATTR_MEM_EFF_PSTATES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_PSTATES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_BYTE_ENABLES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_BYTE_ENABLES entry");
            AttributeTraits<ATTR_MEM_EFF_BYTE_ENABLES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_BYTE_ENABLES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_NIBBLE_ENABLES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_NIBBLE_ENABLES entry");
            AttributeTraits<ATTR_MEM_EFF_NIBBLE_ENABLES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_NIBBLE_ENABLES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_FOUR_RANK_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_FOUR_RANK_MODE entry");
            AttributeTraits<ATTR_MEM_EFF_FOUR_RANK_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_FOUR_RANK_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_MRAM_SUPPORT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_MRAM_SUPPORT entry");
            AttributeTraits<ATTR_MEM_EFF_MRAM_SUPPORT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_MRAM_SUPPORT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_DDP_COMPATIBILITY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_DDP_COMPATIBILITY entry");
            AttributeTraits<ATTR_MEM_EFF_DDP_COMPATIBILITY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_DDP_COMPATIBILITY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EFF_TSV_8H_SUPPORT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EFF_TSV_8H_SUPPORT entry");
            AttributeTraits<ATTR_MEM_EFF_TSV_8H_SUPPORT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EFF_TSV_8H_SUPPORT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_ENTERPRISE_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_ENTERPRISE_MODE entry");
            AttributeTraits<ATTR_MSS_OCMB_ENTERPRISE_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_ENTERPRISE_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_NONENTERPRISE_MODE_OVERRIDE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_NONENTERPRISE_MODE_OVERRIDE entry");
            AttributeTraits<ATTR_MSS_OCMB_NONENTERPRISE_MODE_OVERRIDE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_NONENTERPRISE_MODE_OVERRIDE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_HALF_DIMM_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_HALF_DIMM_MODE entry");
            AttributeTraits<ATTR_MSS_OCMB_HALF_DIMM_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_HALF_DIMM_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_HALF_DIMM_MODE_OVERRIDE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_HALF_DIMM_MODE_OVERRIDE entry");
            AttributeTraits<ATTR_MSS_OCMB_HALF_DIMM_MODE_OVERRIDE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_HALF_DIMM_MODE_OVERRIDE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_MEM_MVPD_FWMS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_MEM_MVPD_FWMS entry");
            AttributeTraits<ATTR_MSS_MEM_MVPD_FWMS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_MEM_MVPD_FWMS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EXP_CS_PRESENT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EXP_CS_PRESENT entry");
            AttributeTraits<ATTR_MEM_EXP_CS_PRESENT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EXP_CS_PRESENT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EXP_INIT_VREF_DQ): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EXP_INIT_VREF_DQ entry");
            AttributeTraits<ATTR_MEM_EXP_INIT_VREF_DQ>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EXP_INIT_VREF_DQ>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EXP_INIT_PHY_VREF): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EXP_INIT_PHY_VREF entry");
            AttributeTraits<ATTR_MEM_EXP_INIT_PHY_VREF>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EXP_INIT_PHY_VREF>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EXP_RCD_DIC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EXP_RCD_DIC entry");
            AttributeTraits<ATTR_MEM_EXP_RCD_DIC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EXP_RCD_DIC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EXP_RCD_VOLTAGE_CTRL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EXP_RCD_VOLTAGE_CTRL entry");
            AttributeTraits<ATTR_MEM_EXP_RCD_VOLTAGE_CTRL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EXP_RCD_VOLTAGE_CTRL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EXP_DRAM_ADDRESS_MIRRORING): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EXP_DRAM_ADDRESS_MIRRORING entry");
            AttributeTraits<ATTR_MEM_EXP_DRAM_ADDRESS_MIRRORING>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EXP_DRAM_ADDRESS_MIRRORING>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EXP_RCD_SLEW_RATE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EXP_RCD_SLEW_RATE entry");
            AttributeTraits<ATTR_MEM_EXP_RCD_SLEW_RATE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EXP_RCD_SLEW_RATE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EXP_3DS_HEIGHT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EXP_3DS_HEIGHT entry");
            AttributeTraits<ATTR_MEM_EXP_3DS_HEIGHT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EXP_3DS_HEIGHT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EXP_SPD_CL_SUPPORTED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EXP_SPD_CL_SUPPORTED entry");
            AttributeTraits<ATTR_MEM_EXP_SPD_CL_SUPPORTED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EXP_SPD_CL_SUPPORTED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EXP_SPD_TAA_MIN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EXP_SPD_TAA_MIN entry");
            AttributeTraits<ATTR_MEM_EXP_SPD_TAA_MIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EXP_SPD_TAA_MIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_EXP_FIRMWARE_EMULATION_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_EXP_FIRMWARE_EMULATION_MODE entry");
            AttributeTraits<ATTR_MEM_EXP_FIRMWARE_EMULATION_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_EXP_FIRMWARE_EMULATION_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_EXP_STRUCT_MMIO_ENDIAN_CTRL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_EXP_STRUCT_MMIO_ENDIAN_CTRL entry");
            AttributeTraits<ATTR_MSS_OCMB_EXP_STRUCT_MMIO_ENDIAN_CTRL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_EXP_STRUCT_MMIO_ENDIAN_CTRL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_EXP_STRUCT_ENDIAN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_EXP_STRUCT_ENDIAN entry");
            AttributeTraits<ATTR_MSS_OCMB_EXP_STRUCT_ENDIAN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_EXP_STRUCT_ENDIAN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_ECID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_ECID entry");
            AttributeTraits<ATTR_MSS_OCMB_ECID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_ECID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_EXP_BOOT_CONFIG_FW_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_EXP_BOOT_CONFIG_FW_MODE entry");
            AttributeTraits<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_FW_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_FW_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_EXP_BOOT_CONFIG_OPENCAPI_LOOPBACK_TEST): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_EXP_BOOT_CONFIG_OPENCAPI_LOOPBACK_TEST entry");
            AttributeTraits<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_OPENCAPI_LOOPBACK_TEST>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_OPENCAPI_LOOPBACK_TEST>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_EXP_BOOT_CONFIG_TRANSPORT_LAYER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_EXP_BOOT_CONFIG_TRANSPORT_LAYER entry");
            AttributeTraits<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_TRANSPORT_LAYER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_TRANSPORT_LAYER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_EXP_BOOT_CONFIG_DL_LAYER_BOOT_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_EXP_BOOT_CONFIG_DL_LAYER_BOOT_MODE entry");
            AttributeTraits<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_DL_LAYER_BOOT_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_DL_LAYER_BOOT_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_EXP_BOOT_CONFIG_BOOT_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_EXP_BOOT_CONFIG_BOOT_MODE entry");
            AttributeTraits<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_BOOT_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_BOOT_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_EXP_BOOT_CONFIG_LANE_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_EXP_BOOT_CONFIG_LANE_MODE entry");
            AttributeTraits<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_LANE_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_LANE_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_OCMB_EXP_BOOT_CONFIG_SERDES_FREQUENCY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_OCMB_EXP_BOOT_CONFIG_SERDES_FREQUENCY entry");
            AttributeTraits<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_SERDES_FREQUENCY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_OCMB_EXP_BOOT_CONFIG_SERDES_FREQUENCY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_AFFINITY_PATH): { break; }
        case (ATTR_ALL_MCS_IN_INTERLEAVING_GROUP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ALL_MCS_IN_INTERLEAVING_GROUP entry");
            AttributeTraits<ATTR_ALL_MCS_IN_INTERLEAVING_GROUP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ALL_MCS_IN_INTERLEAVING_GROUP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ALTFSI_MASTER_CHIP): { break; }
        case (ATTR_ALTFSI_MASTER_PORT): { break; }
        case (ATTR_ASYNC_NEST_FREQ_MHZ): { break; }
        case (ATTR_ATTN_AREA_1_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ATTN_AREA_1_ADDR entry");
            AttributeTraits<ATTR_ATTN_AREA_1_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ATTN_AREA_1_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ATTN_AREA_2_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ATTN_AREA_2_ADDR entry");
            AttributeTraits<ATTR_ATTN_AREA_2_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ATTN_AREA_2_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_AVDD_ID): { break; }
        case (ATTR_BLOCK_SPEC_DECONFIG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: BLOCK_SPEC_DECONFIG entry");
            AttributeTraits<ATTR_BLOCK_SPEC_DECONFIG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_BLOCK_SPEC_DECONFIG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_BMC_FRU_ID): { break; }
        case (ATTR_BRAZOS_RX_FIFO_OVERRIDE): { break; }
        case (ATTR_CDM_DOMAIN): { break; }
        case (ATTR_CDM_POLICIES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CDM_POLICIES entry");
            AttributeTraits<ATTR_CDM_POLICIES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CDM_POLICIES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEC_IPL_TYPE): {
            TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEC_IPL_TYPE skipped -- complexType");
            attrSize = 0;
            break;
        }
        case (ATTR_CENTAUR_ECID_FRU_ID): { break; }
        case (ATTR_CEN_MSS_VOLT_AVDD_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_VOLT_AVDD_MILLIVOLTS entry");
            AttributeTraits<ATTR_CEN_MSS_VOLT_AVDD_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_VOLT_AVDD_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_VOLT_AVDD_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_VOLT_AVDD_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_CEN_MSS_VOLT_AVDD_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_VOLT_AVDD_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_VOLT_VCS_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_VOLT_VCS_MILLIVOLTS entry");
            AttributeTraits<ATTR_CEN_MSS_VOLT_VCS_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_VOLT_VCS_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_VOLT_VCS_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_VOLT_VCS_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_CEN_MSS_VOLT_VCS_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_VOLT_VCS_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_VOLT_VDDR_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_VOLT_VDDR_MILLIVOLTS entry");
            AttributeTraits<ATTR_CEN_MSS_VOLT_VDDR_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_VOLT_VDDR_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_VOLT_VDDR_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_VOLT_VDDR_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_CEN_MSS_VOLT_VDDR_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_VOLT_VDDR_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_VOLT_VDD_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_VOLT_VDD_MILLIVOLTS entry");
            AttributeTraits<ATTR_CEN_MSS_VOLT_VDD_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_VOLT_VDD_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_VOLT_VDD_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_VOLT_VDD_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_CEN_MSS_VOLT_VDD_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_VOLT_VDD_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_VOLT_VPP_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_VOLT_VPP_MILLIVOLTS entry");
            AttributeTraits<ATTR_CEN_MSS_VOLT_VPP_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_VOLT_VPP_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CEN_MSS_VOLT_VPP_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CEN_MSS_VOLT_VPP_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_CEN_MSS_VOLT_VPP_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CEN_MSS_VOLT_VPP_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CHIPLET_ID): { break; }
        case (ATTR_CHIP_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CHIP_ID entry");
            AttributeTraits<ATTR_CHIP_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CHIP_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CHIP_UNIT): { break; }
        case (ATTR_CLASS): { break; }
        case (ATTR_CPU_ATTR): { break; }
        case (ATTR_CVPD_MAX_SECTIONS): { break; }
        case (ATTR_CVPD_SIZE): { break; }
        case (ATTR_DATA_CACHE_LINE_SIZE): { break; }
        case (ATTR_DATA_CACHE_SIZE): { break; }
        case (ATTR_DCACHE_ASSOC_SETS): { break; }
        case (ATTR_DCACHE_LINE_SIZE): { break; }
        case (ATTR_DECONFIG_GARDABLE): { break; }
        case (ATTR_DISABLE_I2C_ENGINE2_PORT0_DIAG_MODE): { break; }
        case (ATTR_DO_ABUS_DECONFIG): { break; }
        case (ATTR_DPO_MIN_FREQ_PERCENT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: DPO_MIN_FREQ_PERCENT entry");
            AttributeTraits<ATTR_DPO_MIN_FREQ_PERCENT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_DPO_MIN_FREQ_PERCENT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_DUMMY_HEAP_ZERO_DEFAULT): { break; }
        case (ATTR_DUMMY_RO): { break; }
        case (ATTR_DUMMY_RW): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: DUMMY_RW entry");
            AttributeTraits<ATTR_DUMMY_RW>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_DUMMY_RW>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_DUMMY_WO): { break; }
        case (ATTR_EC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EC entry");
            AttributeTraits<ATTR_EC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EEPROM_NV_INFO): { break; }
        case (ATTR_EEPROM_SBE_BACKUP_INFO): { break; }
        case (ATTR_EEPROM_SBE_PRIMARY_INFO): { break; }
        case (ATTR_EEPROM_VPD_BACKUP_INFO): { break; }
        case (ATTR_EEPROM_VPD_PRIMARY_INFO): { break; }
        case (ATTR_EFFECTIVE_EC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EFFECTIVE_EC entry");
            AttributeTraits<ATTR_EFFECTIVE_EC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EFFECTIVE_EC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ENABLED_THREADS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ENABLED_THREADS entry");
            AttributeTraits<ATTR_ENABLED_THREADS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ENABLED_THREADS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ENGINE_TYPE): { break; }
        case (ATTR_FABRIC_CHIP_ID): { break; }
        case (ATTR_FABRIC_GROUP_ID): { break; }
        case (ATTR_FABRIC_TO_PHYSICAL_NODE_MAP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FABRIC_TO_PHYSICAL_NODE_MAP entry");
            AttributeTraits<ATTR_FABRIC_TO_PHYSICAL_NODE_MAP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FABRIC_TO_PHYSICAL_NODE_MAP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FAPI_I2C_CONTROL_INFO): { break; }
        case (ATTR_FAPI_NAME): { break; }
        case (ATTR_FIELD_CORE_OVERRIDE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FIELD_CORE_OVERRIDE entry");
            AttributeTraits<ATTR_FIELD_CORE_OVERRIDE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FIELD_CORE_OVERRIDE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FIELD_TH_P8EX_L2_COL_REPAIRS): { break; }
        case (ATTR_FIELD_TH_P8EX_L2_LINE_DELETES): { break; }
        case (ATTR_FIELD_TH_P8EX_L3_COL_REPAIRS): { break; }
        case (ATTR_FIELD_TH_P8EX_L3_LINE_DELETES): { break; }
        case (ATTR_FREQ_CORE_CEILING_MHZ): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FREQ_CORE_CEILING_MHZ entry");
            AttributeTraits<ATTR_FREQ_CORE_CEILING_MHZ>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FREQ_CORE_CEILING_MHZ>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FREQ_CORE_MAX): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FREQ_CORE_MAX entry");
            AttributeTraits<ATTR_FREQ_CORE_MAX>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FREQ_CORE_MAX>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FREQ_PROC_REFCLOCK): { break; }
        case (ATTR_FRU_ID): { break; }
        case (ATTR_FSI_MASTER_CHIP): { break; }
        case (ATTR_FSI_MASTER_PORT): { break; }
        case (ATTR_FSI_MASTER_TYPE): { break; }
        case (ATTR_FSI_OPTION_FLAGS): { break; }
        case (ATTR_FSI_SLAVE_CASCADE): { break; }
        case (ATTR_FSP_BAR_SIZE): { break; }
        case (ATTR_FSP_BASE_ADDR): { break; }
        case (ATTR_FUSED_CORE_MODE_HB): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FUSED_CORE_MODE_HB entry");
            AttributeTraits<ATTR_FUSED_CORE_MODE_HB>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FUSED_CORE_MODE_HB>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FUSED_CORE_OPTION): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: FUSED_CORE_OPTION entry");
            AttributeTraits<ATTR_FUSED_CORE_OPTION>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_FUSED_CORE_OPTION>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HB_HRMOR_NODAL_BASE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HB_HRMOR_NODAL_BASE entry");
            AttributeTraits<ATTR_HB_HRMOR_NODAL_BASE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HB_HRMOR_NODAL_BASE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HB_RSV_MEM_SIZE_MB): { break; }
        case (ATTR_HB_SETTINGS): {
            TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HB_SETTINGS skipped -- complexType");
            attrSize = 0;
            break;
        }
        case (ATTR_HDAT_EC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HDAT_EC entry");
            AttributeTraits<ATTR_HDAT_EC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HDAT_EC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HDAT_HBRT_NUM_SECTIONS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HDAT_HBRT_NUM_SECTIONS entry");
            AttributeTraits<ATTR_HDAT_HBRT_NUM_SECTIONS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HDAT_HBRT_NUM_SECTIONS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HDAT_HBRT_SECTION_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HDAT_HBRT_SECTION_SIZE entry");
            AttributeTraits<ATTR_HDAT_HBRT_SECTION_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HDAT_HBRT_SECTION_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HDAT_RSV_MEM_NUM_SECTIONS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HDAT_RSV_MEM_NUM_SECTIONS entry");
            AttributeTraits<ATTR_HDAT_RSV_MEM_NUM_SECTIONS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HDAT_RSV_MEM_NUM_SECTIONS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HDDW_ORDER): { break; }
        case (ATTR_HOMER_PHYS_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HOMER_PHYS_ADDR entry");
            AttributeTraits<ATTR_HOMER_PHYS_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HOMER_PHYS_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HOSTSVC_PLID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HOSTSVC_PLID entry");
            AttributeTraits<ATTR_HOSTSVC_PLID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HOSTSVC_PLID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HOT_PLUG_POWER_CONTROLLER_INFO): { break; }
        case (ATTR_HUID): { break; }
        case (ATTR_HWAS_STATE): {
            TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HWAS_STATE skipped -- complexType");
            attrSize = 0;
            break;
        }
        case (ATTR_HWAS_STATE_CHANGED_FLAG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HWAS_STATE_CHANGED_FLAG entry");
            AttributeTraits<ATTR_HWAS_STATE_CHANGED_FLAG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HWAS_STATE_CHANGED_FLAG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HWAS_STATE_CHANGED_SUBSCRIPTION_MASK): { break; }
        case (ATTR_I2C_BUS_SPEED_ARRAY): { break; }
        case (ATTR_I2C_CONTROL_INFO): { break; }
        case (ATTR_I2C_SWITCHES): {
            TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: I2C_SWITCHES skipped -- complexType");
            attrSize = 0;
            break;
        }
        case (ATTR_IBSCOM_MCS_BASE_ADDR): { break; }
        case (ATTR_IBSCOM_PROC_BASE_ADDR): { break; }
        case (ATTR_ICACHE_ASSOC_SETS): { break; }
        case (ATTR_ICACHE_BLOCK_SIZE): { break; }
        case (ATTR_ICACHE_LINE_SIZE): { break; }
        case (ATTR_ICACHE_SIZE): { break; }
        case (ATTR_IMT_BAR_SIZE): { break; }
        case (ATTR_IMT_BASE_ADDR): { break; }
        case (ATTR_INIT_TO_AVAILABLE): { break; }
        case (ATTR_INTP_BASE_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: INTP_BASE_ADDR entry");
            AttributeTraits<ATTR_INTP_BASE_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_INTP_BASE_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ISTEP_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ISTEP_MODE entry");
            AttributeTraits<ATTR_ISTEP_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ISTEP_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ISTEP_PAUSE_CONFIG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ISTEP_PAUSE_CONFIG entry");
            AttributeTraits<ATTR_ISTEP_PAUSE_CONFIG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ISTEP_PAUSE_CONFIG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ISTEP_PAUSE_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ISTEP_PAUSE_ENABLE entry");
            AttributeTraits<ATTR_ISTEP_PAUSE_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ISTEP_PAUSE_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IS_INTER_ENCLOSURE_BUS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IS_INTER_ENCLOSURE_BUS entry");
            AttributeTraits<ATTR_IS_INTER_ENCLOSURE_BUS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IS_INTER_ENCLOSURE_BUS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_KEY_TRANSITION_STATE): { // simpleType:enum
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: KEY_TRANSITION_STATE entry");
            AttributeTraits<ATTR_KEY_TRANSITION_STATE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_KEY_TRANSITION_STATE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_L2_CACHE_ASSOC_SETS): { break; }
        case (ATTR_L2_CACHE_LINE_SIZE): { break; }
        case (ATTR_L2_CACHE_SIZE): { break; }
        case (ATTR_L3_CACHE_LINE_SIZE): { break; }
        case (ATTR_L3_CACHE_SIZE): { break; }
        case (ATTR_LOCATION_CODE): { break; }
        case (ATTR_LPC_BUS_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: LPC_BUS_ADDR entry");
            AttributeTraits<ATTR_LPC_BUS_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_LPC_BUS_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MAX_CHIPLETS_PER_PROC): { break; }
        case (ATTR_MAX_COMPUTE_NODES_PER_SYSTEM): { break; }
        case (ATTR_MAX_DIMMS_PER_MBA_PORT): { break; }
        case (ATTR_MAX_DMI_PER_PROC): { break; }
        case (ATTR_MAX_EXS_PER_PROC_CHIP): { break; }
        case (ATTR_MAX_MBAS_PER_MEMBUF_CHIP): { break; }
        case (ATTR_MAX_MBA_PORTS_PER_MBA): { break; }
        case (ATTR_MAX_MCS_PER_SYSTEM): { break; }
        case (ATTR_MAX_POWER): { break; }
        case (ATTR_MAX_PROC_CHIPS_PER_NODE): { break; }
        case (ATTR_MAX_SBE_SEEPROM_SIZE): { break; }
        case (ATTR_MBA_DIMM): { break; }
        case (ATTR_MBA_PORT): { break; }
        case (ATTR_MC_PLL_BUCKET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MC_PLL_BUCKET entry");
            AttributeTraits<ATTR_MC_PLL_BUCKET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MC_PLL_BUCKET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_AVDD_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_AVDD_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_MEM_AVDD_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_AVDD_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_BASE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_BASE entry");
            AttributeTraits<ATTR_MEM_BASE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_BASE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_PORT): { break; }
        case (ATTR_MEM_VCS_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_VCS_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_MEM_VCS_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_VCS_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_VDDR_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_VDDR_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_MEM_VDDR_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_VDDR_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_VDD_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_VDD_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_MEM_VDD_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_VDD_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEM_VPP_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEM_VPP_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_MEM_VPP_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEM_VPP_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MFG_TRACE_ENABLE): { break; }
        case (ATTR_MFG_WRAP_TEST_ABUS_LINKS_SET): { break; }
        case (ATTR_MFG_WRAP_TEST_ABUS_LINKS_SET_ENABLE): { break; }
        case (ATTR_MGC_LOAD_SOURCE): { break; }
        case (ATTR_MIN_FREQ_MHZ): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MIN_FREQ_MHZ entry");
            AttributeTraits<ATTR_MIN_FREQ_MHZ>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MIN_FREQ_MHZ>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MIRROR_BASE_ADDRESS): { break; }
        case (ATTR_MNFG_ABUS_MIN_EYE_HEIGHT): { break; }
        case (ATTR_MNFG_ABUS_MIN_EYE_WIDTH): { break; }
        case (ATTR_MNFG_DMI_MIN_EYE_HEIGHT): { break; }
        case (ATTR_MNFG_DMI_MIN_EYE_WIDTH): { break; }
        case (ATTR_MNFG_TH_CEN_L4_CACHE_CES): { break; }
        case (ATTR_MNFG_TH_CEN_MBA_IPL_SOFT_CE_TH_ALGO): { break; }
        case (ATTR_MNFG_TH_CEN_MBA_RT_RCE_PER_RANK): { break; }
        case (ATTR_MNFG_TH_CEN_MBA_RT_SOFT_CE_TH_ALGO): { break; }
        case (ATTR_MNFG_TH_MEMORY_IMPES): { break; }
        case (ATTR_MNFG_TH_MEMORY_IUES): { break; }
        case (ATTR_MNFG_TH_P8EX_L2_CACHE_CES): { break; }
        case (ATTR_MNFG_TH_P8EX_L2_COL_REPAIRS): { break; }
        case (ATTR_MNFG_TH_P8EX_L2_DIR_CES): { break; }
        case (ATTR_MNFG_TH_P8EX_L2_LINE_DELETES): { break; }
        case (ATTR_MNFG_TH_P8EX_L3_CACHE_CES): { break; }
        case (ATTR_MNFG_TH_P8EX_L3_COL_REPAIRS): { break; }
        case (ATTR_MNFG_TH_P8EX_L3_DIR_CES): { break; }
        case (ATTR_MNFG_TH_P8EX_L3_LINE_DELETES): { break; }
        case (ATTR_MNFG_TH_RCD_PARITY_ERRORS): { break; }
        case (ATTR_MNFG_XBUS_MIN_EYE_WIDTH): { break; }
        case (ATTR_MODEL): { break; }
        case (ATTR_MRU_ID): { break; }
        case (ATTR_MRW_DDR3_VDDR_MAX_LIMIT): { break; }
        case (ATTR_MRW_DDR3_VDDR_MAX_LIMIT_POST_DRAM_INIT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MRW_DDR3_VDDR_MAX_LIMIT_POST_DRAM_INIT entry");
            AttributeTraits<ATTR_MRW_DDR3_VDDR_MAX_LIMIT_POST_DRAM_INIT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MRW_DDR3_VDDR_MAX_LIMIT_POST_DRAM_INIT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MRW_DDR4_VDDR_MAX_LIMIT): { break; }
        case (ATTR_MRW_DDR4_VDDR_MAX_LIMIT_POST_DRAM_INIT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MRW_DDR4_VDDR_MAX_LIMIT_POST_DRAM_INIT entry");
            AttributeTraits<ATTR_MRW_DDR4_VDDR_MAX_LIMIT_POST_DRAM_INIT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MRW_DDR4_VDDR_MAX_LIMIT_POST_DRAM_INIT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MRW_DEFAULT_RISK_LEVEL): { break; }
        case (ATTR_MRW_MEM_THROTTLE_DENOMINATOR): { break; }
        case (ATTR_MSS_AVDD_PROGRAM): { break; }
        case (ATTR_MSS_CENT_AVDD_INTERCEPT): { break; }
        case (ATTR_MSS_CENT_AVDD_SLOPE_ACTIVE): { break; }
        case (ATTR_MSS_CENT_AVDD_SLOPE_INACTIVE): { break; }
        case (ATTR_MSS_CENT_VCS_INTERCEPT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CENT_VCS_INTERCEPT entry");
            AttributeTraits<ATTR_MSS_CENT_VCS_INTERCEPT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CENT_VCS_INTERCEPT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_CENT_VCS_SLOPE_ACTIVE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CENT_VCS_SLOPE_ACTIVE entry");
            AttributeTraits<ATTR_MSS_CENT_VCS_SLOPE_ACTIVE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CENT_VCS_SLOPE_ACTIVE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_CENT_VCS_SLOPE_INACTIVE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CENT_VCS_SLOPE_INACTIVE entry");
            AttributeTraits<ATTR_MSS_CENT_VCS_SLOPE_INACTIVE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CENT_VCS_SLOPE_INACTIVE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_CENT_VDD_INTERCEPT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CENT_VDD_INTERCEPT entry");
            AttributeTraits<ATTR_MSS_CENT_VDD_INTERCEPT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CENT_VDD_INTERCEPT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_CENT_VDD_SLOPE_ACTIVE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CENT_VDD_SLOPE_ACTIVE entry");
            AttributeTraits<ATTR_MSS_CENT_VDD_SLOPE_ACTIVE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CENT_VDD_SLOPE_ACTIVE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_CENT_VDD_SLOPE_INACTIVE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_CENT_VDD_SLOPE_INACTIVE entry");
            AttributeTraits<ATTR_MSS_CENT_VDD_SLOPE_INACTIVE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_CENT_VDD_SLOPE_INACTIVE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_DATABUS_UTIL_PER_MBA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_DATABUS_UTIL_PER_MBA entry");
            AttributeTraits<ATTR_MSS_DATABUS_UTIL_PER_MBA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_DATABUS_UTIL_PER_MBA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_MBA_ADDR_INTERLEAVE_BIT): { break; }
        case (ATTR_MSS_MBA_CACHELINE_INTERLEAVE_MODE): { break; }
        case (ATTR_MSS_PHY_SEQ_REFRESH): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_PHY_SEQ_REFRESH entry");
            AttributeTraits<ATTR_MSS_PHY_SEQ_REFRESH>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_PHY_SEQ_REFRESH>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VCS_PROGRAM): { break; }
        case (ATTR_MSS_VDDR_PROGRAM): { break; }
        case (ATTR_MSS_VDD_PROGRAM): { break; }
        case (ATTR_MSS_VOLT_AVDD_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_AVDD_MILLIVOLTS entry");
            AttributeTraits<ATTR_MSS_VOLT_AVDD_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_AVDD_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_AVDD_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_AVDD_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_MSS_VOLT_AVDD_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_AVDD_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_DDR3_VDDR_INTERCEPT): { break; }
        case (ATTR_MSS_VOLT_DDR3_VDDR_INTERCEPT_POST_DRAM_INIT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_DDR3_VDDR_INTERCEPT_POST_DRAM_INIT entry");
            AttributeTraits<ATTR_MSS_VOLT_DDR3_VDDR_INTERCEPT_POST_DRAM_INIT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_DDR3_VDDR_INTERCEPT_POST_DRAM_INIT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_DDR3_VDDR_SLOPE): { break; }
        case (ATTR_MSS_VOLT_DDR3_VDDR_SLOPE_POST_DRAM_INIT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_DDR3_VDDR_SLOPE_POST_DRAM_INIT entry");
            AttributeTraits<ATTR_MSS_VOLT_DDR3_VDDR_SLOPE_POST_DRAM_INIT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_DDR3_VDDR_SLOPE_POST_DRAM_INIT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_DDR4_VDDR_INTERCEPT): { break; }
        case (ATTR_MSS_VOLT_DDR4_VDDR_INTERCEPT_POST_DRAM_INIT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_DDR4_VDDR_INTERCEPT_POST_DRAM_INIT entry");
            AttributeTraits<ATTR_MSS_VOLT_DDR4_VDDR_INTERCEPT_POST_DRAM_INIT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_DDR4_VDDR_INTERCEPT_POST_DRAM_INIT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_DDR4_VDDR_SLOPE): { break; }
        case (ATTR_MSS_VOLT_DDR4_VDDR_SLOPE_POST_DRAM_INIT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_DDR4_VDDR_SLOPE_POST_DRAM_INIT entry");
            AttributeTraits<ATTR_MSS_VOLT_DDR4_VDDR_SLOPE_POST_DRAM_INIT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_DDR4_VDDR_SLOPE_POST_DRAM_INIT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_VCS_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_VCS_MILLIVOLTS entry");
            AttributeTraits<ATTR_MSS_VOLT_VCS_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_VCS_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_VCS_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_VCS_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_MSS_VOLT_VCS_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_VCS_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_VDDR_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_VDDR_MILLIVOLTS entry");
            AttributeTraits<ATTR_MSS_VOLT_VDDR_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_VDDR_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_VDDR_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_VDDR_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_MSS_VOLT_VDDR_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_VDDR_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_VDD_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_VDD_MILLIVOLTS entry");
            AttributeTraits<ATTR_MSS_VOLT_VDD_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_VDD_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_VDD_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_VDD_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_MSS_VOLT_VDD_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_VDD_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_VPP_INTERCEPT): { break; }
        case (ATTR_MSS_VOLT_VPP_INTERCEPT_POST_DRAM_INIT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_VPP_INTERCEPT_POST_DRAM_INIT entry");
            AttributeTraits<ATTR_MSS_VOLT_VPP_INTERCEPT_POST_DRAM_INIT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_VPP_INTERCEPT_POST_DRAM_INIT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_VPP_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_VPP_MILLIVOLTS entry");
            AttributeTraits<ATTR_MSS_VOLT_VPP_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_VPP_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_VPP_OFFSET_MILLIVOLTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_VPP_OFFSET_MILLIVOLTS entry");
            AttributeTraits<ATTR_MSS_VOLT_VPP_OFFSET_MILLIVOLTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_VPP_OFFSET_MILLIVOLTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_VPP_SLOPE): { break; }
        case (ATTR_MSS_VOLT_VPP_SLOPE_POST_DRAM_INIT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_VPP_SLOPE_POST_DRAM_INIT entry");
            AttributeTraits<ATTR_MSS_VOLT_VPP_SLOPE_POST_DRAM_INIT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_VPP_SLOPE_POST_DRAM_INIT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VPP_PROGRAM): { break; }
        case (ATTR_NEST_PLL_FREQ_BUCKETS): { break; }
        case (ATTR_NEST_PLL_FREQ_I2CDIV_LIST): { break; }
        case (ATTR_NEST_PLL_FREQ_LIST): { break; }
        case (ATTR_NEST_VCS_ID): { break; }
        case (ATTR_NEST_VDDR_ID): { break; }
        case (ATTR_NEST_VDD_ID): { break; }
        case (ATTR_NEST_VDN_ID): { break; }
        case (ATTR_NEST_VIO_ID): { break; }
        case (ATTR_NOMINAL_FREQ_MHZ): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NOMINAL_FREQ_MHZ entry");
            AttributeTraits<ATTR_NOMINAL_FREQ_MHZ>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NOMINAL_FREQ_MHZ>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NPU_MMIO_BAR_BASE_ADDR): { break; }
        case (ATTR_NPU_MMIO_BAR_SIZE): { break; }
        case (ATTR_NUMERIC_POD_TYPE_TEST): { break; }
        case (ATTR_NVDIMM_ARMED): {
            TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NVDIMM_ARMED skipped -- complexType");
            attrSize = 0;
            break;
        }
        case (ATTR_NV_OPS_TIMEOUT_MSEC): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NV_OPS_TIMEOUT_MSEC entry");
            AttributeTraits<ATTR_NV_OPS_TIMEOUT_MSEC>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NV_OPS_TIMEOUT_MSEC>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NV_STATUS_FLAG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: NV_STATUS_FLAG entry");
            AttributeTraits<ATTR_NV_STATUS_FLAG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_NV_STATUS_FLAG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_OBUS_BRICK_LANE_MASK): { break; }
        case (ATTR_OBUS_SLOT_INDEX): { break; }
        case (ATTR_OCC_MASTER_CAPABLE): { break; }
        case (ATTR_ORDINAL_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ORDINAL_ID entry");
            AttributeTraits<ATTR_ORDINAL_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ORDINAL_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PARENT_DECONFIG_RULES): { break; }
        case (ATTR_PAYLOAD_BASE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PAYLOAD_BASE entry");
            AttributeTraits<ATTR_PAYLOAD_BASE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PAYLOAD_BASE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PAYLOAD_ENTRY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PAYLOAD_ENTRY entry");
            AttributeTraits<ATTR_PAYLOAD_ENTRY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PAYLOAD_ENTRY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PAYLOAD_IN_MIRROR_MEM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PAYLOAD_IN_MIRROR_MEM entry");
            AttributeTraits<ATTR_PAYLOAD_IN_MIRROR_MEM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PAYLOAD_IN_MIRROR_MEM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PAYLOAD_KIND): { // simpleType:enum
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PAYLOAD_KIND entry");
            AttributeTraits<ATTR_PAYLOAD_KIND>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PAYLOAD_KIND>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PCIE_32BIT_DMA_SIZE): { break; }
        case (ATTR_PCIE_32BIT_MMIO_SIZE): { break; }
        case (ATTR_PCIE_64BIT_DMA_SIZE): { break; }
        case (ATTR_PCIE_64BIT_MMIO_SIZE): { break; }
        case (ATTR_PCIE_CAPABILITES): { break; }
        case (ATTR_PCI_BASE_ADDRS_32): { break; }
        case (ATTR_PCI_BASE_ADDRS_64): { break; }
        case (ATTR_PCI_REFCLOCK_RCVR_TERM): { break; }
        case (ATTR_PEC_IS_BIFURCATABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PEC_IS_BIFURCATABLE entry");
            AttributeTraits<ATTR_PEC_IS_BIFURCATABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PEC_IS_BIFURCATABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PEC_PCIE_HX_KEYWORD_DATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PEC_PCIE_HX_KEYWORD_DATA entry");
            AttributeTraits<ATTR_PEC_PCIE_HX_KEYWORD_DATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PEC_PCIE_HX_KEYWORD_DATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PEC_PCIE_IOP_REVERSAL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PEC_PCIE_IOP_REVERSAL entry");
            AttributeTraits<ATTR_PEC_PCIE_IOP_REVERSAL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PEC_PCIE_IOP_REVERSAL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PEC_PCIE_IOP_REVERSAL_BIFURCATED): { break; }
        case (ATTR_PEC_PCIE_IOP_REVERSAL_NON_BIFURCATED): { break; }
        case (ATTR_PEC_PCIE_IOP_SWAP_BIFURCATED): { break; }
        case (ATTR_PEC_PCIE_IOP_SWAP_NON_BIFURCATED): { break; }
        case (ATTR_PEC_PCIE_LANE_MASK_BIFURCATED): { break; }
        case (ATTR_PEC_PCIE_LANE_MASK_NON_BIFURCATED): { break; }
        case (ATTR_PEER_PATH): { break; }
        case (ATTR_PEER_TARGET): { break; }
        case (ATTR_PG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PG entry");
            AttributeTraits<ATTR_PG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PHB_BASE_ADDRS): { break; }
        case (ATTR_PHYS_PATH): { break; }
        case (ATTR_PIB_I2C_NEST_PLL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PIB_I2C_NEST_PLL entry");
            AttributeTraits<ATTR_PIB_I2C_NEST_PLL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PIB_I2C_NEST_PLL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PIB_I2C_REFCLOCK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PIB_I2C_REFCLOCK entry");
            AttributeTraits<ATTR_PIB_I2C_REFCLOCK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PIB_I2C_REFCLOCK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PLCK_IPL_ATTR_OVERRIDES_EXIST): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PLCK_IPL_ATTR_OVERRIDES_EXIST entry");
            AttributeTraits<ATTR_PLCK_IPL_ATTR_OVERRIDES_EXIST>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PLCK_IPL_ATTR_OVERRIDES_EXIST>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PNOR_FLASH_WORKAROUNDS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PNOR_FLASH_WORKAROUNDS entry");
            AttributeTraits<ATTR_PNOR_FLASH_WORKAROUNDS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PNOR_FLASH_WORKAROUNDS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_POSITION): { break; }
        case (ATTR_POS_ON_MEM_PORT): { break; }
        case (ATTR_POWER_PATH): { break; }
        case (ATTR_PRD_HWP_PLID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PRD_HWP_PLID entry");
            AttributeTraits<ATTR_PRD_HWP_PLID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PRD_HWP_PLID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PREVIOUS_WAKEUP_FAIL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PREVIOUS_WAKEUP_FAIL entry");
            AttributeTraits<ATTR_PREVIOUS_WAKEUP_FAIL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PREVIOUS_WAKEUP_FAIL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PRIMARY_CAPABILITIES): { break; }
        case (ATTR_PROC_COMPATIBILITY_REQ): { break; }
        case (ATTR_PROC_DCM_INSTALLED): { break; }
        case (ATTR_PROC_MASTER_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_MASTER_TYPE entry");
            AttributeTraits<ATTR_PROC_MASTER_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_MASTER_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_PCIE_IOP_CONFIG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_PCIE_IOP_CONFIG entry");
            AttributeTraits<ATTR_PROC_PCIE_IOP_CONFIG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_PCIE_IOP_CONFIG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_PCIE_IOVALID_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_PCIE_IOVALID_ENABLE entry");
            AttributeTraits<ATTR_PROC_PCIE_IOVALID_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_PCIE_IOVALID_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_PCIE_IS_SLOT): { break; }
        case (ATTR_PROC_PCIE_LANE_EQUALIZATION_GEN3): { break; }
        case (ATTR_PROC_PCIE_LANE_EQUALIZATION_GEN4): { break; }
        case (ATTR_PROC_PCIE_LANE_MASK): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_PCIE_LANE_MASK entry");
            AttributeTraits<ATTR_PROC_PCIE_LANE_MASK>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_PCIE_LANE_MASK>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_PCIE_NUM_PEC): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_LOFF_CONTROL): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_PHASE_ROTATOR_CNTL): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_SIGDET_CNTL): { break; }
        case (ATTR_PROC_PCIE_PCS_RX_VGA_CONTRL_REGISTER3): { break; }
        case (ATTR_PROC_PCIE_PCS_SYSTEM_CNTL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_PCIE_PCS_SYSTEM_CNTL entry");
            AttributeTraits<ATTR_PROC_PCIE_PCS_SYSTEM_CNTL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_PCIE_PCS_SYSTEM_CNTL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_PCIE_PCS_TX_FIFO_CONFIG_OFFSET): { break; }
        case (ATTR_PROC_PCIE_PHB_ACTIVE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_PCIE_PHB_ACTIVE entry");
            AttributeTraits<ATTR_PROC_PCIE_PHB_ACTIVE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_PCIE_PHB_ACTIVE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_PCIE_REFCLOCK_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_PCIE_REFCLOCK_ENABLE entry");
            AttributeTraits<ATTR_PROC_PCIE_REFCLOCK_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_PCIE_REFCLOCK_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_REFCLOCK_RCVR_TERM): { break; }
        case (ATTR_PROC_SELECT_BOOT_SEEPROM_IMAGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_SELECT_BOOT_SEEPROM_IMAGE entry");
            AttributeTraits<ATTR_PROC_SELECT_BOOT_SEEPROM_IMAGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_SELECT_BOOT_SEEPROM_IMAGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_SELECT_SEEPROM_IMAGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PROC_SELECT_SEEPROM_IMAGE entry");
            AttributeTraits<ATTR_PROC_SELECT_SEEPROM_IMAGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PROC_SELECT_SEEPROM_IMAGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PSI_BRIDGE_BASE_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PSI_BRIDGE_BASE_ADDR entry");
            AttributeTraits<ATTR_PSI_BRIDGE_BASE_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PSI_BRIDGE_BASE_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PSI_HB_ESB_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PSI_HB_ESB_ADDR entry");
            AttributeTraits<ATTR_PSI_HB_ESB_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PSI_HB_ESB_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_RCD_PARITY_RECONFIG_LOOPS_ALLOWED): { break; }
        case (ATTR_RCD_PARITY_RECONFIG_LOOP_COUNT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: RCD_PARITY_RECONFIG_LOOP_COUNT entry");
            AttributeTraits<ATTR_RCD_PARITY_RECONFIG_LOOP_COUNT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_RCD_PARITY_RECONFIG_LOOP_COUNT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_RECONFIG_LOOP_TESTS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: RECONFIG_LOOP_TESTS entry");
            AttributeTraits<ATTR_RECONFIG_LOOP_TESTS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_RECONFIG_LOOP_TESTS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_RECONFIG_LOOP_TESTS_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: RECONFIG_LOOP_TESTS_ENABLE entry");
            AttributeTraits<ATTR_RECONFIG_LOOP_TESTS_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_RECONFIG_LOOP_TESTS_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_REDUNDANT_CLOCKS): { break; }
        case (ATTR_REL_POS): { break; }
        case (ATTR_RESOURCE_IS_CRITICAL): { break; }
        case (ATTR_RISK_LEVEL_ORIGIN): { // simpleType:enum
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: RISK_LEVEL_ORIGIN entry");
            AttributeTraits<ATTR_RISK_LEVEL_ORIGIN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_RISK_LEVEL_ORIGIN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_RNG_BAR_SIZE): { break; }
        case (ATTR_RNG_BASE_ADDR): { break; }
        case (ATTR_RUN_MAX_MEM_PATTERNS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: RUN_MAX_MEM_PATTERNS entry");
            AttributeTraits<ATTR_RUN_MAX_MEM_PATTERNS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_RUN_MAX_MEM_PATTERNS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SAVED_STATE_UINT8): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SAVED_STATE_UINT8 entry");
            AttributeTraits<ATTR_SAVED_STATE_UINT8>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SAVED_STATE_UINT8>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SBE_COMMIT_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SBE_COMMIT_ID entry");
            AttributeTraits<ATTR_SBE_COMMIT_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SBE_COMMIT_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SBE_IS_STARTED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SBE_IS_STARTED entry");
            AttributeTraits<ATTR_SBE_IS_STARTED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SBE_IS_STARTED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SBE_UPDATE_DISABLE): { break; }
        case (ATTR_SBE_VERSION_INFO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SBE_VERSION_INFO entry");
            AttributeTraits<ATTR_SBE_VERSION_INFO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SBE_VERSION_INFO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCOM_SWITCHES): {
            TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SCOM_SWITCHES skipped -- complexType");
            attrSize = 0;
            break;
        }
        case (ATTR_SECUREBOOT_PROTECT_DECONFIGURED_TPM): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SECUREBOOT_PROTECT_DECONFIGURED_TPM entry");
            AttributeTraits<ATTR_SECUREBOOT_PROTECT_DECONFIGURED_TPM>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SECUREBOOT_PROTECT_DECONFIGURED_TPM>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SLOT_INDEX): { break; }
        case (ATTR_SLOT_NAME): { break; }
        case (ATTR_SOCKET_POWER_NOMINAL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SOCKET_POWER_NOMINAL entry");
            AttributeTraits<ATTR_SOCKET_POWER_NOMINAL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SOCKET_POWER_NOMINAL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SOCKET_POWER_TURBO): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SOCKET_POWER_TURBO entry");
            AttributeTraits<ATTR_SOCKET_POWER_TURBO>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SOCKET_POWER_TURBO>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SP_FUNCTIONS): { break; }
        case (ATTR_START_MEM_ADDRESS_FOR_PAYLOAD_TCE_TOKEN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: START_MEM_ADDRESS_FOR_PAYLOAD_TCE_TOKEN entry");
            AttributeTraits<ATTR_START_MEM_ADDRESS_FOR_PAYLOAD_TCE_TOKEN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_START_MEM_ADDRESS_FOR_PAYLOAD_TCE_TOKEN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_STOP5_DISABLE): { break; }
        case (ATTR_SUPPORTED_STOP_STATES): { break; }
        case (ATTR_SUPPORTS_DYNAMIC_MEM_VOLT): { break; }
        case (ATTR_SYNC_BETWEEN_STEPS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SYNC_BETWEEN_STEPS entry");
            AttributeTraits<ATTR_SYNC_BETWEEN_STEPS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SYNC_BETWEEN_STEPS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SYSTEM_FAMILY): { break; }
        case (ATTR_SYSTEM_TYPE): { break; }
        case (ATTR_TCE_START_TOKEN_FOR_HDAT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: TCE_START_TOKEN_FOR_HDAT entry");
            AttributeTraits<ATTR_TCE_START_TOKEN_FOR_HDAT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_TCE_START_TOKEN_FOR_HDAT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_TCE_START_TOKEN_FOR_PAYLOAD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: TCE_START_TOKEN_FOR_PAYLOAD entry");
            AttributeTraits<ATTR_TCE_START_TOKEN_FOR_PAYLOAD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_TCE_START_TOKEN_FOR_PAYLOAD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_TEMP_SENSOR_I2C_CONFIG): { break; }
        case (ATTR_TEST_NEGATIVE_FCN): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: TEST_NEGATIVE_FCN entry");
            AttributeTraits<ATTR_TEST_NEGATIVE_FCN>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_TEST_NEGATIVE_FCN>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_THREAD_COUNT): { break; }
        case (ATTR_TIME_BASE): { break; }
        case (ATTR_TLB_DATA_ASSOC_SETS): { break; }
        case (ATTR_TLB_DATA_ENTRIES): { break; }
        case (ATTR_TLB_INSTR_ASSOC_SETS): { break; }
        case (ATTR_TLB_INSTR_ENTRIES): { break; }
        case (ATTR_TLB_RESERVE_SIZE): { break; }
        case (ATTR_TOD_CPU_DATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: TOD_CPU_DATA entry");
            AttributeTraits<ATTR_TOD_CPU_DATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_TOD_CPU_DATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_TOD_ROLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: TOD_ROLE entry");
            AttributeTraits<ATTR_TOD_ROLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_TOD_ROLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_TPM_INFO): { break; }
        case (ATTR_TPM_POISONED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: TPM_POISONED entry");
            AttributeTraits<ATTR_TPM_POISONED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_TPM_POISONED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_TPM_REQUIRED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: TPM_REQUIRED entry");
            AttributeTraits<ATTR_TPM_REQUIRED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_TPM_REQUIRED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_TPM_UNUSABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: TPM_UNUSABLE entry");
            AttributeTraits<ATTR_TPM_UNUSABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_TPM_UNUSABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_TYPE): { break; }
        case (ATTR_UCD_MFR_REVISION_OVERRIDE): { break; }
        case (ATTR_ULTRA_TURBO_FREQ_MHZ): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ULTRA_TURBO_FREQ_MHZ entry");
            AttributeTraits<ATTR_ULTRA_TURBO_FREQ_MHZ>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ULTRA_TURBO_FREQ_MHZ>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_USE_TCES_FOR_DMAS): { break; }
        case (ATTR_VCS_ID): { break; }
        case (ATTR_VDDR_ID): { break; }
        case (ATTR_VDD_ID): { break; }
        case (ATTR_VENDOR_ID): { break; }
        case (ATTR_VPD_REC_NUM): { break; }
        case (ATTR_VPP_ID): { break; }
        case (ATTR_WOF_POWER_LIMIT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: WOF_POWER_LIMIT entry");
            AttributeTraits<ATTR_WOF_POWER_LIMIT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_WOF_POWER_LIMIT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_WOF_TABLE_LID_NUMBER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: WOF_TABLE_LID_NUMBER entry");
            AttributeTraits<ATTR_WOF_TABLE_LID_NUMBER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_WOF_TABLE_LID_NUMBER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_XIVE_CONTROLLER_BAR_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: XIVE_CONTROLLER_BAR_ADDR entry");
            AttributeTraits<ATTR_XIVE_CONTROLLER_BAR_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_XIVE_CONTROLLER_BAR_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_XIVE_THREAD_MGMT1_BAR_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: XIVE_THREAD_MGMT1_BAR_ADDR entry");
            AttributeTraits<ATTR_XIVE_THREAD_MGMT1_BAR_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_XIVE_THREAD_MGMT1_BAR_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_XSCOM_BASE_ADDRESS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: XSCOM_BASE_ADDRESS entry");
            AttributeTraits<ATTR_XSCOM_BASE_ADDRESS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_XSCOM_BASE_ADDRESS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ALLOW_ATTR_OVERRIDES_IN_SECURE_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ALLOW_ATTR_OVERRIDES_IN_SECURE_MODE entry");
            AttributeTraits<ATTR_ALLOW_ATTR_OVERRIDES_IN_SECURE_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ALLOW_ATTR_OVERRIDES_IN_SECURE_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ASSUME_SBE_QUIESCED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ASSUME_SBE_QUIESCED entry");
            AttributeTraits<ATTR_ASSUME_SBE_QUIESCED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ASSUME_SBE_QUIESCED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ATTN_CHK_ALL_PROCS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ATTN_CHK_ALL_PROCS entry");
            AttributeTraits<ATTR_ATTN_CHK_ALL_PROCS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ATTN_CHK_ALL_PROCS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CENTAUR_REGISTER_CACHE_PTR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CENTAUR_REGISTER_CACHE_PTR entry");
            AttributeTraits<ATTR_CENTAUR_REGISTER_CACHE_PTR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CENTAUR_REGISTER_CACHE_PTR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CHKSTOP_ANALYSIS_ON_STARTUP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CHKSTOP_ANALYSIS_ON_STARTUP entry");
            AttributeTraits<ATTR_CHKSTOP_ANALYSIS_ON_STARTUP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CHKSTOP_ANALYSIS_ON_STARTUP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CLEAR_DIMM_SPD_ENABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CLEAR_DIMM_SPD_ENABLE entry");
            AttributeTraits<ATTR_CLEAR_DIMM_SPD_ENABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CLEAR_DIMM_SPD_ENABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_DIMM_SPD_BYTE_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: DIMM_SPD_BYTE_SIZE entry");
            AttributeTraits<ATTR_DIMM_SPD_BYTE_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_DIMM_SPD_BYTE_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_DRTM_PAYLOAD_ADDR_MB_HB): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: DRTM_PAYLOAD_ADDR_MB_HB entry");
            AttributeTraits<ATTR_DRTM_PAYLOAD_ADDR_MB_HB>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_DRTM_PAYLOAD_ADDR_MB_HB>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_EARLY_TESTCASES_ISTEP): { break; }
        case (ATTR_EEPROM_PAGE_ARRAY): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: EEPROM_PAGE_ARRAY entry");
            AttributeTraits<ATTR_EEPROM_PAGE_ARRAY>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_EEPROM_PAGE_ARRAY>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_FORCE_PRE_PAYLOAD_DRTM): { break; }
        case (ATTR_FSI_MASTER_MUTEX): { break; }
        case (ATTR_FSI_SCOM_MUTEX): { break; }
        case (ATTR_HBRT_HYP_ID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HBRT_HYP_ID entry");
            AttributeTraits<ATTR_HBRT_HYP_ID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HBRT_HYP_ID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HB_EXISTING_IMAGE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HB_EXISTING_IMAGE entry");
            AttributeTraits<ATTR_HB_EXISTING_IMAGE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HB_EXISTING_IMAGE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HB_INITIATED_PM_RESET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HB_INITIATED_PM_RESET entry");
            AttributeTraits<ATTR_HB_INITIATED_PM_RESET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HB_INITIATED_PM_RESET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HB_MUTEX_TEST_LOCK): { break; }
        case (ATTR_HB_NODE_COMM_ABUS_MUTEX): { break; }
        case (ATTR_HB_NODE_COMM_XBUS_MUTEX): { break; }
        case (ATTR_HB_RSV_MEM_NEXT_SECTION): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HB_RSV_MEM_NEXT_SECTION entry");
            AttributeTraits<ATTR_HB_RSV_MEM_NEXT_SECTION>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HB_RSV_MEM_NEXT_SECTION>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HB_SBE_SEEPROM_VERSION_MISMATCH): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HB_SBE_SEEPROM_VERSION_MISMATCH entry");
            AttributeTraits<ATTR_HB_SBE_SEEPROM_VERSION_MISMATCH>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HB_SBE_SEEPROM_VERSION_MISMATCH>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HB_TARGET_SCOMABLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HB_TARGET_SCOMABLE entry");
            AttributeTraits<ATTR_HB_TARGET_SCOMABLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HB_TARGET_SCOMABLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HB_TPM_INIT_ATTEMPTED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HB_TPM_INIT_ATTEMPTED entry");
            AttributeTraits<ATTR_HB_TPM_INIT_ATTEMPTED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HB_TPM_INIT_ATTEMPTED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HB_TPM_LOG_MGR_PTR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HB_TPM_LOG_MGR_PTR entry");
            AttributeTraits<ATTR_HB_TPM_LOG_MGR_PTR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HB_TPM_LOG_MGR_PTR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HB_TPM_MUTEX): { break; }
        case (ATTR_HIDDEN_ERRLOGS_ENABLE): { break; }
        case (ATTR_HOMER_HCODE_LOADED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HOMER_HCODE_LOADED entry");
            AttributeTraits<ATTR_HOMER_HCODE_LOADED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HOMER_HCODE_LOADED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HOMER_VIRT_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HOMER_VIRT_ADDR entry");
            AttributeTraits<ATTR_HOMER_VIRT_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HOMER_VIRT_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_I2C_PAGE_MUTEX_0): { break; }
        case (ATTR_I2C_PAGE_MUTEX_1): { break; }
        case (ATTR_I2C_PAGE_MUTEX_2): { break; }
        case (ATTR_I2C_PAGE_MUTEX_3): { break; }
        case (ATTR_IBSCOM_ENABLE_OVERRIDE): { break; }
        case (ATTR_IBSCOM_MUTEX): { break; }
        case (ATTR_IBSCOM_VIRTUAL_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IBSCOM_VIRTUAL_ADDR entry");
            AttributeTraits<ATTR_IBSCOM_VIRTUAL_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IBSCOM_VIRTUAL_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IPC_NODE_BUFFER_GLOBAL_ADDRESS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IPC_NODE_BUFFER_GLOBAL_ADDRESS entry");
            AttributeTraits<ATTR_IPC_NODE_BUFFER_GLOBAL_ADDRESS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IPC_NODE_BUFFER_GLOBAL_ADDRESS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IS_DRTM_MPIPL_HB): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IS_DRTM_MPIPL_HB entry");
            AttributeTraits<ATTR_IS_DRTM_MPIPL_HB>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IS_DRTM_MPIPL_HB>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IS_MPIPL_HB): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IS_MPIPL_HB entry");
            AttributeTraits<ATTR_IS_MPIPL_HB>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IS_MPIPL_HB>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IS_SLAVE_DRAWER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IS_SLAVE_DRAWER entry");
            AttributeTraits<ATTR_IS_SLAVE_DRAWER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IS_SLAVE_DRAWER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MASTER_MBOX_SCRATCH): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MASTER_MBOX_SCRATCH entry");
            AttributeTraits<ATTR_MASTER_MBOX_SCRATCH>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MASTER_MBOX_SCRATCH>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MEMD_OFFSET): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MEMD_OFFSET entry");
            AttributeTraits<ATTR_MEMD_OFFSET>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MEMD_OFFSET>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MMIO_VM_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MMIO_VM_ADDR entry");
            AttributeTraits<ATTR_MMIO_VM_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MMIO_VM_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MPIPL_HB_MDRT_COUNT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MPIPL_HB_MDRT_COUNT entry");
            AttributeTraits<ATTR_MPIPL_HB_MDRT_COUNT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MPIPL_HB_MDRT_COUNT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MRW_DDR3_VDDR_MAX_LIMIT_EFF_CONFIG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MRW_DDR3_VDDR_MAX_LIMIT_EFF_CONFIG entry");
            AttributeTraits<ATTR_MRW_DDR3_VDDR_MAX_LIMIT_EFF_CONFIG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MRW_DDR3_VDDR_MAX_LIMIT_EFF_CONFIG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MRW_DDR4_VDDR_MAX_LIMIT_EFF_CONFIG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MRW_DDR4_VDDR_MAX_LIMIT_EFF_CONFIG entry");
            AttributeTraits<ATTR_MRW_DDR4_VDDR_MAX_LIMIT_EFF_CONFIG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MRW_DDR4_VDDR_MAX_LIMIT_EFF_CONFIG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_DDR3_VDDR_INTERCEPT_EFF_CONFIG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_DDR3_VDDR_INTERCEPT_EFF_CONFIG entry");
            AttributeTraits<ATTR_MSS_VOLT_DDR3_VDDR_INTERCEPT_EFF_CONFIG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_DDR3_VDDR_INTERCEPT_EFF_CONFIG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_DDR3_VDDR_SLOPE_EFF_CONFIG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_DDR3_VDDR_SLOPE_EFF_CONFIG entry");
            AttributeTraits<ATTR_MSS_VOLT_DDR3_VDDR_SLOPE_EFF_CONFIG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_DDR3_VDDR_SLOPE_EFF_CONFIG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_DDR4_VDDR_INTERCEPT_EFF_CONFIG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_DDR4_VDDR_INTERCEPT_EFF_CONFIG entry");
            AttributeTraits<ATTR_MSS_VOLT_DDR4_VDDR_INTERCEPT_EFF_CONFIG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_DDR4_VDDR_INTERCEPT_EFF_CONFIG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_DDR4_VDDR_SLOPE_EFF_CONFIG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_DDR4_VDDR_SLOPE_EFF_CONFIG entry");
            AttributeTraits<ATTR_MSS_VOLT_DDR4_VDDR_SLOPE_EFF_CONFIG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_DDR4_VDDR_SLOPE_EFF_CONFIG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_VPP_INTERCEPT_EFF_CONFIG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_VPP_INTERCEPT_EFF_CONFIG entry");
            AttributeTraits<ATTR_MSS_VOLT_VPP_INTERCEPT_EFF_CONFIG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_VPP_INTERCEPT_EFF_CONFIG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MSS_VOLT_VPP_SLOPE_EFF_CONFIG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_VOLT_VPP_SLOPE_EFF_CONFIG entry");
            AttributeTraits<ATTR_MSS_VOLT_VPP_SLOPE_EFF_CONFIG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_VOLT_VPP_SLOPE_EFF_CONFIG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_OCC_COMMON_AREA_PHYS_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: OCC_COMMON_AREA_PHYS_ADDR entry");
            AttributeTraits<ATTR_OCC_COMMON_AREA_PHYS_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_OCC_COMMON_AREA_PHYS_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_OVERRIDES_ATTEMPTED_FLAG): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: OVERRIDES_ATTEMPTED_FLAG entry");
            AttributeTraits<ATTR_OVERRIDES_ATTEMPTED_FLAG>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_OVERRIDES_ATTEMPTED_FLAG>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PART_NUMBER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PART_NUMBER entry");
            AttributeTraits<ATTR_PART_NUMBER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PART_NUMBER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PDA_CAPTURED_THREAD_REG_ARRAY_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PDA_CAPTURED_THREAD_REG_ARRAY_ADDR entry");
            AttributeTraits<ATTR_PDA_CAPTURED_THREAD_REG_ARRAY_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PDA_CAPTURED_THREAD_REG_ARRAY_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PDA_CAPTURED_THREAD_REG_ARRAY_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PDA_CAPTURED_THREAD_REG_ARRAY_SIZE entry");
            AttributeTraits<ATTR_PDA_CAPTURED_THREAD_REG_ARRAY_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PDA_CAPTURED_THREAD_REG_ARRAY_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PDA_THREAD_REG_ENTRY_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PDA_THREAD_REG_ENTRY_SIZE entry");
            AttributeTraits<ATTR_PDA_THREAD_REG_ENTRY_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PDA_THREAD_REG_ENTRY_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PDA_THREAD_REG_STATE_ENTRY_FORMAT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PDA_THREAD_REG_STATE_ENTRY_FORMAT entry");
            AttributeTraits<ATTR_PDA_THREAD_REG_STATE_ENTRY_FORMAT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PDA_THREAD_REG_STATE_ENTRY_FORMAT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SBE_COMM_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SBE_COMM_ADDR entry");
            AttributeTraits<ATTR_SBE_COMM_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SBE_COMM_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SBE_FFDC_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SBE_FFDC_ADDR entry");
            AttributeTraits<ATTR_SBE_FFDC_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SBE_FFDC_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SCAN_MUTEX): { break; }
        case (ATTR_SCOM_IND_MUTEX): { break; }
        case (ATTR_SERIAL_NUMBER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SERIAL_NUMBER entry");
            AttributeTraits<ATTR_SERIAL_NUMBER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SERIAL_NUMBER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SPCWKUP_COUNT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SPCWKUP_COUNT entry");
            AttributeTraits<ATTR_SPCWKUP_COUNT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SPCWKUP_COUNT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_TPM_MODEL): { break; }
        case (ATTR_TPM_ROLE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: TPM_ROLE entry");
            AttributeTraits<ATTR_TPM_ROLE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_TPM_ROLE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_VPD_SWITCHES): {
            TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: VPD_SWITCHES skipped -- complexType");
            attrSize = 0;
            break;
        }
        case (ATTR_WOF_FREQUENCY_UPLIFT_SELECTED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: WOF_FREQUENCY_UPLIFT_SELECTED entry");
            AttributeTraits<ATTR_WOF_FREQUENCY_UPLIFT_SELECTED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_WOF_FREQUENCY_UPLIFT_SELECTED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_XSCOM_VIRTUAL_ADDR): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: XSCOM_VIRTUAL_ADDR entry");
            AttributeTraits<ATTR_XSCOM_VIRTUAL_ADDR>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_XSCOM_VIRTUAL_ADDR>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ASCII_VPD_LX_KEYWORD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ASCII_VPD_LX_KEYWORD entry");
            AttributeTraits<ATTR_ASCII_VPD_LX_KEYWORD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ASCII_VPD_LX_KEYWORD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CHIP_VER): { break; }
        case (ATTR_CREATE_DEF_PARTITION): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CREATE_DEF_PARTITION entry");
            AttributeTraits<ATTR_CREATE_DEF_PARTITION>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CREATE_DEF_PARTITION>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ENLARGED_IO_SLOT_COUNT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: ENLARGED_IO_SLOT_COUNT entry");
            AttributeTraits<ATTR_ENLARGED_IO_SLOT_COUNT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_ENLARGED_IO_SLOT_COUNT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HUGE_PAGE_COUNT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HUGE_PAGE_COUNT entry");
            AttributeTraits<ATTR_HUGE_PAGE_COUNT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HUGE_PAGE_COUNT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HUGE_PAGE_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HUGE_PAGE_SIZE entry");
            AttributeTraits<ATTR_HUGE_PAGE_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HUGE_PAGE_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HW_VER): { break; }
        case (ATTR_HYPERVISOR_IPL_DESTINATION): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HYPERVISOR_IPL_DESTINATION entry");
            AttributeTraits<ATTR_HYPERVISOR_IPL_DESTINATION>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HYPERVISOR_IPL_DESTINATION>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HYPERVISOR_IPL_SIDE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HYPERVISOR_IPL_SIDE entry");
            AttributeTraits<ATTR_HYPERVISOR_IPL_SIDE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HYPERVISOR_IPL_SIDE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HYP_DISPATCH_WHEEL): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HYP_DISPATCH_WHEEL entry");
            AttributeTraits<ATTR_HYP_DISPATCH_WHEEL>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HYP_DISPATCH_WHEEL>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IPL_ATTRIBUTES): {
            TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IPL_ATTRIBUTES skipped -- complexType");
            attrSize = 0;
            break;
        }
        case (ATTR_IPS_ENABLE): { break; }
        case (ATTR_IPS_ENTER_TIME_SECONDS): { break; }
        case (ATTR_IPS_ENTER_UTILIZATION_PERCENT): { break; }
        case (ATTR_IPS_EXIT_TIME_SECONDS): { break; }
        case (ATTR_IPS_EXIT_UTILIZATION_PERCENT): { break; }
        case (ATTR_LMB_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: LMB_SIZE entry");
            AttributeTraits<ATTR_LMB_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_LMB_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_MAX_HSL_OPTICONNECT_CONNECTIONS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MAX_HSL_OPTICONNECT_CONNECTIONS entry");
            AttributeTraits<ATTR_MAX_HSL_OPTICONNECT_CONNECTIONS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MAX_HSL_OPTICONNECT_CONNECTIONS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_OPEN_POWER_PM_MODE): { break; }
        case (ATTR_OPEN_POWER_PM_MODE_FREQ_PERCENT): { break; }
        case (ATTR_OS_IPL_MODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: OS_IPL_MODE entry");
            AttributeTraits<ATTR_OS_IPL_MODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_OS_IPL_MODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PHYP_SYSTEM_TYPE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PHYP_SYSTEM_TYPE entry");
            AttributeTraits<ATTR_PHYP_SYSTEM_TYPE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PHYP_SYSTEM_TYPE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PRESERVE_MDC_PARTITION_VPD): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: PRESERVE_MDC_PARTITION_VPD entry");
            AttributeTraits<ATTR_PRESERVE_MDC_PARTITION_VPD>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_PRESERVE_MDC_PARTITION_VPD>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_HW_TOPOLOGY): { break; }
        case (ATTR_ROLE): { break; }
        case (ATTR_SLCA_INDEX): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SLCA_INDEX entry");
            AttributeTraits<ATTR_SLCA_INDEX>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SLCA_INDEX>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SLCA_RID): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: SLCA_RID entry");
            AttributeTraits<ATTR_SLCA_RID>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_SLCA_RID>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_SW_VER): { break; }
        case (ATTR_VLAN_SWITCHES): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: VLAN_SWITCHES entry");
            AttributeTraits<ATTR_VLAN_SWITCHES>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_VLAN_SWITCHES>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_VTPM_ENABLED): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: VTPM_ENABLED entry");
            AttributeTraits<ATTR_VTPM_ENABLED>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_VTPM_ENABLED>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_ADC_CHANNEL_FUNC_IDS): { break; }
        case (ATTR_ADC_CHANNEL_GAINS): { break; }
        case (ATTR_ADC_CHANNEL_GNDS): { break; }
        case (ATTR_ADC_CHANNEL_OFFSETS): { break; }
        case (ATTR_ADC_CHANNEL_SENSOR_NUMBERS): { break; }
        case (ATTR_ALLOW_CALLHOME_ESELS_TO_BMC): { break; }
        case (ATTR_APSS_GPIO_PORT_MODES): { break; }
        case (ATTR_APSS_GPIO_PORT_PINS): { break; }
        case (ATTR_BMC_HW_CHIP_TYPE): { break; }
        case (ATTR_BMC_MANUFACTURER): { break; }
        case (ATTR_BMC_MAX_ERROR_LOG_SIZE): { break; }
        case (ATTR_BMC_SW_TYPE): { break; }
        case (ATTR_CALCULATED_MAX_SYS_POWER_EXCLUDING_GPUS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CALCULATED_MAX_SYS_POWER_EXCLUDING_GPUS entry");
            AttributeTraits<ATTR_CALCULATED_MAX_SYS_POWER_EXCLUDING_GPUS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CALCULATED_MAX_SYS_POWER_EXCLUDING_GPUS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CALCULATED_PROC_MEMORY_POWER_DROP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CALCULATED_PROC_MEMORY_POWER_DROP entry");
            AttributeTraits<ATTR_CALCULATED_PROC_MEMORY_POWER_DROP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CALCULATED_PROC_MEMORY_POWER_DROP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_CUMULATIVE_PMCOMPLEX_RESET_COUNT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: CUMULATIVE_PMCOMPLEX_RESET_COUNT entry");
            AttributeTraits<ATTR_CUMULATIVE_PMCOMPLEX_RESET_COUNT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_CUMULATIVE_PMCOMPLEX_RESET_COUNT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_GPIO_INFO): { break; }
        case (ATTR_GPU_SENSORS): { break; }
        case (ATTR_HDAT_I2C_ADDR): { break; }
        case (ATTR_HDAT_I2C_BUS_FREQ): { break; }
        case (ATTR_HDAT_I2C_DEVICE_LABEL): { break; }
        case (ATTR_HDAT_I2C_DEVICE_PURPOSE): { break; }
        case (ATTR_HDAT_I2C_DEVICE_TYPE): { break; }
        case (ATTR_HDAT_I2C_ELEMENTS): { break; }
        case (ATTR_HDAT_I2C_ENGINE): { break; }
        case (ATTR_HDAT_I2C_MASTER_PORT): { break; }
        case (ATTR_HDAT_I2C_SLAVE_PORT): { break; }
        case (ATTR_HTMGT_INTERNAL_FLAGS): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMGT_INTERNAL_FLAGS entry");
            AttributeTraits<ATTR_HTMGT_INTERNAL_FLAGS>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMGT_INTERNAL_FLAGS>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMGT_PMCOMPLEX_RESET_COUNT_TIMER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMGT_PMCOMPLEX_RESET_COUNT_TIMER entry");
            AttributeTraits<ATTR_HTMGT_PMCOMPLEX_RESET_COUNT_TIMER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMGT_PMCOMPLEX_RESET_COUNT_TIMER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMGT_SAFEMODE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMGT_SAFEMODE entry");
            AttributeTraits<ATTR_HTMGT_SAFEMODE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMGT_SAFEMODE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_HTMGT_SAVED_POWER_LIMIT): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: HTMGT_SAVED_POWER_LIMIT entry");
            AttributeTraits<ATTR_HTMGT_SAVED_POWER_LIMIT>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_HTMGT_SAVED_POWER_LIMIT>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IPMI_INSTANCE): { break; }
        case (ATTR_IPMI_MAX_BUFFER_SIZE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: IPMI_MAX_BUFFER_SIZE entry");
            AttributeTraits<ATTR_IPMI_MAX_BUFFER_SIZE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_IPMI_MAX_BUFFER_SIZE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_IPMI_SENSORS): { break; }
        case (ATTR_IS_MPIPL_SUPPORTED): { break; }
        case (ATTR_MAX_VDD_CURRENT_READING): { break; }
        case (ATTR_MISC_SYSTEM_COMPONENTS_MAX_POWER_WATTS): { break; }
        case (ATTR_MRW_SAFEMODE_MEM_THROTTLE_NUMERATOR_PER_CHIP): { break; }
        case (ATTR_MSS_UTIL_N_PER_MBA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: MSS_UTIL_N_PER_MBA entry");
            AttributeTraits<ATTR_MSS_UTIL_N_PER_MBA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_MSS_UTIL_N_PER_MBA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_NO_APSS_PROC_POWER_VCS_VIO_WATTS): { break; }
        case (ATTR_N_PLUS_ONE_MEM_POWER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: N_PLUS_ONE_MEM_POWER entry");
            AttributeTraits<ATTR_N_PLUS_ONE_MEM_POWER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_N_PLUS_ONE_MEM_POWER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_N_PLUS_ONE_N_PER_CHIP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: N_PLUS_ONE_N_PER_CHIP entry");
            AttributeTraits<ATTR_N_PLUS_ONE_N_PER_CHIP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_N_PLUS_ONE_N_PER_CHIP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_N_PLUS_ONE_N_PER_MBA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: N_PLUS_ONE_N_PER_MBA entry");
            AttributeTraits<ATTR_N_PLUS_ONE_N_PER_MBA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_N_PLUS_ONE_N_PER_MBA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_OCC_CONTROL_DATA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: OCC_CONTROL_DATA entry");
            AttributeTraits<ATTR_OCC_CONTROL_DATA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_OCC_CONTROL_DATA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_OPAL_MODEL): { break; }
        case (ATTR_OPEN_POWER_DIMM_ERROR_TEMP_DEG_C): { break; }
        case (ATTR_OPEN_POWER_DIMM_READ_TIMEOUT_SEC): { break; }
        case (ATTR_OPEN_POWER_DIMM_THROTTLE_TEMP_DEG_C): { break; }
        case (ATTR_OPEN_POWER_GPU_ERROR_TEMP_DEG_C): { break; }
        case (ATTR_OPEN_POWER_GPU_MEM_ERROR_TEMP_DEG_C): { break; }
        case (ATTR_OPEN_POWER_GPU_MEM_READ_TIMEOUT_SEC): { break; }
        case (ATTR_OPEN_POWER_GPU_READ_TIMEOUT_SEC): { break; }
        case (ATTR_OPEN_POWER_MEMCTRL_ERROR_TEMP_DEG_C): { break; }
        case (ATTR_OPEN_POWER_MEMCTRL_READ_TIMEOUT_SEC): { break; }
        case (ATTR_OPEN_POWER_MEMCTRL_THROTTLE_TEMP_DEG_C): { break; }
        case (ATTR_OPEN_POWER_MIN_MEM_UTILIZATION_POWER_CAP): { break; }
        case (ATTR_OPEN_POWER_MIN_MEM_UTILIZATION_THROTTLING): { break; }
        case (ATTR_OPEN_POWER_MIN_POWER_CAP_WATTS): { break; }
        case (ATTR_OPEN_POWER_N_BULK_POWER_LIMIT_WATTS): { break; }
        case (ATTR_OPEN_POWER_N_MAX_MEM_POWER_WATTS): { break; }
        case (ATTR_OPEN_POWER_N_PLUS_ONE_BULK_POWER_LIMIT_WATTS): { break; }
        case (ATTR_OPEN_POWER_N_PLUS_ONE_HPC_BULK_POWER_LIMIT_WATTS): { break; }
        case (ATTR_OPEN_POWER_N_PLUS_ONE_MAX_MEM_POWER_WATTS): { break; }
        case (ATTR_OPEN_POWER_PROC_DVFS_TEMP_DEG_C): { break; }
        case (ATTR_OPEN_POWER_PROC_ERROR_TEMP_DEG_C): { break; }
        case (ATTR_OPEN_POWER_PROC_READ_TIMEOUT_SEC): { break; }
        case (ATTR_OPEN_POWER_PROC_WEIGHT): { break; }
        case (ATTR_OPEN_POWER_QUAD_WEIGHT): { break; }
        case (ATTR_OPEN_POWER_REGULATOR_EFFICIENCY_FACTOR): { break; }
        case (ATTR_OPEN_POWER_SOFT_MIN_PCAP_WATTS): { break; }
        case (ATTR_OPEN_POWER_TURBO_MODE_SUPPORTED): { break; }
        case (ATTR_OPEN_POWER_VRM_READ_TIMEOUT_SEC): { break; }
        case (ATTR_OPEN_POWER_VRM_VDD_DVFS_TEMP_DEG_C): { break; }
        case (ATTR_OPEN_POWER_VRM_VDD_ERROR_TEMP_DEG_C): { break; }
        case (ATTR_OPEN_POWER_VRM_VDD_READ_TIMEOUT_SEC): { break; }
        case (ATTR_OP_TRACE_LITE): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: OP_TRACE_LITE entry");
            AttributeTraits<ATTR_OP_TRACE_LITE>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_OP_TRACE_LITE>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_OT_MEM_POWER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: OT_MEM_POWER entry");
            AttributeTraits<ATTR_OT_MEM_POWER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_OT_MEM_POWER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_OT_MIN_N_PER_MBA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: OT_MIN_N_PER_MBA entry");
            AttributeTraits<ATTR_OT_MIN_N_PER_MBA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_OT_MIN_N_PER_MBA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_POWERCAP_MEM_POWER): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: POWERCAP_MEM_POWER entry");
            AttributeTraits<ATTR_POWERCAP_MEM_POWER>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_POWERCAP_MEM_POWER>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_POWERCAP_N_PER_CHIP): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: POWERCAP_N_PER_CHIP entry");
            AttributeTraits<ATTR_POWERCAP_N_PER_CHIP>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_POWERCAP_N_PER_CHIP>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_POWERCAP_N_PER_MBA): { //simpleType:uint, :int...
            //TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: POWERCAP_N_PER_MBA entry");
            AttributeTraits<ATTR_POWERCAP_N_PER_MBA>::Type tmp;
            if( iv_pTarget->tryGetAttr<ATTR_POWERCAP_N_PER_MBA>(tmp) ) {
                tmpBuffer = new char[sizeof(tmp)];
                memcpy(tmpBuffer, &tmp, sizeof(tmp));
                attrSize = sizeof(tmp);
            }
            break;
        }
        case (ATTR_PROC_MHZ_PER_WATT): { break; }
        case (ATTR_PROC_SOCKET_POWER_WATTS): { break; }
        case (ATTR_REPORT_THROTTLE_BELOW_NOMINAL): { break; }
        case (ATTR_VDD_CURRENT_OVERFLOW_WORKAROUND_ENABLE): { break; }
        default: { //Shouldn't be anything here!!
            TRACDCOMP( g_trac_errl, "ErrlUserDetailsAttribute: UNKNOWN i_attr %x", i_attr);
            break;
        }
#endif //@fixme-RTC:152874
    } //switch

    // if we generated one, copy the string into the buffer
    if (attrSize) { // we have something to output
        // resize buffer and copy string into it
        uint8_t * pBuf;
        pBuf = reinterpret_cast<uint8_t *>(reallocUsrBuf(iv_dataSize + attrSize + sizeof(i_attr) ));
        memcpy(pBuf + iv_dataSize, &i_attr, sizeof(i_attr)); // first dump the attr enum
        iv_dataSize += sizeof(i_attr);
        memcpy(pBuf + iv_dataSize, tmpBuffer, attrSize); // copy into iv_pBuffer
        iv_dataSize += attrSize;
    }
    delete [] tmpBuffer;
}


//------------------------------------------------------------------------------
ErrlUserDetailsAttribute::ErrlUserDetailsAttribute(
    const Target * i_pTarget, uint32_t i_attr)
    : iv_pTarget(i_pTarget), iv_dataSize(0)
{
    // Set up ErrlUserDetails instance variables
    iv_CompId = ERRL_COMP_ID;
    iv_Version = 1;
    iv_SubSection = ERRL_UDT_ATTRIBUTE;
    // override the default of false
    iv_merge = true;

    // first, write out the HUID
    addData(ATTR_HUID);
    if (i_attr != ATTR_HUID) {
        addData(i_attr);
    }
}

//------------------------------------------------------------------------------
ErrlUserDetailsAttribute::ErrlUserDetailsAttribute(
    const Target * i_pTarget)
    : iv_pTarget(i_pTarget), iv_dataSize(0)
{
    // Set up ErrlUserDetails instance variables
    iv_CompId = ERRL_COMP_ID;
    iv_Version = 1;
    iv_SubSection = ERRL_UDT_ATTRIBUTE;
    // override the default of false
    iv_merge = true;

    dumpAll();
}

//------------------------------------------------------------------------------
void ErrlUserDetailsAttribute::dumpAll()
{
    // write out the HUID first and always
    addData(ATTR_HUID);
    addData(ATTR_SAFE_MODE_NOVDM_UPLIFT_MV);
    addData(ATTR_SAFE_MODE_VOLTAGE_MV);
    addData(ATTR_SAFE_MODE_FREQUENCY_MHZ);
    addData(ATTR_VDD_BOOT_VOLTAGE);
    addData(ATTR_VDN_BOOT_VOLTAGE);
    addData(ATTR_VCS_BOOT_VOLTAGE);
    addData(ATTR_SYSTEM_RESCLK_DISABLE);
    addData(ATTR_SYSTEM_RESCLK_FREQ_REGIONS);
    addData(ATTR_SYSTEM_RESCLK_FREQ_REGION_INDEX);
    addData(ATTR_SYSTEM_RESCLK_VALUE);
    addData(ATTR_SYSTEM_RESCLK_L3_VALUE);
    addData(ATTR_SYSTEM_RESCLK_L3_VOLTAGE_THRESHOLD_MV);
    addData(ATTR_PM_GLOBAL_FIR_TRACE_EN);
    addData(ATTR_FREQ_PB_MHZ_POUNDV_FALLBACK);
    addData(ATTR_SKIP_WAKEUP);
    addData(ATTR_PM_MALF_ALERT_ENABLE);
    addData(ATTR_PM_RESET_FFDC_ENABLE);
    addData(ATTR_UNSECURE_HOMER_ADDRESS);
    addData(ATTR_PMCR_MOST_RECENT_MODE);
    addData(ATTR_IO_XBUS_DCCAL_FLAGS);
    addData(ATTR_IO_XBUS_MASTER_MODE);
    addData(ATTR_IO_XBUS_GRP0_PRE_BAD_LANE_DATA);
    addData(ATTR_IO_XBUS_GRP1_PRE_BAD_LANE_DATA);
    addData(ATTR_DO_MSS_WR_VREF);
    addData(ATTR_SKIP_HW_VREF_CAL);
    addData(ATTR_SKIP_RD_VREF_VREFSENSE_OVERRIDE);
    addData(ATTR_DO_MSS_VREF_DAC);
    addData(ATTR_DO_MSS_TRAINING_BAD_BITS);
    addData(ATTR_MSS_RUN_DCD_CALIBRATION);
    addData(ATTR_PROC_ENABLE_DL_TMPL_1);
    addData(ATTR_PROC_ENABLE_DL_TMPL_4);
    addData(ATTR_PROC_ENABLE_DL_TMPL_7);
    addData(ATTR_PROC_ENABLE_DL_TMPL_A);
    addData(ATTR_PROC_TMPL_0_PACING);
    addData(ATTR_PROC_TMPL_1_PACING);
    addData(ATTR_PROC_TMPL_4_PACING);
    addData(ATTR_PROC_TMPL_7_PACING);
    addData(ATTR_PROC_TMPL_A_PACING);
    addData(ATTR_PROC_OMI_OC_MAJOR_VER);
    addData(ATTR_PROC_OMI_OC_MINOR_VER);
    addData(ATTR_EFF_DRAM_GEN);
    addData(ATTR_EFF_DIMM_TYPE);
    addData(ATTR_EFF_HYBRID_MEMORY_TYPE);
    addData(ATTR_EFF_HYBRID);
    addData(ATTR_EFF_DRAM_DENSITY);
    addData(ATTR_EFF_DRAM_BANK_BITS);
    addData(ATTR_EFF_DRAM_BANK_GROUP_BITS);
    addData(ATTR_EFF_DRAM_COLUMN_BITS);
    addData(ATTR_EFF_DRAM_ROW_BITS);
    addData(ATTR_EFF_PRIM_STACK_TYPE);
    addData(ATTR_EFF_DRAM_PPR);
    addData(ATTR_EFF_DRAM_SOFT_PPR);
    addData(ATTR_EFF_DRAM_TRCD);
    addData(ATTR_EFF_DRAM_TRP);
    addData(ATTR_EFF_DRAM_TRAS);
    addData(ATTR_EFF_DRAM_TRC);
    addData(ATTR_EFF_DRAM_TRFC);
    addData(ATTR_EFF_DRAM_TFAW);
    addData(ATTR_EFF_DRAM_TRRD_S);
    addData(ATTR_EFF_DRAM_TRRD_L);
    addData(ATTR_EFF_DRAM_TCCD_L);
    addData(ATTR_EFF_DRAM_TWR);
    addData(ATTR_EFF_DRAM_TWTR_S);
    addData(ATTR_EFF_DRAM_TWTR_L);
    addData(ATTR_EFF_DRAM_TMAW);
    addData(ATTR_EFF_DRAM_WIDTH);
    addData(ATTR_EFF_DRAM_RANK_MIX);
    addData(ATTR_EFF_NUM_RANKS_PER_DIMM);
    addData(ATTR_EFF_REGISTER_TYPE);
    addData(ATTR_EFF_DRAM_MFG_ID);
    addData(ATTR_EFF_RCD_MFG_ID);
    addData(ATTR_EFF_REGISTER_REV);
    addData(ATTR_EFF_PACKAGE_RANK_MAP);
    addData(ATTR_EFF_NIBBLE_MAP);
    addData(ATTR_PROC_NPU_REGION_ENABLED);
    addData(ATTR_CLOCK_PLL_MUX);
    addData(ATTR_EQ_GARD);
    addData(ATTR_EC_GARD);
    addData(ATTR_NEST_PLL_BUCKET);
    addData(ATTR_FILTER_PLL_BUCKET);
    addData(ATTR_RISK_LEVEL);
    addData(ATTR_BACKUP_SEEPROM_SELECT);
    addData(ATTR_BOOT_FLAGS);
    addData(ATTR_ECID);
    addData(ATTR_MC_SYNC_MODE);
    addData(ATTR_PROC_SBE_MASTER_CHIP);
    addData(ATTR_MASTER_CORE);
    addData(ATTR_MASTER_EX);
    addData(ATTR_PIBMEM_REPAIR0);
    addData(ATTR_PIBMEM_REPAIR1);
    addData(ATTR_PIBMEM_REPAIR2);
    addData(ATTR_SENSEADJ_STEP);
    addData(ATTR_TARGET_HAS_POWER);
    addData(ATTR_TARGET_HAS_CLOCK);
    addData(ATTR_TARGET_IS_SCOMMABLE);
    addData(ATTR_NDL_MESHCTRL_SETUP);
    addData(ATTR_SYSTEM_CORECACHE_SKEWADJ_DISABLE);
    addData(ATTR_SYSTEM_CORECACHE_DCADJ_DISABLE);
    addData(ATTR_PROC_MEM_TO_USE);
    addData(ATTR_ORIG_FIR_SETTINGS_ACTION0);
    addData(ATTR_ORIG_FIR_SETTINGS_ACTION1);
    addData(ATTR_LPC_CONSOLE_CNFG);
    addData(ATTR_MSS_VPD_CKE_MAP);
    addData(ATTR_IO_OBUS_DCCAL_FLAGS);
    addData(ATTR_IO_OBUS_PAT_A_DETECT_RUN);
    addData(ATTR_IO_OBUS_PAT_A_CAPTURE);
    addData(ATTR_IO_OBUS_TRAIN_FOR_RECOVERY);
    addData(ATTR_IO_OBUS_LANE_PDWN);
    addData(ATTR_IO_OLLFIR_MASK);
    addData(ATTR_IO_PB_IOOFIR_MASK);
    addData(ATTR_MSS_VPD_MT_0_VERSION_LAYOUT);
    addData(ATTR_MSS_VPD_MT_1_VERSION_DATA);
    addData(ATTR_MSS_VPD_MT_2_SIGNATURE_HASH);
    addData(ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CA);
    addData(ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CKE);
    addData(ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CS);
    addData(ATTR_MSS_VPD_MT_DIMM_RCD_IBT_ODT);
    addData(ATTR_MSS_VPD_MT_DRAM_DRV_IMP_DQ_DQS);
    addData(ATTR_MSS_VPD_MT_DRAM_RTT_NOM);
    addData(ATTR_MSS_VPD_MT_DRAM_RTT_PARK);
    addData(ATTR_MSS_VPD_MT_DRAM_RTT_WR);
    addData(ATTR_MSS_VPD_MT_MC_BIAS_TRIM);
    addData(ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_RD_UP);
    addData(ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_WR_DOWN);
    addData(ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_WR_UP);
    addData(ATTR_MSS_VPD_MT_MC_DQ_CTLE_CAP);
    addData(ATTR_MSS_VPD_MT_MC_DQ_CTLE_RES);
    addData(ATTR_MSS_VPD_MT_MC_DRV_IMP_CLK);
    addData(ATTR_MSS_VPD_MT_MC_DRV_IMP_CMD_ADDR);
    addData(ATTR_MSS_VPD_MT_MC_DRV_IMP_CNTL);
    addData(ATTR_MSS_VPD_MT_MC_DRV_IMP_CSCID);
    addData(ATTR_MSS_VPD_MT_MC_DRV_IMP_DQ_DQS);
    addData(ATTR_MSS_VPD_MT_MC_RCV_IMP_DQ_DQS);
    addData(ATTR_MSS_VPD_MT_ODT_RD);
    addData(ATTR_MSS_VPD_MT_ODT_WR);
    addData(ATTR_MSS_VPD_MT_PREAMBLE);
    addData(ATTR_MSS_VPD_MT_VREF_DRAM_WR);
    addData(ATTR_MSS_VPD_MT_VREF_MC_RD);
    addData(ATTR_MSS_VPD_MT_WINDAGE_RD_CTR);
    addData(ATTR_HB_HRMOR_BYTES);
    addData(ATTR_NHTM_TRACE_TYPE);
    addData(ATTR_CHTM_TRACE_TYPE);
    addData(ATTR_HTMSC_TTYPEFILT_PAT);
    addData(ATTR_HTMSC_TSIZEFILT_PAT);
    addData(ATTR_HTMSC_TTYPEFILT_MASK);
    addData(ATTR_HTMSC_TSIZEFILT_MASK);
    addData(ATTR_HTMSC_TTYPEFILT_INVERT);
    addData(ATTR_HTMSC_CRESPFILT_INVERT);
    addData(ATTR_HTMSC_FILT_PAT);
    addData(ATTR_HTMSC_FILT_CRESP_PAT);
    addData(ATTR_HTMSC_FILT_MASK);
    addData(ATTR_HTMSC_FILT_CRESP_MASK);
    addData(ATTR_NHTM_HTMSC_MODE_CONTENT_SEL);
    addData(ATTR_NHTM_HTMSC_MODE_CAPTURE_GENERATED_WRITES);
    addData(ATTR_NHTM_HTMSC_MODE_CAPTURE_ENABLE_FILTER_ALL);
    addData(ATTR_NHTM_HTMSC_MODE_CAPTURE_PRECISE_CRESP_MODE);
    addData(ATTR_NHTM_HTMSC_MODE_CAPTURE_LIMIT_MEM_ALLOCATION);
    addData(ATTR_NHTM_HTMSC_MODE_CAPTURE_PMISC_ONLY_CMD);
    addData(ATTR_NHTM_HTMSC_MODE_SYNC_STAMP_FORCE);
    addData(ATTR_NHTM_HTMSC_MODE_WRITETOIO);
    addData(ATTR_CHTM_HTMSC_MODE_CONTENT_SEL);
    addData(ATTR_CHTM_HTMSC_MODE_CAPTURE);
    addData(ATTR_CHTM_HTMSC_MODE_CORE_INSTR_STALL);
    addData(ATTR_HTMSC_MODE_WRAP);
    addData(ATTR_HTMSC_MODE_DIS_TSTAMP);
    addData(ATTR_HTMSC_MODE_SINGLE_TSTAMP);
    addData(ATTR_HTMSC_MODE_MARKERS_ONLY);
    addData(ATTR_HTMSC_MODE_DIS_FORCE_GROUP_SCOPE);
    addData(ATTR_HTMSC_MODE_VGTARGET);
    addData(ATTR_HTMSC_MEM_SCOPE);
    addData(ATTR_HTMSC_MEM_PRIORITY);
    addData(ATTR_NHTM_CTRL_TRIG);
    addData(ATTR_NHTM_CTRL_MARK);
    addData(ATTR_CHTM_CTRL_TRIG);
    addData(ATTR_CHTM_CTRL_MARK);
    addData(ATTR_HTMSC_CTRL_DBG0_STOP);
    addData(ATTR_HTMSC_CTRL_DBG1_STOP);
    addData(ATTR_HTMSC_CTRL_RUN_STOP);
    addData(ATTR_HTMSC_CTRL_OTHER_DBG0_STOP);
    addData(ATTR_HTMSC_CTRL_XSTOP_STOP);
    addData(ATTR_HTMSC_CTRL_CHIP0_STOP);
    addData(ATTR_HTMSC_CTRL_CHIP1_STOP);
    addData(ATTR_HTMSC_IMA_PDBAR_SPLIT_CORE_MODE);
    addData(ATTR_HTMSC_IMA_PDBAR_SCOPE);
    addData(ATTR_HTMSC_IMA_PDBAR_ADDR);
    addData(ATTR_FREQ_PB_MHZ);
    addData(ATTR_FREQ_O_MHZ);
    addData(ATTR_FREQ_A_MHZ);
    addData(ATTR_FREQ_X_MHZ);
    addData(ATTR_PROC_FABRIC_ASYNC_SAFE_MODE);
    addData(ATTR_PROC_FABRIC_CORE_FLOOR_RATIO);
    addData(ATTR_PROC_FABRIC_CORE_CEILING_RATIO);
    addData(ATTR_PROC_FABRIC_OPTICS_CONFIG_MODE);
    addData(ATTR_FABRIC_PRESENT_GROUPS);
    addData(ATTR_FABRIC_ADDR_EXTENSION_GROUP_ID);
    addData(ATTR_FABRIC_ADDR_EXTENSION_CHIP_ID);
    addData(ATTR_PROC_EFF_FABRIC_GROUP_ID);
    addData(ATTR_PROC_EFF_FABRIC_CHIP_ID);
    addData(ATTR_PROC_FABRIC_SYSTEM_MASTER_CHIP);
    addData(ATTR_PROC_FABRIC_GROUP_MASTER_CHIP);
    addData(ATTR_PROC_FABRIC_LINK_ACTIVE);
    addData(ATTR_LINK_TRAIN);
    addData(ATTR_PROC_FABRIC_X_ATTACHED_CHIP_CNFG);
    addData(ATTR_PROC_FABRIC_X_LINKS_CNFG);
    addData(ATTR_PROC_FABRIC_A_ATTACHED_CHIP_CNFG);
    addData(ATTR_PROC_FABRIC_A_LINKS_CNFG);
    addData(ATTR_PROC_FABRIC_X_ATTACHED_CHIP_ID);
    addData(ATTR_PROC_FABRIC_X_ATTACHED_LINK_ID);
    addData(ATTR_PROC_FABRIC_A_ATTACHED_CHIP_ID);
    addData(ATTR_PROC_FABRIC_A_ATTACHED_LINK_ID);
    addData(ATTR_PROC_FABRIC_X_AGGREGATE);
    addData(ATTR_PROC_FABRIC_X_ADDR_DIS);
    addData(ATTR_PROC_FABRIC_X_LINK_DELAY);
    addData(ATTR_PROC_FABRIC_A_AGGREGATE);
    addData(ATTR_PROC_FABRIC_A_ADDR_DIS);
    addData(ATTR_PROC_FABRIC_A_LINK_DELAY);
    addData(ATTR_PROC_EPS_GB_PERCENTAGE);
    addData(ATTR_PROC_EPS_READ_CYCLES_T0);
    addData(ATTR_PROC_EPS_READ_CYCLES_T1);
    addData(ATTR_PROC_EPS_READ_CYCLES_T2);
    addData(ATTR_PROC_EPS_WRITE_CYCLES_T1);
    addData(ATTR_PROC_EPS_WRITE_CYCLES_T2);
    addData(ATTR_SYSTEM_IPL_PHASE);
    addData(ATTR_MAX_INTERLEAVE_GROUP_SIZE);
    addData(ATTR_PROC_MEM_BASES);
    addData(ATTR_PROC_MEM_SIZES);
    addData(ATTR_PROC_MIRROR_BASES);
    addData(ATTR_PROC_MIRROR_SIZES);
    addData(ATTR_MSS_INTERLEAVE_ENABLE);
    addData(ATTR_MSS_MEM_MC_IN_GROUP);
    addData(ATTR_MSS_MCS_GROUP_32);
    addData(ATTR_MSS_MEM_IPL_COMPLETE);
    addData(ATTR_MRW_HW_MIRRORING_ENABLE);
    addData(ATTR_PROC_NHTM_BAR_BASE_ADDR);
    addData(ATTR_PROC_NHTM_BAR_SIZE);
    addData(ATTR_PROC_CHTM_BAR_BASE_ADDR);
    addData(ATTR_PROC_CHTM_BAR_SIZES);
    addData(ATTR_PROC_SMF_BAR_BASE_ADDR);
    addData(ATTR_PROC_SMF_BAR_SIZE);
    addData(ATTR_SMF_ENABLED);
    addData(ATTR_PROC_OCC_SANDBOX_BASE_ADDR);
    addData(ATTR_PROC_OCC_SANDBOX_SIZE);
    addData(ATTR_PROC_MEM_BASES_ACK);
    addData(ATTR_PROC_MEM_SIZES_ACK);
    addData(ATTR_PROC_MIRROR_BASES_ACK);
    addData(ATTR_PROC_MIRROR_SIZES_ACK);
    addData(ATTR_HTM_QUEUES);
    addData(ATTR_MSS_VPD_DQ_MAP);
    addData(ATTR_MSS_VPD_MR_0_VERSION_LAYOUT);
    addData(ATTR_MSS_VPD_MR_1_VERSION_DATA);
    addData(ATTR_MSS_VPD_MR_2_SIGNATURE_HASH);
    addData(ATTR_MSS_VPD_MR_DPHY_GPO);
    addData(ATTR_MSS_VPD_MR_DPHY_RLO);
    addData(ATTR_MSS_VPD_MR_DPHY_WLO);
    addData(ATTR_MSS_VPD_MR_MC_2N_MODE_AUTOSET);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A00);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A01);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A02);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A03);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A04);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A05);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A06);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A07);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A08);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A09);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A10);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A11);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A12);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A13);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A17);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA0);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA1);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG0);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG1);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C0);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C1);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C2);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ACTN);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_CASN_A15);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_RASN_A16);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_WEN_A14);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_PAR);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE0);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE1);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN0);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN1);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT0);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT1);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE0);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE1);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN0);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN1);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT0);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT1);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_D0_CLKN);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_D0_CLKP);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_D1_CLKN);
    addData(ATTR_MSS_VPD_MR_MC_PHASE_ROT_D1_CLKP);
    addData(ATTR_MSS_VPD_MR_TSYS_ADR);
    addData(ATTR_MSS_VPD_MR_TSYS_DATA);
    addData(ATTR_PROC_PCIE_IOP_SWAP);
    addData(ATTR_PROC_PCIE_PCS_RX_ROT_EXTEL);
    addData(ATTR_PROC_PCIE_PCS_RX_DFE_FDDC);
    addData(ATTR_PROC_PCIE_CACHE_INJ_MODE);
    addData(ATTR_PROC_PCIE_CACHE_INJ_THROTTLE);
    addData(ATTR_PROC_DPLL_DIVIDER);
    addData(ATTR_STOPGPE_BOOT_COPIER_IVPR_OFFSET);
    addData(ATTR_PSTATEGPE_BOOT_COPIER_IVPR_OFFSET);
    addData(ATTR_PM_SPWUP_IGNORE_XSTOP_FLAG);
    addData(ATTR_OCC_LFIR);
    addData(ATTR_PBA_LFIR);
    addData(ATTR_PM_FIRINIT_DONE_ONCE_FLAG);
    addData(ATTR_QUAD_PPM_ERRMASK);
    addData(ATTR_CORE_PPM_ERRMASK);
    addData(ATTR_CME_LOCAL_FIRMASK);
    addData(ATTR_L2_HASCLOCKS);
    addData(ATTR_L3_HASCLOCKS);
    addData(ATTR_C0_EXEC_HASCLOCKS);
    addData(ATTR_C1_EXEC_HASCLOCKS);
    addData(ATTR_C0_PC_HASCLOCKS);
    addData(ATTR_C1_PC_HASCLOCKS);
    addData(ATTR_L2_HASPOWER);
    addData(ATTR_L3_HASPOWER);
    addData(ATTR_C0_HASPOWER);
    addData(ATTR_C1_HASPOWER);
    addData(ATTR_PM_SPIPSS_FRAME_SIZE);
    addData(ATTR_PM_SPIPSS_IN_DELAY);
    addData(ATTR_PM_SPIPSS_CLOCK_POLARITY);
    addData(ATTR_PM_SPIPSS_CLOCK_PHASE);
    addData(ATTR_PM_SPIPSS_CLOCK_DIVIDER);
    addData(ATTR_PM_SPIPSS_INTER_FRAME_DELAY_SETTING);
    addData(ATTR_PSTATES_ENABLED);
    addData(ATTR_RESCLK_ENABLED);
    addData(ATTR_VDM_ENABLED);
    addData(ATTR_IVRM_ENABLED);
    addData(ATTR_WOF_ENABLED);
    addData(ATTR_WOV_OVERV_ENABLED);
    addData(ATTR_WOV_UNDERV_ENABLED);
    addData(ATTR_SGPE_PHANTOM_HALT_ENABLE);
    addData(ATTR_PGPE_PHANTOM_HALT_ENABLE);
    addData(ATTR_CME_STOP_PHANTOM_HALT_ENABLE);
    addData(ATTR_CME_PSTATE_PHANTOM_HALT_ENABLE);
    addData(ATTR_CORE_INSIDE_SPECIAL_WAKEUP);
    addData(ATTR_EX_INSIDE_SPECIAL_WAKEUP);
    addData(ATTR_EQ_INSIDE_SPECIAL_WAKEUP);
    addData(ATTR_INITIATED_PM_RESET);
    addData(ATTR_PM_RESET_PHASE);
    addData(ATTR_PM_MALF_CYCLE);
    addData(ATTR_IO_OMI_DCCAL_FLAGS);
    addData(ATTR_IO_DMI_PROC_DCCAL_FLAGS);
    addData(ATTR_MSS_FREQ_OVERRIDE);
    addData(ATTR_MSS_FREQ);
    addData(ATTR_MSS_FREQ_BIAS_PERCENTAGE);
    addData(ATTR_EFF_DIMM_SPARE);
    addData(ATTR_EFF_DRAM_WR_VREF);
    addData(ATTR_EFF_DRAM_WR_VREF_SCHMOO);
    addData(ATTR_EFF_DRAM_WRDDR4_VREF_SCHMOO);
    addData(ATTR_EFF_DIMM_SIZE);
    addData(ATTR_EFF_DRAM_CL);
    addData(ATTR_EFF_DRAM_AL);
    addData(ATTR_EFF_DRAM_CWL);
    addData(ATTR_EFF_DRAM_RBT);
    addData(ATTR_EFF_DRAM_TM);
    addData(ATTR_EFF_DRAM_DLL_RESET);
    addData(ATTR_EFF_DRAM_DLL_PPD);
    addData(ATTR_EFF_DRAM_DLL_ENABLE);
    addData(ATTR_EFF_DRAM_WR_LVL_ENABLE);
    addData(ATTR_EFF_DRAM_OUTPUT_BUFFER);
    addData(ATTR_EFF_DRAM_PASR);
    addData(ATTR_EFF_DRAM_ASR);
    addData(ATTR_EFF_DRAM_SRT);
    addData(ATTR_EFF_MPR_LOC);
    addData(ATTR_EFF_MPR_MODE);
    addData(ATTR_EFF_DIMM_DDR4_RC00);
    addData(ATTR_EFF_DIMM_DDR4_RC01);
    addData(ATTR_EFF_DIMM_DDR4_RC02);
    addData(ATTR_EFF_DIMM_DDR4_RC03);
    addData(ATTR_EFF_DIMM_DDR4_RC04);
    addData(ATTR_EFF_DIMM_DDR4_RC05);
    addData(ATTR_EFF_DIMM_DDR4_RC06_07);
    addData(ATTR_EFF_DIMM_DDR4_RC08);
    addData(ATTR_EFF_DIMM_DDR4_RC09);
    addData(ATTR_EFF_DIMM_DDR4_RC0A);
    addData(ATTR_EFF_DIMM_DDR4_RC0B);
    addData(ATTR_EFF_DIMM_DDR4_RC0C);
    addData(ATTR_EFF_DIMM_DDR4_RC0D);
    addData(ATTR_EFF_DIMM_DDR4_RC0E);
    addData(ATTR_EFF_DIMM_DDR4_RC0F);
    addData(ATTR_EFF_DIMM_DDR4_RC_1x);
    addData(ATTR_EFF_DIMM_DDR4_RC_2x);
    addData(ATTR_EFF_DIMM_DDR4_RC_3x);
    addData(ATTR_EFF_DIMM_DDR4_RC_4x);
    addData(ATTR_EFF_DIMM_DDR4_RC_5x);
    addData(ATTR_EFF_DIMM_DDR4_RC_6x);
    addData(ATTR_EFF_DIMM_DDR4_RC_7x);
    addData(ATTR_EFF_DIMM_DDR4_RC_8x);
    addData(ATTR_EFF_DIMM_DDR4_RC_9x);
    addData(ATTR_EFF_DIMM_DDR4_RC_Ax);
    addData(ATTR_EFF_DIMM_DDR4_RC_Bx);
    addData(ATTR_EFF_DIMM_RCD_MIRROR_MODE);
    addData(ATTR_EFF_SCHMOO_MODE);
    addData(ATTR_EFF_SCHMOO_ADDR_MODE);
    addData(ATTR_EFF_SCHMOO_TEST_VALID);
    addData(ATTR_EFF_SCHMOO_PARAM_VALID);
    addData(ATTR_EFF_SCHMOO_WR_EYE_MIN_MARGIN);
    addData(ATTR_EFF_SCHMOO_RD_EYE_MIN_MARGIN);
    addData(ATTR_EFF_SCHMOO_DQS_CLK_MIN_MARGIN);
    addData(ATTR_EFF_SCHMOO_RD_GATE_MIN_MARGIN);
    addData(ATTR_EFF_SCHMOO_ADDR_CMD_MIN_MARGIN);
    addData(ATTR_EFF_MEMCAL_INTERVAL);
    addData(ATTR_EFF_ZQCAL_INTERVAL);
    addData(ATTR_EFF_IBM_TYPE);
    addData(ATTR_EFF_NUM_MASTER_RANKS_PER_DIMM);
    addData(ATTR_EFF_DIMM_RANKS_CONFIGED);
    addData(ATTR_EFF_PRIM_DIE_COUNT);
    addData(ATTR_MSS_MEM_THROTTLED_N_COMMANDS_PER_PORT);
    addData(ATTR_MSS_MEM_PORT_POS_OF_FAIL_THROTTLE);
    addData(ATTR_MSS_MEM_M_DRAM_CLOCKS);
    addData(ATTR_MSS_MEM_THROTTLED_N_COMMANDS_PER_SLOT);
    addData(ATTR_MSS_MEM_WATT_TARGET);
    addData(ATTR_MSS_TOTAL_PWR_SLOPE);
    addData(ATTR_MSS_TOTAL_PWR_INTERCEPT);
    addData(ATTR_MSS_DIMM_MAXBANDWIDTH_GBS);
    addData(ATTR_MSS_DIMM_MAXBANDWIDTH_MRS);
    addData(ATTR_MSS_CHANNEL_PAIR_MAXBANDWIDTH_GBS);
    addData(ATTR_MSS_CHANNEL_PAIR_MAXBANDWIDTH_MRS);
    addData(ATTR_MSS_DIMM_MAXPOWER);
    addData(ATTR_MSS_DATABUS_UTIL);
    addData(ATTR_MSS_PORT_MAXPOWER);
    addData(ATTR_MSS_DIMM_THERMAL_LIMIT);
    addData(ATTR_MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_PORT);
    addData(ATTR_MSS_RUNTIME_MEM_M_DRAM_CLOCKS);
    addData(ATTR_MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_SLOT);
    addData(ATTR_MSS_EFF_DIMM_FUNCTIONAL_VECTOR);
    addData(ATTR_EFF_DRAM_LPASR);
    addData(ATTR_EFF_MPR_PAGE);
    addData(ATTR_EFF_GEARDOWN_MODE);
    addData(ATTR_EFF_PER_DRAM_ACCESS);
    addData(ATTR_EFF_TEMP_READOUT);
    addData(ATTR_EFF_CRC_WR_LATENCY);
    addData(ATTR_EFF_MPR_RD_FORMAT);
    addData(ATTR_EFF_MAX_POWERDOWN_MODE);
    addData(ATTR_EFF_INTERNAL_VREF_MONITOR);
    addData(ATTR_EFF_CS_CMD_LATENCY);
    addData(ATTR_EFF_SELF_REF_ABORT);
    addData(ATTR_EFF_RD_PREAMBLE_TRAIN);
    addData(ATTR_EFF_RD_PREAMBLE);
    addData(ATTR_EFF_WR_PREAMBLE);
    addData(ATTR_EFF_CA_PARITY_LATENCY);
    addData(ATTR_EFF_CRC_ERROR_CLEAR);
    addData(ATTR_EFF_CA_PARITY_ERROR_STATUS);
    addData(ATTR_EFF_ODT_INPUT_BUFF);
    addData(ATTR_EFF_CA_PARITY);
    addData(ATTR_EFF_DATA_MASK);
    addData(ATTR_EFF_WRITE_DBI);
    addData(ATTR_EFF_READ_DBI);
    addData(ATTR_EFF_VREF_DQ_TRAIN_VALUE);
    addData(ATTR_EFF_VREF_DQ_TRAIN_RANGE);
    addData(ATTR_EFF_VREF_DQ_TRAIN_ENABLE);
    addData(ATTR_EFF_WRITE_CRC);
    addData(ATTR_MSS_CAL_STEP_ENABLE);
    addData(ATTR_MSS_CUSTOM_TRAINING_ADV_PATTERNS);
    addData(ATTR_MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS);
    addData(ATTR_MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS2);
    addData(ATTR_MSS_CUSTOM_TRAINING_ADV_WR_PATTERN);
    addData(ATTR_MSS_VREF_CAL_ENABLE);
    addData(ATTR_MSS_RDVREF_CAL_ENABLE);
    addData(ATTR_MSS_CAL_ABORT_ON_ERROR);
    addData(ATTR_MSS_SLEW_RATE_DATA);
    addData(ATTR_MSS_SLEW_RATE_ADR);
    addData(ATTR_SCHMOO_MULTIPLE_SETUP_CALL);
    addData(ATTR_EFF_BUFFER_LATENCY);
    addData(ATTR_EFF_LRDIMM_WORD_X);
    addData(ATTR_LRDIMM_MR12_REG);
    addData(ATTR_LRDIMM_ADDITIONAL_CNTL_WORDS);
    addData(ATTR_LRDIMM_RANK_MULT_MODE);
    addData(ATTR_MSS_EFF_VPD_VERSION);
    addData(ATTR_MSS_VOLT_OVERRIDE);
    addData(ATTR_MSS_VDDR_OVERIDE_SPD);
    addData(ATTR_MSS_VMEM_REGULATOR_MAX_DIMM_COUNT);
    addData(ATTR_MSS_VREF_DAC_NIBBLE);
    addData(ATTR_MSS_VCCD_OVERRIDE);
    addData(ATTR_EFF_DRAM_MAC);
    addData(ATTR_EFF_DRAM_MODULE_BUS_WIDTH);
    addData(ATTR_EFF_DRAM_RTT_NOM);
    addData(ATTR_EFF_DRAM_RTT_WR);
    addData(ATTR_EFF_DRAM_RTT_PARK);
    addData(ATTR_EFF_DIMM_DDR4_BC00);
    addData(ATTR_EFF_DIMM_DDR4_BC01);
    addData(ATTR_EFF_DIMM_DDR4_BC02);
    addData(ATTR_EFF_DIMM_DDR4_BC03);
    addData(ATTR_EFF_DIMM_DDR4_BC04);
    addData(ATTR_EFF_DIMM_DDR4_BC05);
    addData(ATTR_EFF_DIMM_DDR4_BC06);
    addData(ATTR_EFF_DIMM_DDR4_BC07);
    addData(ATTR_EFF_DIMM_DDR4_BC08);
    addData(ATTR_EFF_DIMM_DDR4_BC09);
    addData(ATTR_EFF_DIMM_DDR4_BC0A);
    addData(ATTR_EFF_DIMM_DDR4_BC0B);
    addData(ATTR_EFF_DIMM_DDR4_BC0C);
    addData(ATTR_EFF_DIMM_DDR4_BC0D);
    addData(ATTR_EFF_DIMM_DDR4_BC0E);
    addData(ATTR_EFF_DIMM_DDR4_BC0F);
    addData(ATTR_EFF_DIMM_DDR4_F0BC1x);
    addData(ATTR_EFF_DIMM_DDR4_F30BC2x);
    addData(ATTR_EFF_DIMM_DDR4_F30BC3x);
    addData(ATTR_EFF_DIMM_DDR4_F30BC4x);
    addData(ATTR_EFF_DIMM_DDR4_F30BC5x);
    addData(ATTR_EFF_DIMM_DDR4_F0BC6x);
    addData(ATTR_EFF_DIMM_DDR4_F70BC7x);
    addData(ATTR_EFF_DIMM_DDR4_F30BC8x);
    addData(ATTR_EFF_DIMM_DDR4_F30BC9x);
    addData(ATTR_EFF_DIMM_DDR4_F30BCAx);
    addData(ATTR_EFF_DIMM_DDR4_F30BCBx);
    addData(ATTR_EFF_DIMM_DDR4_F0BCCx);
    addData(ATTR_EFF_DIMM_DDR4_F0BCDx);
    addData(ATTR_EFF_DIMM_DDR4_F0BCEx);
    addData(ATTR_EFF_DIMM_DDR4_F0BCFx);
    addData(ATTR_EFF_DIMM_DDR4_F1BCCx);
    addData(ATTR_EFF_DIMM_DDR4_F1BCDx);
    addData(ATTR_EFF_DIMM_DDR4_F1BCEx);
    addData(ATTR_EFF_DIMM_DDR4_F1BCFx);
    addData(ATTR_EFF_DIMM_DDR4_F2BCEx);
    addData(ATTR_EFF_DIMM_DDR4_F4BC0x);
    addData(ATTR_EFF_DIMM_DDR4_F4BC1x);
    addData(ATTR_EFF_DIMM_DDR4_F4BC2x);
    addData(ATTR_EFF_DIMM_DDR4_F4BC3x);
    addData(ATTR_EFF_DIMM_DDR4_F4BC4x);
    addData(ATTR_EFF_DIMM_DDR4_F4BC5x);
    addData(ATTR_EFF_DIMM_DDR4_F4BC6x);
    addData(ATTR_EFF_DIMM_DDR4_F5BC0x);
    addData(ATTR_EFF_DIMM_DDR4_F5BC1x);
    addData(ATTR_EFF_DIMM_DDR4_F5BC2x);
    addData(ATTR_EFF_DIMM_DDR4_F5BC3x);
    addData(ATTR_EFF_DIMM_DDR4_F5BC5x);
    addData(ATTR_EFF_DIMM_DDR4_F5BC6x);
    addData(ATTR_EFF_DIMM_DDR4_F6BC0x);
    addData(ATTR_EFF_DIMM_DDR4_F6BC1x);
    addData(ATTR_EFF_DIMM_DDR4_F6BC2x);
    addData(ATTR_EFF_DIMM_DDR4_F6BC3x);
    addData(ATTR_EFF_DIMM_DDR4_F6BC4x);
    addData(ATTR_EFF_DIMM_DDR4_F6BC5x);
    addData(ATTR_EFF_DIMM_DDR4_F74BC8x);
    addData(ATTR_EFF_DIMM_DDR4_F74BC9x);
    addData(ATTR_EFF_DIMM_DDR4_F74BCAx);
    addData(ATTR_EFF_DIMM_DDR4_F74BCBx);
    addData(ATTR_EFF_DIMM_DDR4_F74BCCx);
    addData(ATTR_EFF_DIMM_DDR4_F74BCDx);
    addData(ATTR_EFF_DIMM_DDR4_F74BCEx);
    addData(ATTR_EFF_DIMM_DDR4_F74BCFx);
    addData(ATTR_EFF_DRAM_RON);
    addData(ATTR_EFF_DRAM_TDQS);
    addData(ATTR_EFF_DRAM_ODIC);
    addData(ATTR_MSS_LRDIMM_TRAINING_PATTERN);
    addData(ATTR_MSS_EFF_ODT_RD);
    addData(ATTR_MSS_EFF_ODT_WR);
    addData(ATTR_MSS_EFF_DPHY_WLO);
    addData(ATTR_MSS_EFF_DPHY_RLO);
    addData(ATTR_EFF_DRAM_TREFI);
    addData(ATTR_EFF_DRAM_TRTP);
    addData(ATTR_EFF_DRAM_TRFC_DLR);
    addData(ATTR_EFF_DRAM_TFAW_DLR);
    addData(ATTR_EFF_DRAM_TRRD_DLR);
    addData(ATTR_EFF_DRAM_TXS);
    addData(ATTR_MSS_IGNORE_PLUG_RULES);
    addData(ATTR_MSS_MVPD_FWMS);
    addData(ATTR_MSS_REORDER_QUEUE_SETTING);
    addData(ATTR_EFF_RANK_GROUP_OVERRIDE);
    addData(ATTR_MSS_RTT_NOM_OVERRIDE_DISABLE);
    addData(ATTR_MSS_EFF_WR_CRC);
    addData(ATTR_MSS_WR_VREF_OFFSET);
    addData(ATTR_SBE_NVDIMM_IN_PORT);
    addData(ATTR_SCRATCH_UINT8_1);
    addData(ATTR_SCRATCH_UINT8_2);
    addData(ATTR_SCRATCH_UINT16_1);
    addData(ATTR_SCRATCH_UINT16_2);
    addData(ATTR_SCRATCH_UINT32_1);
    addData(ATTR_SCRATCH_UINT32_2);
    addData(ATTR_SCRATCH_UINT64_1);
    addData(ATTR_SCRATCH_UINT64_2);
    addData(ATTR_SCRATCH_UINT8_ARRAY_1);
    addData(ATTR_SCRATCH_UINT8_ARRAY_2);
    addData(ATTR_SCRATCH_UINT16_ARRAY_1);
    addData(ATTR_SCRATCH_UINT16_ARRAY_2);
    addData(ATTR_SCRATCH_UINT32_ARRAY_1);
    addData(ATTR_SCRATCH_UINT32_ARRAY_2);
    addData(ATTR_SCRATCH_UINT64_ARRAY_1);
    addData(ATTR_SCRATCH_UINT64_ARRAY_2);
    addData(ATTR_SCRATCH_INT8_1);
    addData(ATTR_SCRATCH_INT8_2);
    addData(ATTR_SCRATCH_INT16_1);
    addData(ATTR_SCRATCH_INT16_2);
    addData(ATTR_SCRATCH_INT32_1);
    addData(ATTR_SCRATCH_INT32_2);
    addData(ATTR_SCRATCH_INT64_1);
    addData(ATTR_SCRATCH_INT64_2);
    addData(ATTR_SCRATCH_INT8_ARRAY_1);
    addData(ATTR_SCRATCH_INT8_ARRAY_2);
    addData(ATTR_SCRATCH_INT16_ARRAY_1);
    addData(ATTR_SCRATCH_INT16_ARRAY_2);
    addData(ATTR_SCRATCH_INT32_ARRAY_1);
    addData(ATTR_SCRATCH_INT32_ARRAY_2);
    addData(ATTR_SCRATCH_INT64_ARRAY_1);
    addData(ATTR_SCRATCH_INT64_ARRAY_2);
    addData(ATTR_IS_SIMULATION);
    addData(ATTR_MNFG_FLAGS);
    addData(ATTR_RECONFIGURE_LOOP);
    addData(ATTR_MINI_EC);
    addData(ATTR_CEN_MSS_DATABUS_UTIL_PER_MBA);
    addData(ATTR_CEN_SPD_DRAM_DEVICE_TYPE);
    addData(ATTR_CEN_SPD_MODULE_TYPE);
    addData(ATTR_CEN_SPD_CUSTOM);
    addData(ATTR_CEN_SPD_SDRAM_DENSITY);
    addData(ATTR_CEN_SPD_SDRAM_BANKS);
    addData(ATTR_CEN_SPD_SDRAM_ROWS);
    addData(ATTR_CEN_SPD_SDRAM_COLUMNS);
    addData(ATTR_CEN_SPD_MODULE_NOMINAL_VOLTAGE);
    addData(ATTR_CEN_SPD_NUM_RANKS);
    addData(ATTR_CEN_SPD_DRAM_WIDTH);
    addData(ATTR_CEN_SPD_MODULE_MEMORY_BUS_WIDTH);
    addData(ATTR_CEN_SPD_TCKMIN);
    addData(ATTR_CEN_SPD_CAS_LATENCIES_SUPPORTED);
    addData(ATTR_CEN_SPD_TAAMIN);
    addData(ATTR_CEN_SPD_TRCDMIN);
    addData(ATTR_CEN_SPD_TRPMIN);
    addData(ATTR_CEN_SPD_TRASMIN);
    addData(ATTR_CEN_SPD_TRCMIN);
    addData(ATTR_CEN_SPD_TFAWMIN);
    addData(ATTR_CEN_SPD_SDRAM_OPTIONAL_FEATURES);
    addData(ATTR_CEN_SPD_SDRAM_THERMAL_AND_REFRESH_OPTIONS);
    addData(ATTR_ROW_REPAIR_SPPR_SUPPORTED);
    addData(ATTR_CEN_SPD_MODULE_THERMAL_SENSOR);
    addData(ATTR_CEN_SPD_SDRAM_DEVICE_TYPE);
    addData(ATTR_CEN_SPD_SDRAM_DEVICE_TYPE_SIGNAL_LOADING);
    addData(ATTR_CEN_SPD_SDRAM_DIE_COUNT);
    addData(ATTR_CEN_SPD_FINE_OFFSET_TCKMIN);
    addData(ATTR_CEN_SPD_FINE_OFFSET_TAAMIN);
    addData(ATTR_CEN_SPD_FINE_OFFSET_TRCDMIN);
    addData(ATTR_CEN_SPD_FINE_OFFSET_TRPMIN);
    addData(ATTR_CEN_SPD_FINE_OFFSET_TRCMIN);
    addData(ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURERS_JEDEC_ID_CODE);
    addData(ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_LOCATION);
    addData(ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_DATE);
    addData(ATTR_CEN_SPD_MODULE_ID_MODULE_SERIAL_NUMBER);
    addData(ATTR_CEN_SPD_MODULE_PART_NUMBER);
    addData(ATTR_CEN_SPD_MODULE_REVISION_CODE);
    addData(ATTR_CEN_SPD_DRAM_MANUFACTURER_JEDEC_ID_CODE);
    addData(ATTR_CEN_SPD_BAD_DQ_DATA);
    addData(ATTR_CEN_SPD_FTB_DIVIDEND);
    addData(ATTR_CEN_SPD_FTB_DIVISOR);
    addData(ATTR_CEN_SPD_MTB_DIVIDEND);
    addData(ATTR_CEN_SPD_MTB_DIVISOR);
    addData(ATTR_CEN_SPD_TWRMIN);
    addData(ATTR_CEN_SPD_TRRDMIN);
    addData(ATTR_CEN_SPD_TRFCMIN);
    addData(ATTR_CEN_SPD_TWTRMIN);
    addData(ATTR_CEN_SPD_TRTPMIN);
    addData(ATTR_CEN_SPD_SDRAM_BANKGROUPS_DDR4);
    addData(ATTR_CEN_SPD_TIMEBASE_MTB_DDR4);
    addData(ATTR_CEN_SPD_TIMEBASE_FTB_DDR4);
    addData(ATTR_CEN_SPD_TCKMAX_DDR4);
    addData(ATTR_CEN_SPD_TRFC1MIN_DDR4);
    addData(ATTR_CEN_SPD_TRFC2MIN_DDR4);
    addData(ATTR_CEN_SPD_TRFC4MIN_DDR4);
    addData(ATTR_CEN_SPD_TRRDSMIN_DDR4);
    addData(ATTR_CEN_SPD_TRRDLMIN_DDR4);
    addData(ATTR_CEN_SPD_TCCDLMIN_DDR4);
    addData(ATTR_CEN_SPD_FINE_OFFSET_TCCDLMIN_DDR4);
    addData(ATTR_CEN_SPD_FINE_OFFSET_TRRDLMIN_DDR4);
    addData(ATTR_CEN_SPD_FINE_OFFSET_TRRDSMIN_DDR4);
    addData(ATTR_CEN_SPD_FINE_OFFSET_TCKMAX_DDR4);
    addData(ATTR_CEN_SPD_CRC_BASE_CONFIG_DDR4);
    addData(ATTR_CEN_SPD_DRAM_STEPPING_DDR4);
    addData(ATTR_CEN_SPD_CRC_MNFG_SEC_DDR4);
    addData(ATTR_CEN_SPD_ADDR_MAP_REG_TO_DRAM);
    addData(ATTR_CEN_SPD_MODULE_REVISION_CODE_DDR4);
    addData(ATTR_CEN_ISDIMM_MBVPD_INDEX);
    addData(ATTR_CEN_MBVPD_VERSION);
    addData(ATTR_CEN_MCBIST_ADDR_MODES);
    addData(ATTR_CEN_MCBIST_RANK);
    addData(ATTR_CEN_MCBIST_START_ADDR);
    addData(ATTR_CEN_MCBIST_END_ADDR);
    addData(ATTR_CEN_MCBIST_ERROR_CAPTURE);
    addData(ATTR_CEN_MCBIST_MAX_TIMEOUT);
    addData(ATTR_CEN_MCBIST_PRINT_PORT);
    addData(ATTR_CEN_MCBIST_STOP_ON_ERROR);
    addData(ATTR_CEN_MCBIST_DATA_SEED);
    addData(ATTR_CEN_MCBIST_ADDR_INTER);
    addData(ATTR_CEN_MCBIST_ADDR_NUM_ROWS);
    addData(ATTR_CEN_MCBIST_ADDR_NUM_COLS);
    addData(ATTR_CEN_MCBIST_ADDR_RANK);
    addData(ATTR_CEN_MCBIST_ADDR_BANK);
    addData(ATTR_CEN_MCBIST_ADDR_SLAVE_RANK_ON);
    addData(ATTR_CEN_MCBIST_ADDR_STR_MAP);
    addData(ATTR_CEN_MCBIST_ADDR_RAND);
    addData(ATTR_CEN_EFF_DRAM_ADDRESS_MIRRORING);
    addData(ATTR_CEN_MSS_FREQ_OVERRIDE);
    addData(ATTR_CEN_MSS_FREQ);
    addData(ATTR_CEN_MSS_FREQ_BIAS_PERCENTAGE);
    addData(ATTR_CEN_EFF_DIMM_RANKS_CONFIGED);
    addData(ATTR_CEN_EFF_NUM_RANKS_PER_DIMM);
    addData(ATTR_CEN_EFF_DIMM_TYPE);
    addData(ATTR_CEN_EFF_CUSTOM_DIMM);
    addData(ATTR_CEN_EFF_DRAM_WIDTH);
    addData(ATTR_CEN_EFF_DRAM_GEN);
    addData(ATTR_CEN_EFF_PRIMARY_RANK_GROUP0);
    addData(ATTR_CEN_EFF_PRIMARY_RANK_GROUP1);
    addData(ATTR_CEN_EFF_PRIMARY_RANK_GROUP2);
    addData(ATTR_CEN_EFF_PRIMARY_RANK_GROUP3);
    addData(ATTR_CEN_EFF_SECONDARY_RANK_GROUP0);
    addData(ATTR_CEN_EFF_SECONDARY_RANK_GROUP1);
    addData(ATTR_CEN_EFF_SECONDARY_RANK_GROUP2);
    addData(ATTR_CEN_EFF_SECONDARY_RANK_GROUP3);
    addData(ATTR_CEN_EFF_TERTIARY_RANK_GROUP0);
    addData(ATTR_CEN_EFF_TERTIARY_RANK_GROUP1);
    addData(ATTR_CEN_EFF_TERTIARY_RANK_GROUP2);
    addData(ATTR_CEN_EFF_TERTIARY_RANK_GROUP3);
    addData(ATTR_CEN_EFF_QUATERNARY_RANK_GROUP0);
    addData(ATTR_CEN_EFF_QUATERNARY_RANK_GROUP1);
    addData(ATTR_CEN_EFF_QUATERNARY_RANK_GROUP2);
    addData(ATTR_CEN_EFF_QUATERNARY_RANK_GROUP3);
    addData(ATTR_CEN_EFF_DRAM_WR_VREF);
    addData(ATTR_CEN_EFF_DRAM_WR_VREF_SCHMOO);
    addData(ATTR_CEN_EFF_CEN_DRV_IMP_DQ_DQS);
    addData(ATTR_CEN_EFF_CEN_DRV_IMP_DQ_DQS_SCHMOO);
    addData(ATTR_CEN_EFF_CEN_SLEW_RATE_DQ_DQS);
    addData(ATTR_CEN_EFF_CEN_DRV_IMP_CLK_SCHMOO);
    addData(ATTR_CEN_EFF_CEN_DRV_IMP_SPCKE_SCHMOO);
    addData(ATTR_CEN_EFF_CEN_DRV_IMP_CNTL_SCHMOO);
    addData(ATTR_CEN_EFF_CEN_RCV_IMP_DQ_DQS);
    addData(ATTR_CEN_EFF_CEN_RCV_IMP_DQ_DQS_SCHMOO);
    addData(ATTR_CEN_EFF_CEN_SLEW_RATE_DQ_DQS_SCHMOO);
    addData(ATTR_CEN_EFF_CEN_SLEW_RATE_CLK_SCHMOO);
    addData(ATTR_CEN_EFF_CEN_SLEW_RATE_SPCKE_SCHMOO);
    addData(ATTR_CEN_EFF_CEN_SLEW_RATE_ADDR_SCHMOO);
    addData(ATTR_CEN_EFF_CEN_SLEW_RATE_CNTL_SCHMOO);
    addData(ATTR_CEN_EFF_RD_VREF);
    addData(ATTR_CEN_EFF_CEN_RD_VREF_SCHMOO);
    addData(ATTR_CEN_EFF_DIMM_SIZE);
    addData(ATTR_CEN_EFF_DRAM_BANKS);
    addData(ATTR_CEN_EFF_DRAM_ROWS);
    addData(ATTR_CEN_EFF_DRAM_COLS);
    addData(ATTR_CEN_EFF_DRAM_DENSITY);
    addData(ATTR_CEN_EFF_DRAM_TRCD);
    addData(ATTR_CEN_EFF_DRAM_TRRD);
    addData(ATTR_CEN_EFF_DRAM_TRRD_L);
    addData(ATTR_CEN_EFF_DRAM_TRP);
    addData(ATTR_CEN_EFF_DRAM_TRAS);
    addData(ATTR_CEN_EFF_DRAM_TRC);
    addData(ATTR_CEN_EFF_DRAM_TRFI);
    addData(ATTR_CEN_EFF_DRAM_TRFC);
    addData(ATTR_CEN_EFF_DRAM_TWTR);
    addData(ATTR_CEN_EFF_DRAM_TWTR_L);
    addData(ATTR_CEN_EFF_DRAM_TRTP);
    addData(ATTR_CEN_EFF_DRAM_TFAW);
    addData(ATTR_CEN_EFF_DRAM_BL);
    addData(ATTR_CEN_EFF_DRAM_CL);
    addData(ATTR_CEN_EFF_DRAM_AL);
    addData(ATTR_CEN_EFF_DRAM_CWL);
    addData(ATTR_CEN_EFF_DRAM_RBT);
    addData(ATTR_CEN_EFF_DRAM_TM);
    addData(ATTR_CEN_EFF_DRAM_DLL_RESET);
    addData(ATTR_CEN_EFF_DRAM_WR);
    addData(ATTR_CEN_EFF_DRAM_DLL_PPD);
    addData(ATTR_CEN_EFF_DRAM_DLL_ENABLE);
    addData(ATTR_CEN_EFF_DRAM_TDQS);
    addData(ATTR_CEN_EFF_DRAM_WR_LVL_ENABLE);
    addData(ATTR_CEN_EFF_DRAM_OUTPUT_BUFFER);
    addData(ATTR_CEN_EFF_DRAM_PASR);
    addData(ATTR_CEN_EFF_DRAM_ASR);
    addData(ATTR_CEN_EFF_DRAM_SRT);
    addData(ATTR_CEN_EFF_MPR_LOC);
    addData(ATTR_CEN_EFF_MPR_MODE);
    addData(ATTR_CEN_EFF_DIMM_RCD_CNTL_WORD_0_15);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC00);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC01);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC02);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC03);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC04);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC05);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC06_07);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC08);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC09);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC10);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC11);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC12);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC13);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC14);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC15);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC_1x);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC_2x);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC_3x);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC_4x);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC_5x);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC_6x);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC_7x);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC_8x);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC_9x);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC_Ax);
    addData(ATTR_CEN_EFF_DIMM_DDR4_RC_Bx);
    addData(ATTR_CEN_EFF_SCHMOO_MODE);
    addData(ATTR_CEN_EFF_SCHMOO_ADDR_MODE);
    addData(ATTR_CEN_EFF_SCHMOO_TEST_VALID);
    addData(ATTR_CEN_EFF_SCHMOO_PARAM_VALID);
    addData(ATTR_CEN_EFF_SCHMOO_VREF_STEP);
    addData(ATTR_CEN_EFF_SCHMOO_WR_EYE_MIN_MARGIN);
    addData(ATTR_CEN_EFF_SCHMOO_RD_EYE_MIN_MARGIN);
    addData(ATTR_CEN_EFF_SCHMOO_DQS_CLK_MIN_MARGIN);
    addData(ATTR_CEN_EFF_SCHMOO_RD_GATE_MIN_MARGIN);
    addData(ATTR_CEN_EFF_SCHMOO_ADDR_CMD_MIN_MARGIN);
    addData(ATTR_CEN_EFF_MEMCAL_INTERVAL);
    addData(ATTR_CEN_EFF_ZQCAL_INTERVAL);
    addData(ATTR_CEN_EFF_IBM_TYPE);
    addData(ATTR_CEN_EFF_NUM_DROPS_PER_PORT);
    addData(ATTR_CEN_EFF_STACK_TYPE);
    addData(ATTR_CEN_EFF_NUM_MASTER_RANKS_PER_DIMM);
    addData(ATTR_CEN_EFF_NUM_PACKAGES_PER_RANK);
    addData(ATTR_CEN_EFF_NUM_DIES_PER_PACKAGE);
    addData(ATTR_CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_MBA);
    addData(ATTR_CEN_MSS_MEM_THROTTLE_DENOMINATOR);
    addData(ATTR_CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_CHIP);
    addData(ATTR_CEN_MSS_MEM_WATT_TARGET);
    addData(ATTR_CEN_MSS_POWER_SLOPE);
    addData(ATTR_CEN_MSS_POWER_SLOPE2);
    addData(ATTR_CEN_MSS_POWER_INT);
    addData(ATTR_CEN_MSS_POWER_INT2);
    addData(ATTR_CEN_MSS_TOTAL_POWER_SLOPE);
    addData(ATTR_CEN_MSS_TOTAL_POWER_SLOPE2);
    addData(ATTR_CEN_MSS_TOTAL_POWER_INT);
    addData(ATTR_CEN_MSS_TOTAL_POWER_INT2);
    addData(ATTR_CEN_MSS_CHANNEL_PAIR_MAXPOWER);
    addData(ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_MBA);
    addData(ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_DENOMINATOR);
    addData(ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_CHIP);
    addData(ATTR_CEN_MSS_DERIVED_MBA_ADDR_INTERLEAVE_BIT);
    addData(ATTR_CEN_MSS_DERIVED_MBA_CACHELINE_INTERLEAVE_MODE);
    addData(ATTR_CEN_MSS_EFF_DIMM_FUNCTIONAL_VECTOR);
    addData(ATTR_CEN_EFF_DRAM_LPASR);
    addData(ATTR_CEN_EFF_MPR_PAGE);
    addData(ATTR_CEN_EFF_GEARDOWN_MODE);
    addData(ATTR_CEN_EFF_PER_DRAM_ACCESS);
    addData(ATTR_CEN_EFF_TEMP_READOUT);
    addData(ATTR_CEN_EFF_FINE_REFRESH_MODE);
    addData(ATTR_CEN_EFF_CRC_WR_LATENCY);
    addData(ATTR_CEN_EFF_MPR_RD_FORMAT);
    addData(ATTR_CEN_EFF_MAX_POWERDOWN_MODE);
    addData(ATTR_CEN_EFF_TEMP_REF_RANGE);
    addData(ATTR_CEN_EFF_TEMP_REF_MODE);
    addData(ATTR_CEN_EFF_INT_VREF_MON);
    addData(ATTR_CEN_EFF_CS_CMD_LATENCY);
    addData(ATTR_CEN_EFF_SELF_REF_ABORT);
    addData(ATTR_CEN_EFF_RD_PREAMBLE_TRAIN);
    addData(ATTR_CEN_EFF_RD_PREAMBLE);
    addData(ATTR_CEN_EFF_WR_PREAMBLE);
    addData(ATTR_CEN_EFF_CA_PARITY_LATENCY);
    addData(ATTR_CEN_EFF_CRC_ERROR_CLEAR);
    addData(ATTR_CEN_EFF_CA_PARITY_ERROR_STATUS);
    addData(ATTR_CEN_EFF_ODT_INPUT_BUFF);
    addData(ATTR_CEN_EFF_CA_PARITY);
    addData(ATTR_CEN_EFF_DATA_MASK);
    addData(ATTR_CEN_EFF_WRITE_DBI);
    addData(ATTR_CEN_EFF_READ_DBI);
    addData(ATTR_CEN_EFF_VREF_DQ_TRAIN_VALUE);
    addData(ATTR_CEN_EFF_VREF_DQ_TRAIN_RANGE);
    addData(ATTR_CEN_EFF_VREF_DQ_TRAIN_ENABLE);
    addData(ATTR_CEN_EFF_DRAM_TCCD_L);
    addData(ATTR_CEN_TCCD_L);
    addData(ATTR_CEN_EFF_WRITE_CRC);
    addData(ATTR_CEN_MSS_CAL_STEP_ENABLE);
    addData(ATTR_CEN_MSS_SLEW_RATE_DATA);
    addData(ATTR_CEN_MSS_SLEW_RATE_ADR);
    addData(ATTR_CEN_MSS_PSRO);
    addData(ATTR_CEN_MSS_NWELL_MISPLACEMENT);
    addData(ATTR_CEN_MSS_BLUEWATERFALL_BROKEN);
    addData(ATTR_CEN_MCBIST_PATTERN);
    addData(ATTR_CEN_MCBIST_TEST_TYPE);
    addData(ATTR_CEN_MCBIST_PRINTING_DISABLE);
    addData(ATTR_CEN_MCBIST_DATA_ENABLE);
    addData(ATTR_CEN_MCBIST_USER_RANK);
    addData(ATTR_CEN_MCBIST_USER_BANK);
    addData(ATTR_CEN_SCHMOO_MULTIPLE_SETUP_CALL);
    addData(ATTR_CEN_LRDIMM_RANK_MULT_MODE);
    addData(ATTR_CEN_MSS_THROTTLE_CONTROL_RAS_WEIGHT);
    addData(ATTR_CEN_MSS_THROTTLE_CONTROL_CAS_WEIGHT);
    addData(ATTR_CEN_MCBIST_RANDOM_SEED_VALUE);
    addData(ATTR_CEN_MCBIST_RANDOM_SEED_TYPE);
    addData(ATTR_CEN_MSS_INIT_STATE);
    addData(ATTR_CEN_MSS_EFF_VPD_VERSION);
    addData(ATTR_CEN_MSS_NEST_CAPABLE_FREQUENCIES);
    addData(ATTR_MEM_DRAM_CWL);
    addData(ATTR_MEM_RDIMM_BUFFER_DELAY);
    addData(ATTR_MEM_REORDER_QUEUE_SETTING);
    addData(ATTR_MEM_2N_MODE);
    addData(ATTR_MEM_VPD_DQ_MAP);
    addData(ATTR_MEM_DIMM_DDR4_F0RC0F);
    addData(ATTR_MEM_CS_CMD_LATENCY);
    addData(ATTR_MEM_CA_PARITY_LATENCY);
    addData(ATTR_MEM_DIMM_DDR4_F0RC02);
    addData(ATTR_MEM_DIMM_DDR4_F0RC03);
    addData(ATTR_MEM_DIMM_DDR4_F0RC04);
    addData(ATTR_MEM_DIMM_DDR4_F0RC05);
    addData(ATTR_MEM_DIMM_DDR4_F0RC0B);
    addData(ATTR_MEM_DIMM_DDR4_F0RC1X);
    addData(ATTR_MEM_DIMM_DDR4_F0RC7X);
    addData(ATTR_MEM_DIMM_DDR4_F1RC00);
    addData(ATTR_MEM_DIMM_DDR4_F1RC02);
    addData(ATTR_MEM_DIMM_DDR4_F1RC03);
    addData(ATTR_MEM_DIMM_DDR4_F1RC04);
    addData(ATTR_MEM_DIMM_DDR4_F1RC05);
    addData(ATTR_MEM_DIMM_POS_METADATA);
    addData(ATTR_MEM_DRAM_GEN_METADATA);
    addData(ATTR_MEM_DIMM_TYPE_METADATA);
    addData(ATTR_MEM_SI_SIGNATURE_HASH);
    addData(ATTR_MEM_SI_DIMM_RCD_IBT_CA);
    addData(ATTR_MEM_SI_DIMM_RCD_IBT_CKE);
    addData(ATTR_MEM_SI_DIMM_RCD_IBT_CS);
    addData(ATTR_MEM_SI_DIMM_RCD_IBT_ODT);
    addData(ATTR_MEM_SI_DRAM_DRV_IMP_DQ_DQS);
    addData(ATTR_MEM_SI_DRAM_PREAMBLE);
    addData(ATTR_MEM_SI_DRAM_RTT_NOM);
    addData(ATTR_MEM_SI_DRAM_RTT_PARK);
    addData(ATTR_MEM_SI_DRAM_RTT_WR);
    addData(ATTR_MEM_SI_VREF_DQ_TRAIN_VALUE);
    addData(ATTR_MEM_SI_VREF_DQ_TRAIN_RANGE);
    addData(ATTR_MEM_SI_GEARDOWN_MODE);
    addData(ATTR_MEM_SI_MC_DRV_DQ_DQS);
    addData(ATTR_MEM_SI_MC_RCV_EQ_DQ_DQS);
    addData(ATTR_MEM_SI_MC_DRV_EQ_DQ_DQS);
    addData(ATTR_MEM_SI_MC_DRV_IMP_CLK);
    addData(ATTR_MEM_SI_MC_DRV_IMP_CMD_ADDR);
    addData(ATTR_MEM_SI_MC_DRV_IMP_CNTL);
    addData(ATTR_MEM_SI_MC_DRV_IMP_CSCID);
    addData(ATTR_MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_DOWN);
    addData(ATTR_MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_UP);
    addData(ATTR_MEM_SI_MC_DRV_SLEW_RATE_CLK);
    addData(ATTR_MEM_SI_MC_DRV_SLEW_RATE_CMD_ADDR);
    addData(ATTR_MEM_SI_MC_DRV_SLEW_RATE_CNTL);
    addData(ATTR_MEM_SI_MC_DRV_SLEW_RATE_CSCID);
    addData(ATTR_MEM_SI_MC_DRV_SLEW_RATE_DQ_DQS);
    addData(ATTR_MEM_SI_MC_RCV_IMP_ALERT_N);
    addData(ATTR_MEM_SI_MC_RCV_IMP_DQ_DQS);
    addData(ATTR_MEM_SI_ODT_RD);
    addData(ATTR_MEM_SI_ODT_WR);
    addData(ATTR_MEM_SI_VREF_DRAM_WR);
    addData(ATTR_MEM_SI_VREF_MC_RD);
    addData(ATTR_MEM_SI_WINDAGE_RD_CTR);
    addData(ATTR_MEM_EFF_DRAM_GEN);
    addData(ATTR_MEM_EFF_DIMM_TYPE);
    addData(ATTR_MEM_EFF_HYBRID_MEMORY_TYPE);
    addData(ATTR_MEM_EFF_HYBRID);
    addData(ATTR_MEM_EFF_HOST_TO_DDR_SPEED_RATIO);
    addData(ATTR_MEM_EFF_DRAM_DENSITY);
    addData(ATTR_MEM_EFF_DRAM_BANK_BITS);
    addData(ATTR_MEM_EFF_DRAM_BANK_GROUP_BITS);
    addData(ATTR_MEM_EFF_DRAM_COLUMN_BITS);
    addData(ATTR_MEM_EFF_DRAM_ROW_BITS);
    addData(ATTR_MEM_EFF_PRIM_STACK_TYPE);
    addData(ATTR_MEM_EFF_DRAM_PPR);
    addData(ATTR_MEM_EFF_DRAM_SOFT_PPR);
    addData(ATTR_MEM_EFF_DRAM_TRCD);
    addData(ATTR_MEM_EFF_DRAM_TRP);
    addData(ATTR_MEM_EFF_DRAM_TRAS);
    addData(ATTR_MEM_EFF_DRAM_TRC);
    addData(ATTR_MEM_EFF_DRAM_TRFC);
    addData(ATTR_MEM_EFF_DRAM_TFAW);
    addData(ATTR_MEM_EFF_DRAM_TRRD_S);
    addData(ATTR_MEM_EFF_DRAM_TRRD_L);
    addData(ATTR_MEM_EFF_DRAM_TRRD_DLR);
    addData(ATTR_MEM_EFF_DRAM_TCCD_L);
    addData(ATTR_MEM_EFF_DRAM_TWR);
    addData(ATTR_MEM_EFF_DRAM_TWTR_S);
    addData(ATTR_MEM_EFF_DRAM_TWTR_L);
    addData(ATTR_MEM_EFF_DRAM_TMAW);
    addData(ATTR_MEM_EFF_DRAM_WIDTH);
    addData(ATTR_MEM_EFF_NUM_RANKS_PER_DIMM);
    addData(ATTR_MEM_EFF_REGISTER_TYPE);
    addData(ATTR_MEM_EFF_DRAM_MFG_ID);
    addData(ATTR_MEM_EFF_RCD_MFG_ID);
    addData(ATTR_MEM_EFF_REGISTER_REV);
    addData(ATTR_MEM_EFF_PACKAGE_RANK_MAP);
    addData(ATTR_MEM_EFF_NIBBLE_MAP);
    addData(ATTR_MEM_EFF_DIMM_SIZE);
    addData(ATTR_MEM_EFF_DIMM_SPARE);
    addData(ATTR_MEM_EFF_DRAM_CL);
    addData(ATTR_MEM_EFF_NUM_MASTER_RANKS_PER_DIMM);
    addData(ATTR_MEM_EFF_DIMM_RANKS_CONFIGED);
    addData(ATTR_MEM_EFF_DRAM_TREFI);
    addData(ATTR_MEM_EFF_DRAM_TRTP);
    addData(ATTR_MEM_EFF_DRAM_TRFC_DLR);
    addData(ATTR_MEM_EFF_FREQ);
    addData(ATTR_MEM_EFF_VOLT_VDDR);
    addData(ATTR_MEM_EFF_VOLT_VPP);
    addData(ATTR_MEM_EFF_PSTATES);
    addData(ATTR_MEM_EFF_BYTE_ENABLES);
    addData(ATTR_MEM_EFF_NIBBLE_ENABLES);
    addData(ATTR_MEM_EFF_FOUR_RANK_MODE);
    addData(ATTR_MEM_EFF_MRAM_SUPPORT);
    addData(ATTR_MEM_EFF_DDP_COMPATIBILITY);
    addData(ATTR_MEM_EFF_TSV_8H_SUPPORT);
    addData(ATTR_MSS_OCMB_ENTERPRISE_MODE);
    addData(ATTR_MSS_OCMB_NONENTERPRISE_MODE_OVERRIDE);
    addData(ATTR_MSS_OCMB_HALF_DIMM_MODE);
    addData(ATTR_MSS_OCMB_HALF_DIMM_MODE_OVERRIDE);
    addData(ATTR_MSS_MEM_MVPD_FWMS);
    addData(ATTR_MEM_EXP_CS_PRESENT);
    addData(ATTR_MEM_EXP_INIT_VREF_DQ);
    addData(ATTR_MEM_EXP_INIT_PHY_VREF);
    addData(ATTR_MEM_EXP_RCD_DIC);
    addData(ATTR_MEM_EXP_RCD_VOLTAGE_CTRL);
    addData(ATTR_MEM_EXP_DRAM_ADDRESS_MIRRORING);
    addData(ATTR_MEM_EXP_RCD_SLEW_RATE);
    addData(ATTR_MEM_EXP_3DS_HEIGHT);
    addData(ATTR_MEM_EXP_SPD_CL_SUPPORTED);
    addData(ATTR_MEM_EXP_SPD_TAA_MIN);
    addData(ATTR_MEM_EXP_FIRMWARE_EMULATION_MODE);
    addData(ATTR_MSS_OCMB_EXP_STRUCT_MMIO_ENDIAN_CTRL);
    addData(ATTR_MSS_OCMB_EXP_STRUCT_ENDIAN);
    addData(ATTR_MSS_OCMB_ECID);
    addData(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_FW_MODE);
    addData(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_OPENCAPI_LOOPBACK_TEST);
    addData(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_TRANSPORT_LAYER);
    addData(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_DL_LAYER_BOOT_MODE);
    addData(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_BOOT_MODE);
    addData(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_LANE_MODE);
    addData(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_SERDES_FREQUENCY);
    addData(ATTR_ALL_MCS_IN_INTERLEAVING_GROUP);
    addData(ATTR_ATTN_AREA_1_ADDR);
    addData(ATTR_ATTN_AREA_2_ADDR);
    addData(ATTR_BLOCK_SPEC_DECONFIG);
    addData(ATTR_CDM_POLICIES);
    addData(ATTR_CEC_IPL_TYPE);
    addData(ATTR_CEN_MSS_VOLT_AVDD_MILLIVOLTS);
    addData(ATTR_CEN_MSS_VOLT_AVDD_OFFSET_MILLIVOLTS);
    addData(ATTR_CEN_MSS_VOLT_VCS_MILLIVOLTS);
    addData(ATTR_CEN_MSS_VOLT_VCS_OFFSET_MILLIVOLTS);
    addData(ATTR_CEN_MSS_VOLT_VDDR_MILLIVOLTS);
    addData(ATTR_CEN_MSS_VOLT_VDDR_OFFSET_MILLIVOLTS);
    addData(ATTR_CEN_MSS_VOLT_VDD_MILLIVOLTS);
    addData(ATTR_CEN_MSS_VOLT_VDD_OFFSET_MILLIVOLTS);
    addData(ATTR_CEN_MSS_VOLT_VPP_MILLIVOLTS);
    addData(ATTR_CEN_MSS_VOLT_VPP_OFFSET_MILLIVOLTS);
    addData(ATTR_CHIP_ID);
    addData(ATTR_DPO_MIN_FREQ_PERCENT);
    addData(ATTR_DUMMY_RW);
    addData(ATTR_EC);
    addData(ATTR_EFFECTIVE_EC);
    addData(ATTR_ENABLED_THREADS);
    addData(ATTR_FABRIC_TO_PHYSICAL_NODE_MAP);
    addData(ATTR_FIELD_CORE_OVERRIDE);
    addData(ATTR_FREQ_CORE_CEILING_MHZ);
    addData(ATTR_FREQ_CORE_MAX);
    addData(ATTR_FUSED_CORE_MODE_HB);
    addData(ATTR_FUSED_CORE_OPTION);
    addData(ATTR_HB_HRMOR_NODAL_BASE);
    addData(ATTR_HB_SETTINGS);
    addData(ATTR_HDAT_EC);
    addData(ATTR_HDAT_HBRT_NUM_SECTIONS);
    addData(ATTR_HDAT_HBRT_SECTION_SIZE);
    addData(ATTR_HDAT_RSV_MEM_NUM_SECTIONS);
    addData(ATTR_HOMER_PHYS_ADDR);
    addData(ATTR_HOSTSVC_PLID);
    addData(ATTR_HWAS_STATE);
    addData(ATTR_HWAS_STATE_CHANGED_FLAG);
    addData(ATTR_I2C_SWITCHES);
    addData(ATTR_INTP_BASE_ADDR);
    addData(ATTR_ISTEP_MODE);
    addData(ATTR_ISTEP_PAUSE_CONFIG);
    addData(ATTR_ISTEP_PAUSE_ENABLE);
    addData(ATTR_IS_INTER_ENCLOSURE_BUS);
    addData(ATTR_KEY_TRANSITION_STATE);
    addData(ATTR_LPC_BUS_ADDR);
    addData(ATTR_MC_PLL_BUCKET);
    addData(ATTR_MEM_AVDD_OFFSET_MILLIVOLTS);
    addData(ATTR_MEM_BASE);
    addData(ATTR_MEM_VCS_OFFSET_MILLIVOLTS);
    addData(ATTR_MEM_VDDR_OFFSET_MILLIVOLTS);
    addData(ATTR_MEM_VDD_OFFSET_MILLIVOLTS);
    addData(ATTR_MEM_VPP_OFFSET_MILLIVOLTS);
    addData(ATTR_MIN_FREQ_MHZ);
    addData(ATTR_MRW_DDR3_VDDR_MAX_LIMIT_POST_DRAM_INIT);
    addData(ATTR_MRW_DDR4_VDDR_MAX_LIMIT_POST_DRAM_INIT);
    addData(ATTR_MSS_CENT_VCS_INTERCEPT);
    addData(ATTR_MSS_CENT_VCS_SLOPE_ACTIVE);
    addData(ATTR_MSS_CENT_VCS_SLOPE_INACTIVE);
    addData(ATTR_MSS_CENT_VDD_INTERCEPT);
    addData(ATTR_MSS_CENT_VDD_SLOPE_ACTIVE);
    addData(ATTR_MSS_CENT_VDD_SLOPE_INACTIVE);
    addData(ATTR_MSS_DATABUS_UTIL_PER_MBA);
    addData(ATTR_MSS_PHY_SEQ_REFRESH);
    addData(ATTR_MSS_VOLT_AVDD_MILLIVOLTS);
    addData(ATTR_MSS_VOLT_AVDD_OFFSET_MILLIVOLTS);
    addData(ATTR_MSS_VOLT_DDR3_VDDR_INTERCEPT_POST_DRAM_INIT);
    addData(ATTR_MSS_VOLT_DDR3_VDDR_SLOPE_POST_DRAM_INIT);
    addData(ATTR_MSS_VOLT_DDR4_VDDR_INTERCEPT_POST_DRAM_INIT);
    addData(ATTR_MSS_VOLT_DDR4_VDDR_SLOPE_POST_DRAM_INIT);
    addData(ATTR_MSS_VOLT_VCS_MILLIVOLTS);
    addData(ATTR_MSS_VOLT_VCS_OFFSET_MILLIVOLTS);
    addData(ATTR_MSS_VOLT_VDDR_MILLIVOLTS);
    addData(ATTR_MSS_VOLT_VDDR_OFFSET_MILLIVOLTS);
    addData(ATTR_MSS_VOLT_VDD_MILLIVOLTS);
    addData(ATTR_MSS_VOLT_VDD_OFFSET_MILLIVOLTS);
    addData(ATTR_MSS_VOLT_VPP_INTERCEPT_POST_DRAM_INIT);
    addData(ATTR_MSS_VOLT_VPP_MILLIVOLTS);
    addData(ATTR_MSS_VOLT_VPP_OFFSET_MILLIVOLTS);
    addData(ATTR_MSS_VOLT_VPP_SLOPE_POST_DRAM_INIT);
    addData(ATTR_NOMINAL_FREQ_MHZ);
    addData(ATTR_NVDIMM_ARMED);
    addData(ATTR_NV_OPS_TIMEOUT_MSEC);
    addData(ATTR_NV_STATUS_FLAG);
    addData(ATTR_ORDINAL_ID);
    addData(ATTR_PAYLOAD_BASE);
    addData(ATTR_PAYLOAD_ENTRY);
    addData(ATTR_PAYLOAD_IN_MIRROR_MEM);
    addData(ATTR_PAYLOAD_KIND);
    addData(ATTR_PEC_IS_BIFURCATABLE);
    addData(ATTR_PEC_PCIE_HX_KEYWORD_DATA);
    addData(ATTR_PEC_PCIE_IOP_REVERSAL);
    addData(ATTR_PG);
    addData(ATTR_PIB_I2C_NEST_PLL);
    addData(ATTR_PIB_I2C_REFCLOCK);
    addData(ATTR_PLCK_IPL_ATTR_OVERRIDES_EXIST);
    addData(ATTR_PNOR_FLASH_WORKAROUNDS);
    addData(ATTR_PRD_HWP_PLID);
    addData(ATTR_PREVIOUS_WAKEUP_FAIL);
    addData(ATTR_PROC_MASTER_TYPE);
    addData(ATTR_PROC_PCIE_IOP_CONFIG);
    addData(ATTR_PROC_PCIE_IOVALID_ENABLE);
    addData(ATTR_PROC_PCIE_LANE_MASK);
    addData(ATTR_PROC_PCIE_PCS_SYSTEM_CNTL);
    addData(ATTR_PROC_PCIE_PHB_ACTIVE);
    addData(ATTR_PROC_PCIE_REFCLOCK_ENABLE);
    addData(ATTR_PROC_SELECT_BOOT_SEEPROM_IMAGE);
    addData(ATTR_PROC_SELECT_SEEPROM_IMAGE);
    addData(ATTR_PSI_BRIDGE_BASE_ADDR);
    addData(ATTR_PSI_HB_ESB_ADDR);
    addData(ATTR_RAW_MTM);
    addData(ATTR_RCD_PARITY_RECONFIG_LOOP_COUNT);
    addData(ATTR_RECONFIG_LOOP_TESTS);
    addData(ATTR_RECONFIG_LOOP_TESTS_ENABLE);
    addData(ATTR_RISK_LEVEL_ORIGIN);
    addData(ATTR_RUN_MAX_MEM_PATTERNS);
    addData(ATTR_SAVED_STATE_UINT8);
    addData(ATTR_SBE_COMMIT_ID);
    addData(ATTR_SBE_IS_STARTED);
    addData(ATTR_SBE_RELEASE_TAG);
    addData(ATTR_SBE_VERSION_INFO);
    addData(ATTR_SCOM_SWITCHES);
    addData(ATTR_SECUREBOOT_PROTECT_DECONFIGURED_TPM);
    addData(ATTR_SOCKET_POWER_NOMINAL);
    addData(ATTR_SOCKET_POWER_TURBO);
    addData(ATTR_START_MEM_ADDRESS_FOR_PAYLOAD_TCE_TOKEN);
    addData(ATTR_SYNC_BETWEEN_STEPS);
    addData(ATTR_TCE_START_TOKEN_FOR_HDAT);
    addData(ATTR_TCE_START_TOKEN_FOR_PAYLOAD);
    addData(ATTR_TEST_MAX_STRING);
    addData(ATTR_TEST_MIN_STRING);
    addData(ATTR_TEST_NEGATIVE_FCN);
    addData(ATTR_TEST_NO_DEFAULT_STRING);
    addData(ATTR_TEST_NULL_STRING);
    addData(ATTR_TOD_CPU_DATA);
    addData(ATTR_TOD_ROLE);
    addData(ATTR_TPM_POISONED);
    addData(ATTR_TPM_REQUIRED);
    addData(ATTR_TPM_UNUSABLE);
    addData(ATTR_ULTRA_TURBO_FREQ_MHZ);
    addData(ATTR_WOF_POWER_LIMIT);
    addData(ATTR_WOF_TABLE_LID_NUMBER);
    addData(ATTR_XIVE_CONTROLLER_BAR_ADDR);
    addData(ATTR_XIVE_THREAD_MGMT1_BAR_ADDR);
    addData(ATTR_XSCOM_BASE_ADDRESS);
    addData(ATTR_ALLOW_ATTR_OVERRIDES_IN_SECURE_MODE);
    addData(ATTR_ASSUME_SBE_QUIESCED);
    addData(ATTR_ATTN_CHK_ALL_PROCS);
    addData(ATTR_CENTAUR_REGISTER_CACHE_PTR);
    addData(ATTR_CHKSTOP_ANALYSIS_ON_STARTUP);
    addData(ATTR_CLEAR_DIMM_SPD_ENABLE);
    addData(ATTR_DIMM_SPD_BYTE_SIZE);
    addData(ATTR_DRTM_PAYLOAD_ADDR_MB_HB);
    addData(ATTR_EEPROM_PAGE_ARRAY);
    addData(ATTR_HBRT_HYP_ID);
    addData(ATTR_HB_EXISTING_IMAGE);
    addData(ATTR_HB_INITIATED_PM_RESET);
    addData(ATTR_HB_RSV_MEM_NEXT_SECTION);
    addData(ATTR_HB_SBE_SEEPROM_VERSION_MISMATCH);
    addData(ATTR_HB_TARGET_SCOMABLE);
    addData(ATTR_HB_TPM_INIT_ATTEMPTED);
    addData(ATTR_HB_TPM_LOG_MGR_PTR);
    addData(ATTR_HOMER_HCODE_LOADED);
    addData(ATTR_HOMER_VIRT_ADDR);
    addData(ATTR_IBSCOM_VIRTUAL_ADDR);
    addData(ATTR_IPC_NODE_BUFFER_GLOBAL_ADDRESS);
    addData(ATTR_IS_DRTM_MPIPL_HB);
    addData(ATTR_IS_MPIPL_HB);
    addData(ATTR_IS_SLAVE_DRAWER);
    addData(ATTR_MASTER_MBOX_SCRATCH);
    addData(ATTR_MEMD_OFFSET);
    addData(ATTR_MMIO_VM_ADDR);
    addData(ATTR_MPIPL_HB_MDRT_COUNT);
    addData(ATTR_MRW_DDR3_VDDR_MAX_LIMIT_EFF_CONFIG);
    addData(ATTR_MRW_DDR4_VDDR_MAX_LIMIT_EFF_CONFIG);
    addData(ATTR_MSS_VOLT_DDR3_VDDR_INTERCEPT_EFF_CONFIG);
    addData(ATTR_MSS_VOLT_DDR3_VDDR_SLOPE_EFF_CONFIG);
    addData(ATTR_MSS_VOLT_DDR4_VDDR_INTERCEPT_EFF_CONFIG);
    addData(ATTR_MSS_VOLT_DDR4_VDDR_SLOPE_EFF_CONFIG);
    addData(ATTR_MSS_VOLT_VPP_INTERCEPT_EFF_CONFIG);
    addData(ATTR_MSS_VOLT_VPP_SLOPE_EFF_CONFIG);
    addData(ATTR_OCC_COMMON_AREA_PHYS_ADDR);
    addData(ATTR_OVERRIDES_ATTEMPTED_FLAG);
    addData(ATTR_PART_NUMBER);
    addData(ATTR_PDA_CAPTURED_THREAD_REG_ARRAY_ADDR);
    addData(ATTR_PDA_CAPTURED_THREAD_REG_ARRAY_SIZE);
    addData(ATTR_PDA_THREAD_REG_ENTRY_SIZE);
    addData(ATTR_PDA_THREAD_REG_STATE_ENTRY_FORMAT);
    addData(ATTR_SBE_COMM_ADDR);
    addData(ATTR_SBE_FFDC_ADDR);
    addData(ATTR_SERIAL_NUMBER);
    addData(ATTR_SPCWKUP_COUNT);
    addData(ATTR_TPM_ROLE);
    addData(ATTR_VPD_SWITCHES);
    addData(ATTR_WOF_FREQUENCY_UPLIFT_SELECTED);
    addData(ATTR_XSCOM_VIRTUAL_ADDR);
    addData(ATTR_ASCII_VPD_LX_KEYWORD);
    addData(ATTR_CREATE_DEF_PARTITION);
    addData(ATTR_ENLARGED_IO_SLOT_COUNT);
    addData(ATTR_HUGE_PAGE_COUNT);
    addData(ATTR_HUGE_PAGE_SIZE);
    addData(ATTR_HYPERVISOR_IPL_DESTINATION);
    addData(ATTR_HYPERVISOR_IPL_SIDE);
    addData(ATTR_HYP_DISPATCH_WHEEL);
    addData(ATTR_IPL_ATTRIBUTES);
    addData(ATTR_LMB_SIZE);
    addData(ATTR_MAX_HSL_OPTICONNECT_CONNECTIONS);
    addData(ATTR_OS_IPL_MODE);
    addData(ATTR_PHYP_SYSTEM_TYPE);
    addData(ATTR_PRESERVE_MDC_PARTITION_VPD);
    addData(ATTR_SLCA_INDEX);
    addData(ATTR_SLCA_RID);
    addData(ATTR_SYSTEM_BRAND_NAME);
    addData(ATTR_VLAN_SWITCHES);
    addData(ATTR_VTPM_ENABLED);
    addData(ATTR_CALCULATED_MAX_SYS_POWER_EXCLUDING_GPUS);
    addData(ATTR_CALCULATED_PROC_MEMORY_POWER_DROP);
    addData(ATTR_CUMULATIVE_PMCOMPLEX_RESET_COUNT);
    addData(ATTR_HTMGT_INTERNAL_FLAGS);
    addData(ATTR_HTMGT_PMCOMPLEX_RESET_COUNT_TIMER);
    addData(ATTR_HTMGT_SAFEMODE);
    addData(ATTR_HTMGT_SAVED_POWER_LIMIT);
    addData(ATTR_IPMI_MAX_BUFFER_SIZE);
    addData(ATTR_MSS_UTIL_N_PER_MBA);
    addData(ATTR_N_PLUS_ONE_MEM_POWER);
    addData(ATTR_N_PLUS_ONE_N_PER_CHIP);
    addData(ATTR_N_PLUS_ONE_N_PER_MBA);
    addData(ATTR_OCC_CONTROL_DATA);
    addData(ATTR_OP_TRACE_LITE);
    addData(ATTR_OT_MEM_POWER);
    addData(ATTR_OT_MIN_N_PER_MBA);
    addData(ATTR_POWERCAP_MEM_POWER);
    addData(ATTR_POWERCAP_N_PER_CHIP);
    addData(ATTR_POWERCAP_N_PER_MBA);
}

//------------------------------------------------------------------------------
ErrlUserDetailsAttribute::~ErrlUserDetailsAttribute()
{ }
} // namespace
